<?php


class ImAlmacenModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_almacen
			WHERE alm_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_almacen["alm_id"]			= $row["alm_id"];
		$a_almacen["alm_nombre"]		= $row["alm_nombre"];
		$a_almacen["alm_idRef"]			= $row["alm_idRef"];
		$a_almacen["alm_tipo"]			= $row["alm_tipo"];
		$a_almacen["alm_subInvenTipo"]	= $row["alm_subInvenTipo"];
		$a_almacen["alm_org_inv"]		= $row["alm_org_inv"];
		$a_almacen["alm_org_inv_gl"]	= $row["alm_org_inv_gl"];
		$a_almacen["alm_so"]			= $row["alm_so"];
		$a_almacen["alm_po"]			= $row["alm_po"];
		$a_almacen["alm_direcc1"]		= $row["alm_direcc1"];
		$a_almacen["alm_direcc2"]		= $row["alm_direcc2"];
		$a_almacen["alm_ciudad"]		= $row["alm_ciudad"];
		$a_almacen["alm_estado"]		= $row["alm_estado"];
		$a_almacen["alm_logico"]		= $row["alm_logico"];		
		$a_almacen["alm_agingMax"]		= $row["alm_agingMax"];
		$a_almacen["alm_contab"]		= $row["alm_contab"];
		$a_almacen["alm_status"]		= $row["alm_status"];
		$a_almacen["alm_usract"]		= $row["alm_usract"];
		$a_almacen["alm_fecact"]		= $row["alm_fecact"];
		return $a_almacen;
	}


	public function select($AlmacenObj,$limit=''){
		global $usuario, $PDO;
		if ($AlmacenObj->alm_id){
			$where .= " AND alm_id = :alm_id";
		}
		if ($AlmacenObj->alm_idRef){
			$where .= " AND alm_idRef = :alm_idRef";
		}else{
			$where .= " AND alm_idRef <> 0";
		}
		if ($AlmacenObj->alm_nombre){
			$where .= " AND alm_nombre LIKE :alm_nombre";
		}
		if ($AlmacenObj->alm_prestInt){
			$where .= " AND alm_prestInt NOT LIKE ''";
		}
		if ($AlmacenObj->alm_RMA){
			$where .= " AND alm_rma NOT LIKE ''";
		}
		if ($AlmacenObj->alm_consignacion){
			$where .= " AND alm_consignacion NOT LIKE ''";
		}
		if ($AlmacenObj->alm_po){
			$where .= " AND alm_po <> ''";
		}
		if ($AlmacenObj->alm_status){
			$where .= " AND alm_status = :alm_status";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($AlmacenObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY alm_nombre";
		}
		$sql = "
			SELECT *
			FROM im_almacen 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($AlmacenObj->alm_id){
			$comando->bindParam(':alm_id', $AlmacenObj->alm_id);
		}
		if ($AlmacenObj->alm_idRef){
			$comando->bindParam(':alm_idRef', $AlmacenObj->alm_idRef);
		}
		if ($AlmacenObj->alm_nombre){
			$comando->bindParam(':alm_nombre', $AlmacenObj->alm_nombre);
		}
		if ($AlmacenObj->alm_status){
			$comando->bindParam(':alm_status', $AlmacenObj->alm_status);
		}
		if ($AlmacenObj->orderBy){
			$comando->bindParam(':orderBy', $AlmacenObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_almacen["alm_id"]			= $row["alm_id"];
			$a_almacen["alm_nombre"]		= $row["alm_nombre"];
			$a_almacen["alm_idRef"]			= $row["alm_idRef"];
			$a_almacen["alm_tipo"]			= $row["alm_tipo"];
			$a_almacen["alm_subInvenTipo"]	= $row["alm_subInvenTipo"];
			$a_almacen["alm_org_inv"]		= $row["alm_org_inv"];
			$a_almacen["alm_org_inv_gl"]	= $row["alm_org_inv_gl"];
			$a_almacen["alm_so"]			= $row["alm_so"];
			$a_almacen["alm_po"]			= $row["alm_po"];
			$a_almacen["alm_direcc1"]		= $row["alm_direcc1"];
			$a_almacen["alm_direcc2"]		= $row["alm_direcc2"];
			$a_almacen["alm_ciudad"]		= $row["alm_ciudad"];
			$a_almacen["alm_estado"]		= $row["alm_estado"];
			$a_almacen["alm_logico"]		= $row["alm_logico"];		
			$a_almacen["alm_agingMax"]		= $row["alm_agingMax"];
			$a_almacen["alm_contab"]		= $row["alm_contab"];
			$a_almacen["alm_prestInt"]		= $row["alm_prestInt"];
			$a_almacen["alm_status"]		= $row["alm_status"];
			$a_almacen["alm_usract"]		= $row["alm_usract"];
			$a_almacen["alm_fecact"]		= $row["alm_fecact"];
			$a_almacenList["listaPag"][] = $a_almacen;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_almacenList["total"] = $rowTotal["total"];
		return $a_almacenList;

	}


	public function update($AlmacenObj){
		global $usuario, $PDO;
		if ($AlmacenObj->alm_nombre){
			$set .= ", alm_nombre = :alm_nombre";
		}
		if ($AlmacenObj->alm_idRef){
			$set .= ", alm_idRef = :alm_idRef";
		}
		if ($AlmacenObj->alm_so){
			$set .= ", alm_so = :alm_so";
		}
		if ($AlmacenObj->alm_po){
			$set .= ", alm_po = :alm_po";
		}
		if ($AlmacenObj->alm_direcc1){
			$set .= ", alm_direcc1 = :alm_direcc1";
		}
		if ($AlmacenObj->alm_direcc2){
			$set .= ", alm_direcc2 = :alm_direcc2";
		}
		if ($AlmacenObj->alm_ciudad){
			$set .= ", alm_ciudad = :alm_ciudad";
		}
		if ($AlmacenObj->alm_estado){
			$set .= ", alm_estado = :alm_estado";
		}
		if ($AlmacenObj->alm_logico){
			$set .= ", alm_logico = :alm_logico";
		}
		if ($AlmacenObj->alm_agingMax){
			$set .= ", alm_agingMax = :alm_agingMax";
		}
		if ($AlmacenObj->alm_contab){
			$set .= ", alm_contab = :alm_contab";
		}
		if ($AlmacenObj->alm_kdxGL){
			//$set .= ", alm_kdxGL = :alm_kdxGL";
		}
		if ($AlmacenObj->alm_status){
			$set .= ", alm_status = :alm_status";
		}
		if ($set && $AlmacenObj->alm_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_almacen
				SET 
					$set
					,alm_usract = :alm_usract
				WHERE alm_id = :alm_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':alm_id', $AlmacenObj->alm_id);
			if ($AlmacenObj->alm_nombre){
				$comando->bindParam(':alm_nombre', $AlmacenObj->alm_nombre);
			}
			if ($AlmacenObj->alm_idRef){
				$comando->bindParam(':alm_idRef', $AlmacenObj->alm_idRef);
			}
			if ($AlmacenObj->alm_so){
				$comando->bindParam(':alm_so', $AlmacenObj->alm_so);
			}
			if ($AlmacenObj->alm_po){
				$comando->bindParam(':alm_po', $AlmacenObj->alm_po);
			}
			if ($AlmacenObj->alm_direcc1){
				$comando->bindParam(':alm_direcc1', $AlmacenObj->alm_direcc1);
			}
			if ($AlmacenObj->alm_direcc2){
				$comando->bindParam(':alm_direcc2', $AlmacenObj->alm_direcc2);
			}
			if ($AlmacenObj->alm_ciudad){
				$comando->bindParam(':alm_ciudad', $AlmacenObj->alm_ciudad);
			}
			if ($AlmacenObj->alm_estado){
				$comando->bindParam(':alm_estado', $AlmacenObj->alm_estado);
			}
			if ($AlmacenObj->alm_logico){
				$comando->bindParam(':alm_logico', $AlmacenObj->alm_logico);
			}
			if ($AlmacenObj->alm_agingMax){
				$comando->bindParam(':alm_agingMax', $AlmacenObj->alm_agingMax);
			}
			if ($AlmacenObj->alm_contab){
				$comando->bindParam(':alm_contab', $AlmacenObj->alm_contab);
			}
			if ($AlmacenObj->alm_kdxGL){
				//$comando->bindParam(':alm_kdxGL', $AlmacenObj->alm_kdxGL);
			}
			if ($AlmacenObj->alm_status){
				$comando->bindParam(':alm_status', $AlmacenObj->alm_status);
			}
			$comando->bindParam(':alm_usract', $usuario);
			$comando->execute();
			//print_r($comando->errorInfo());
			return $AlmacenObj->alm_id;
		}
	}

	public function insert($AlmacenObj){
		global $PDO;
		$sql = "
			INSERT INTO im_almacen 
			(
			alm_nombre, 
			alm_idRef,
			alm_tipo,
			alm_subInvenTipo,
			alm_org_inv,
			alm_org_inv_gl,
			alm_so,
			alm_po,
			alm_direcc1,
			alm_direcc2,
			alm_ciudad,
			alm_estado,
			alm_logico,
			alm_agingMax,
			alm_status, 
			alm_usract, 
			alm_fecact
			) 
			VALUES 
			(
			:alm_nombre, 
			:alm_idRef,
			:alm_tipo,
			:alm_subInvenTipo,
			:alm_org_inv,
			:alm_org_inv_gl,
			:alm_so,
			:alm_po,
			:alm_direcc1,
			:alm_direcc2,
			:alm_ciudad,
			:alm_estado,
			:alm_logico,
			:alm_agingMax,
			:alm_status, 
			:alm_usract,
			:alm_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':alm_nombre', $AlmacenObj->alm_nombre);
		$comando->bindParam(':alm_idRef', $AlmacenObj->alm_idRef);
		$comando->bindParam(':alm_tipo', $AlmacenObj->alm_tipo);
		$comando->bindParam(':alm_subInvenTipo', $AlmacenObj->alm_subInvenTipo);
		$comando->bindParam(':alm_org_inv', $AlmacenObj->alm_org_inv);
		$comando->bindParam(':alm_org_inv_gl', $AlmacenObj->alm_org_inv_gl);
		$comando->bindParam(':alm_so', $AlmacenObj->alm_so);
		$comando->bindParam(':alm_po', $AlmacenObj->alm_po);
		$comando->bindParam(':alm_direcc1', $AlmacenObj->alm_direcc1);
		$comando->bindParam(':alm_direcc2', $AlmacenObj->alm_direcc2);
		$comando->bindParam(':alm_estado', $AlmacenObj->alm_estado);
		$comando->bindParam(':alm_logico', $AlmacenObj->alm_logico);
		$comando->bindParam(':alm_agingMax', $AlmacenObj->alm_agingMax);	
		$comando->bindParam(':alm_status', $AlmacenObj->alm_status);
		$comando->bindParam(':alm_usract', $AlmacenObj->alm_usract);
		$comando->bindParam(':alm_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(alm_id) as id 
			FROM `im_almacen` 
			WHERE alm_usract = :alm_usract 
				AND alm_fecact = :alm_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':alm_usract', $AlmacenObj->alm_usract);
		$comando->bindParam(':alm_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

	public function selectMov($almacenId, $movTipo){
		global $PDO;
		$sql = "
			SELECT *
			FROM im_almacen_movTipo
			WHERE almv_alm_id = $almacenId
			AND almv_movTipo = '".$movTipo."'
		";
		$sentenciaMov = $PDO->query($sql);
		$sentenciaMov->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentenciaMov->fetch();
		if ($row["almv_id"]){
			return TRUE;
		}else{
			return FALSE;	
		}
	}

}


?>