<?php


class ImFamiliaModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_familia
			WHERE fm_familiaId = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_familia["fm_familiaId"]	= $row["fm_familiaId"];
		$a_familia["fm_nombre"]		= $row["fm_nombre"];
		$a_familia["fm_glAccount"]	= $row["fm_glAccount"];
		$a_familia["fm_status"]		= $row["fm_status"];
		$a_familia["fm_usract"]		= $row["fm_usract"];
		$a_familia["fm_fecact"]		= $row["fm_fecact"];
		return $a_familia;
	}


	public function select($FamiliaObj,$limit=''){
		global $usuario, $PDO;
		if ($FamiliaObj->fm_familiaId){
			$where .= "AND fm_familiaId = :fm_familiaId";
		}
		if ($FamiliaObj->fm_nombre){
			$where .= "AND fm_nombre LIKE :fm_nombre";
		}
		if ($FamiliaObj->fm_status){
			$where .= "AND fm_status = :fm_status";
		}
		if (!$FamiliaObj->inc_inativo){
			$where .= "AND fm_status <> 'I'";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($FamiliaObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY fm_nombre";
		}
		$sql = "
			SELECT *
			FROM im_familia 
			WHERE 1 $where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($FamiliaObj->fm_familiaId){
			$comando->bindParam(':fm_familiaId', $FamiliaObj->fm_familiaId);
		}
		if ($FamiliaObj->fm_nombre){
			$comando->bindParam(':fm_nombre', $FamiliaObj->fm_nombre);
		}
		if ($FamiliaObj->fm_status){
			$comando->bindParam(':fm_status', $FamiliaObj->fm_status);
		}
		if ($FamiliaObj->orderBy){
			$comando->bindParam(':orderBy', $FamiliaObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_familia["fm_familiaId"]	= $row["fm_familiaId"];
			$a_familia["fm_nombre"]		= $row["fm_nombre"];
			$a_familia["fm_glAccount"]	= $row["fm_glAccount"];
			$a_familia["fm_status"]		= $row["fm_status"];
			$a_familia["fm_usract"]		= $row["fm_usract"];
			$a_familia["fm_fecact"]		= $row["fm_fecact"];
			$a_familiaList["listaPag"][] = $a_familia;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_familiaList["total"] = $rowTotal["total"];
		return $a_familiaList;

	}


	public function update($FamiliaObj){
		global $usuario, $PDO;
		$set .= ", fm_nombre = :fm_nombre";
		$set .= ", fm_glAccount = :fm_glAccount";
		$set .= ", fm_status = :fm_status";
		if ($set && $FamiliaObj->fm_familiaId){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_familia
				SET 
					$set
					,fm_usract = :fm_usract
				WHERE fm_familiaId = :fm_familiaId
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':fm_familiaId', $FamiliaObj->fm_familiaId);
			$comando->bindParam(':fm_nombre', $FamiliaObj->fm_nombre);
			$comando->bindParam(':fm_glAccount', $FamiliaObj->fm_glAccount);
			$comando->bindParam(':fm_status', $FamiliaObj->fm_status);
			$comando->bindParam(':fm_usract', $usuario);
			$comando->execute();
			return $FamiliaObj->fm_familiaId;
		}
	}


	public function insert($FamiliaObj){
		global $PDO;
		$sql = "
			INSERT INTO im_familia 
			(
			fm_nombre, 
			fm_glAccount,
			fm_status, 
			fm_usract, 
			fm_fecact
			) 
			VALUES 
			(
			:fm_nombre, 
			:fm_glAccount,
			:fm_status, 
			:fm_usract,
			:fm_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':fm_nombre', $FamiliaObj->fm_nombre);
		$comando->bindParam(':fm_glAccount', $FamiliaObj->fm_glAccount);
		$comando->bindParam(':fm_status', $FamiliaObj->fm_status);
		$comando->bindParam(':fm_usract', $FamiliaObj->fm_usract);
		$comando->bindParam(':fm_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(fm_familiaId) as id 
			FROM `im_familia` 
			WHERE fm_usract = :fm_usract 
				AND fm_fecact = :fm_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':fm_usract', $FamiliaObj->fm_usract);
		$comando->bindParam(':fm_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>