<?php


class ImIngresoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM im_ingreso
				LEFT JOIN po_proveedor ON ing_prv_id = prv_id 
				LEFT JOIN im_almacen ON ing_almacenId = alm_id 
				LEFT JOIN im_lote ON ing_loteId = lt_id 
				LEFT JOIN xx_maestrolista MSTAT ON ing_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'imIngStatus'
				LEFT JOIN xx_maestrolista MTIPO ON ing_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'imIngTipo'
			WHERE ing_id = :id
		";					
		//--				LEFT JOIN xx_maestrolista ON ing_status = mlst_valorId AND mlst_listaId = 'imIngStatus'
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_recepcion["ing_id"]			= $row["ing_id"];
		$a_recepcion["ing_tipo"]		= $row["ing_tipo"];
		$a_recepcion["ing_fecha"]		= $row["ing_fecha"];
		$a_recepcion["ing_fechaDoc"]	= $row["ing_fechaDoc"];
		$a_recepcion["ing_prv_id"]		= $row["ing_prv_id"];
		$a_recepcion["ing_prv_id2"]		= $row["ing_prv_id2"];
		$a_recepcion["ing_prv_nombre"]	= $row["ing_prv_nombre"];
		$a_recepcion["ing_prv_nombre2"]	= $row["ing_prv_nombre2"];
		$a_recepcion["ing_prv_tipo2"]	= $row["ing_prv_tipo2"];
		$a_recepcion["ing_almacenId"]	= $row["ing_almacenId"];
		$a_recepcion["ing_loteId"]		= $row["ing_loteId"];
		$a_recepcion["ing_refDocTipo"]	= $row["ing_refDocTipo"];
		$a_recepcion["ing_refDocId"]	= $row["ing_refDocId"];
		$a_recepcion["ing_refDocTipo2"]	= $row["ing_refDocTipo2"];
		$a_recepcion["ing_refDocId2"]	= $row["ing_refDocId2"];
		$a_recepcion["ing_tipoCambio"]	= $row["ing_tipoCambio"];
		$a_recepcion["ing_moneda"]		= $row["ing_moneda"];
		$a_recepcion["ing_glosa"]		= $row["ing_glosa"];
		$a_recepcion["ing_obs"]			= $row["ing_obs"];
		$a_recepcion["ing_2_sal_id"]	= $row["ing_2_sal_id"];
		$a_recepcion["ing_pdte_regulariza"]	= $row["ing_pdte_regulariza"];
		
		$a_recepcion["ing_status"]		= $row["ing_status"];
		$a_recepcion["ing_usrreg"]		= $row["ing_usrreg"];
		$a_recepcion["ing_usract"]		= $row["ing_usract"];
		$a_recepcion["ing_fecreg"]		= $row["ing_fecreg"];
		$a_recepcion["ing_fecact"]		= $row["ing_fecact"];
		if (!$row["ing_prv_nombre"]){
			$a_recepcion["ing_prv_nombre"] = $row["prv_nombre"];
		}else{
			$a_recepcion["ing_prv_nombre"] = $row["ing_prv_nombre"];
		}
		$a_recepcion["alm_nombre"]		= $row["alm_nombre"];
		$a_recepcion["lt_nombre"]		= $row["lt_nombre"];		
		//$a_recepcion["ing_status_nombre"] = $row["mlst_valorDsc"];
		$a_recepcion["ing_status_nombre"] = $row["status_nombre"];
		$a_recepcion["ing_tipo_nombre"] = $row["tipo_nombre"];
		return $a_recepcion;
	}

	public function select($IngresoObj,$limit=''){
		global $usuario, $PDO;
		if ($IngresoObj->ing_id){
			$where .= " AND ing_id = :ing_id";
		}
		if ($IngresoObj->ing_tipo){
			$where .= " AND ing_tipo = :ing_tipo";
		}
		if ($IngresoObj->ing_almacenId){
			$where .= " AND ing_almacenId = :ing_almacenId";
		}
		if ($IngresoObj->ing_loteId){
			$where .= " AND ing_loteId = :ing_loteId";
		}
		if ($IngresoObj->fechaIni){
			$where .= " AND ing_fecha >= :fechaIni";
		}
		if ($IngresoObj->fechaFin){
			$where .= " AND ing_fecha <= :fechaFin";
		}
		if ($IngresoObj->ing_prv_id){
			$where .= " AND ing_prv_id = :ing_prv_id";
		}
		if ($IngresoObj->ing_refDocTipo){
			$where .= " AND ing_refDocTipo = :ing_refDocTipo";
		}
		if ($IngresoObj->ing_refDocId){
			$where .= " AND ing_refDocId = :ing_refDocId";
		}
		if ($IngresoObj->ing_status=='*'){
			$where .= " AND ing_status = ''";
		}elseif ($IngresoObj->ing_status){
			$where .= " AND ing_status = '".$IngresoObj->ing_status."'";
		}
		if ($IngresoObj->pr_id){
			$where .= " AND ingl_prId = :pr_id";
//			$join .= " LEFT JOIN im_ingresolinea ON ing_id = ingl_id";
		}
		if ($IngresoObj->pr_familiaId){
			$where .= " AND pr_familiaId = :pr_familiaId";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}

		if ($IngresoObj->orderBy){
			$orderBy = " ORDER BY ".$IngresoObj->orderBy;
		}else{
			$orderBy = " ORDER BY ing_fecha, ing_id";
		}

		$sql = "
			SELECT *
			FROM im_ingreso
				LEFT JOIN po_proveedor ON ing_prv_id = prv_id 
				LEFT JOIN im_ingresolinea ON ing_id = ingl_id
				LEFT JOIN im_producto ON ingl_prId = pr_id
				LEFT JOIN im_almacen ON ing_almacenId = alm_id 
				$join
			WHERE 1 $where
			GROUP BY ing_id
			$orderBy
			$limit
		";		
		$comando = $PDO->prepare($sql);
		if ($IngresoObj->ing_id){
			$comando->bindParam(':ing_id', $IngresoObj->ing_id);
		}
		if ($IngresoObj->ing_tipo){
			$comando->bindParam(':ing_tipo', $IngresoObj->ing_tipo);
		}
		if ($IngresoObj->fechaIni){
			$comando->bindParam(':fechaIni', $IngresoObj->fechaIni);
		}
		if ($IngresoObj->fechaFin){
			$comando->bindParam(':fechaFin', $IngresoObj->fechaFin);
		}
		if ($IngresoObj->ing_almacenId){
			$comando->bindParam(':ing_almacenId', $IngresoObj->ing_almacenId);
		}
		if ($IngresoObj->ing_loteId){
			$comando->bindParam(':ing_loteId', $IngresoObj->ing_loteId);
		}
		if ($IngresoObj->pr_id){
			$comando->bindParam(':pr_id', $IngresoObj->pr_id);
		}
		if ($IngresoObj->pr_familiaId){
			$comando->bindParam(':pr_familiaId', $IngresoObj->pr_familiaId);
		}
		
		$comando->execute();
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_ingreso["ing_id"]			= $row["ing_id"];
			$a_ingreso["ing_tipo"]			= $row["ing_tipo"];
			$a_ingreso["ing_almacenId"]		= $row["ing_almacenId"];
			$a_ingreso["ing_loteId"]		= $row["ing_loteId"];
			$a_ingreso["ing_fecha"]			= $row["ing_fecha"];
			$a_ingreso["ing_fechaDoc"]		= $row["ing_fechaDoc"];
			$a_ingreso["ing_prv_id"]		= $row["ing_prv_id"];
			$a_ingreso["ing_prv_id2"]		= $row["ing_prv_id2"];
			$a_ingreso["ing_prv_nombre"]	= $row["ing_prv_nombre"];
			$a_ingreso["ing_prv_nombre2"]	= $row["ing_prv_nombre2"];
			$a_ingreso["ing_prv_tipo2"]		= $row["ing_prv_tipo2"];
			$a_ingreso["ing_refDocTipo"]	= $row["ing_refDocTipo"];
			$a_ingreso["ing_refDocId"]		= $row["ing_refDocId"];
			$a_ingreso["ing_refDocTipo2"]	= $row["ing_refDocTipo2"];
			$a_ingreso["ing_refDocId2"]		= $row["ing_refDocId2"];
			$a_ingreso["ing_tipoCambio"]	= $row["ing_tipoCambio"];
			$a_ingreso["ing_moneda"]		= $row["ing_moneda"];
			$a_ingreso["ing_glosa"]			= $row["ing_glosa"];
			$a_ingreso["ing_obs"]			= $row["ing_obs"];
			$a_ingreso["ing_pdte_regulariza"]			= $row["ing_pdte_regulariza"];
			$a_ingreso["ing_status"]		= $row["ing_status"];
			$a_ingreso["ing_usrreg"]		= $row["ing_usrreg"];
			$a_ingreso["ing_usract"]		= $row["ing_usract"];
			$a_ingreso["ing_fecreg"]		= $row["ing_fecreg"];
			$a_ingreso["ing_fecact"]		= $row["ing_fecact"];
			if (!$row["ing_prv_nombre"]){
				$a_ingreso["ing_prv_nombre"] = $row["prv_nombre"];
			}else{
				$a_ingreso["ing_prv_nombre"] = $row["ing_prv_nombre"];
			}
			$a_ingreso["alm_nombre"]		= $row["alm_nombre"];
			$a_ingreso["lt_nombre"]			= $row["lt_nombre"];	
			$a_ingresoList[]				= $a_ingreso;
		}
		return $a_ingresoList;

	}


	public function update($IngresoObj){
		global $usuario, $PDO;
		if ($IngresoObj->ing_tipo){
			$set .= ",ing_tipo = :ing_tipo";
		}
		if ($IngresoObj->ing_fecha){
			$set .= ",ing_fecha = :ing_fecha";
		}
		if ($IngresoObj->ing_fechaDoc){
			$set .= ",ing_fechaDoc = :ing_fechaDoc";
		}
		if ($IngresoObj->ing_prv_id){
			$set .= ",ing_prv_id = :ing_prv_id";
		}
		if ($IngresoObj->ing_prv_id2){
			$set .= ",ing_prv_id2 = :ing_prv_id2";
		}
		if ($IngresoObj->ing_prv_nombre){
			$set .= ",ing_prv_nombre = :ing_prv_nombre";
		}
		if ($IngresoObj->ing_prv_nombre2){
			$set .= ",ing_prv_nombre2 = :ing_prv_nombre2";
		}
		if ($IngresoObj->ing_prv_tipo2){
			$set .= ",ing_prv_tipo2 = :ing_prv_tipo2";
		}
		if ($IngresoObj->ing_almacenId){
			$set .= ",ing_almacenId = :ing_almacenId";
		}
		if ($IngresoObj->ing_loteId){
			$set .= ",ing_loteId = :ing_loteId";
		}
		if ($IngresoObj->ing_refDocTipo){
			$set .= ",ing_refDocTipo = :ing_refDocTipo";
		}
		if ($IngresoObj->ing_refDocId){
			$set .= ",ing_refDocId = :ing_refDocId";
		}
		if ($IngresoObj->ing_refDocTipo2){
			$set .= ",ing_refDocTipo2 = :ing_refDocTipo2";
		}
		if ($IngresoObj->ing_refDocId2){
			$set .= ",ing_refDocId2 = :ing_refDocId2";
		}
		if ($IngresoObj->ing_glosa){
			$set .= ",ing_glosa = :ing_glosa";
		}
		if ($IngresoObj->ing_tipoCambio){
			$set .= ",ing_tipoCambio = :ing_tipoCambio";
		}
		if ($IngresoObj->ing_moneda){
			$set .= ",ing_moneda = :ing_moneda";
		}
		if ($IngresoObj->ing_obs){
			$set .= ",ing_obs = :ing_obs";
		}
		if ($IngresoObj->ing_2_sal_id){
			$set .= ",ing_2_sal_id = :ing_2_sal_id";
		}
		if ($IngresoObj->ing_pdte_regulariza){
			$set .= ",ing_pdte_regulariza = :ing_pdte_regulariza";
		}

		
		if ($IngresoObj->ing_status){
			$set .= ",ing_status = :ing_status";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_ingreso
				SET 
					$set
					,ing_usract = :usract
				WHERE ing_id = :ing_id
				AND ing_status <> 'C'
				LIMIT 1";	
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':ing_id', $IngresoObj->ing_id);
			$comando->bindParam(':usract', $usuario);
			if ($IngresoObj->ing_tipo){
				$comando->bindParam(':ing_tipo', $IngresoObj->ing_tipo);
			}
			if ($IngresoObj->ing_fecha){
				$comando->bindParam(':ing_fecha', $IngresoObj->ing_fecha);
			}
			if ($IngresoObj->ing_fechaDoc){
				$comando->bindParam(':ing_fechaDoc', $IngresoObj->ing_fechaDoc);
			}
			if ($IngresoObj->ing_prv_id){
				$comando->bindParam(':ing_prv_id', $IngresoObj->ing_prv_id);
			}
			if ($IngresoObj->ing_prv_id2){
				$comando->bindParam(':ing_prv_id2', $IngresoObj->ing_prv_id2);
			}
			if ($IngresoObj->ing_prv_nombre){
				$comando->bindParam(':ing_prv_nombre', $IngresoObj->ing_prv_nombre);
			}
			if ($IngresoObj->ing_prv_nombre2){
				$comando->bindParam(':ing_prv_nombre2', $IngresoObj->ing_prv_nombre2);
			}
			if ($IngresoObj->ing_prv_tipo2){
				$comando->bindParam(':ing_prv_tipo2', $IngresoObj->ing_prv_tipo2);
			}
			if ($IngresoObj->ing_almacenId){
				$comando->bindParam(':ing_almacenId', $IngresoObj->ing_almacenId);
			}
			if ($IngresoObj->ing_loteId){
				$comando->bindParam(':ing_loteId', $IngresoObj->ing_loteId);
			}
			if ($IngresoObj->ing_refDocTipo){
				$comando->bindParam(':ing_refDocTipo', $IngresoObj->ing_refDocTipo);
			}
			if ($IngresoObj->ing_refDocId){
				$comando->bindParam(':ing_refDocId', $IngresoObj->ing_refDocId);
			}
			if ($IngresoObj->ing_refDocTipo2){
				$comando->bindParam(':ing_refDocTipo2', $IngresoObj->ing_refDocTipo2);
			}
			if ($IngresoObj->ing_refDocId2){
				$comando->bindParam(':ing_refDocId2', $IngresoObj->ing_refDocId2);
			}
			if ($IngresoObj->ing_tipoCambio){
				$comando->bindParam(':ing_tipoCambio', $IngresoObj->ing_tipoCambio);
			}
			if ($IngresoObj->ing_moneda){
				$comando->bindParam(':ing_moneda', $IngresoObj->ing_moneda);
			}
			if ($IngresoObj->ing_glosa){
				$comando->bindParam(':ing_glosa', $IngresoObj->ing_glosa);
			}
			if ($IngresoObj->ing_obs){
				$comando->bindParam(':ing_obs', $IngresoObj->ing_obs);
			}
			if ($IngresoObj->ing_2_sal_id){
				$comando->bindParam(':ing_2_sal_id', $IngresoObj->ing_2_sal_id);
			}
			if ($IngresoObj->ing_pdte_regulariza){
				$comando->bindParam(':ing_pdte_regulariza', $IngresoObj->ing_pdte_regulariza);
			}
			if ($IngresoObj->ing_status){
				$comando->bindParam(':ing_status', $IngresoObj->ing_status);
			}
			$comando->execute();
			return $IngresoObj->ing_id;
		}
	}


	public function insert($IngresoObj){
		global $usuario,$PDO;
		if (!$IngresoObj->ing_pdte_regulariza){
			$IngresoObj->ing_pdte_regulariza = '';
		}
		$sql = "
			INSERT INTO `im_ingreso` 
			(
			ing_tipo, 
			ing_fecha,
			ing_fechaDoc,
			ing_prv_id,
			ing_prv_id2,
			ing_prv_nombre,
			ing_prv_nombre2,			
			ing_prv_tipo2,			
			ing_almacenId, 
			ing_loteId, 
			ing_refDocTipo, 
			ing_refDocId, 
			ing_refDocTipo2, 
			ing_refDocId2,
			ing_tipoCambio,
			ing_moneda,
			ing_glosa, 			
			ing_obs,
			ing_pdte_regulariza,
			ing_status, 
			ing_usrreg,
			ing_fecreg
			) 
			VALUES 
			(
			:ing_tipo,
			:ing_fecha,
			:ing_fechaDoc,
			:ing_prv_id,
			:ing_prv_id2,
			:ing_prv_nombre,
			:ing_prv_nombre2,
			:ing_prv_tipo2,			
			:ing_almacenId,
			:ing_loteId,
			:ing_refDocTipo, 
			:ing_refDocId, 
			:ing_refDocTipo2, 
			:ing_refDocId2,
			:ing_tipoCambio,
			:ing_moneda,
			:ing_glosa, 
			:ing_obs, 
			:ing_pdte_regulariza,
			:ing_status, 
			:usrreg,
			:fecreg
			);			
		";
		if (!$IngresoObj->ing_prv_id2){
			$IngresoObj->ing_prv_id2 = '';
		}
		if (!$IngresoObj->ing_prv_nombre2){
			$IngresoObj->ing_prv_nombre2 = '';
		}
		if (!$IngresoObj->ing_prv_tipo2){
			$IngresoObj->ing_prv_tipo2 = '';
		}
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':ing_tipo', $IngresoObj->ing_tipo);
		$comando->bindParam(':ing_fecha', $IngresoObj->ing_fecha);
		$comando->bindParam(':ing_fechaDoc', $IngresoObj->ing_fechaDoc);
		$comando->bindParam(':ing_prv_id', $IngresoObj->ing_prv_id);
		$comando->bindParam(':ing_prv_id2', $IngresoObj->ing_prv_id2);
		$comando->bindParam(':ing_prv_nombre', $IngresoObj->ing_prv_nombre);
		$comando->bindParam(':ing_prv_nombre2', $IngresoObj->ing_prv_nombre2);
		$comando->bindParam(':ing_prv_tipo2', $IngresoObj->ing_prv_tipo2);
		$comando->bindParam(':ing_almacenId', $IngresoObj->ing_almacenId);
		$comando->bindParam(':ing_loteId', $IngresoObj->ing_loteId);
		$comando->bindParam(':ing_refDocTipo', $IngresoObj->ing_refDocTipo);
		$comando->bindParam(':ing_refDocId', $IngresoObj->ing_refDocId);
		$comando->bindParam(':ing_refDocTipo2', $IngresoObj->ing_refDocTipo2);
		$comando->bindParam(':ing_refDocId2', $IngresoObj->ing_refDocId2);
		$comando->bindParam(':ing_tipoCambio', $IngresoObj->ing_tipoCambio);
		$comando->bindParam(':ing_moneda', $IngresoObj->ing_moneda);
		$comando->bindParam(':ing_glosa', $IngresoObj->ing_glosa);	
		$comando->bindParam(':ing_obs', $IngresoObj->ing_obs);
		$comando->bindParam(':ing_pdte_regulariza', $IngresoObj->ing_pdte_regulariza);		
		$comando->bindParam(':ing_status', $IngresoObj->ing_status);
		$comando->bindParam(':usrreg', $IngresoObj->ing_usrreg);
		$comando->bindParam(':fecreg', $fecreg);

/*
		echo "<pre>";
		print_r($IngresoObj);
		echo $sql;
		echo "</pre>";
*/		
		$comando->execute();
//		print_r($comando->errorInfo());
//		exit("aqui 2222 !!***-n");

		$query	 = "SELECT DISTINCT max(ing_id) as id FROM im_ingreso where ing_fecreg = '".$fecreg."' AND ing_usrreg = '".$IngresoObj->ing_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
//print_r($comando->errorInfo());
		return $row["id"];		
	}

}



class ImIngresoLineaModel{

	public function insert($IngresoLineaObj){
		global $usuario,$PDO;
		if (!$IngresoLineaObj->ingl_odp_id){
			$IngresoLineaObj->ingl_odp_id = 0;
		}
		$sql = "
			INSERT INTO 
			im_ingresolinea 
			(
			ingl_id, 
			ingl_docRefTipo,
			ingl_docRefId,
			ingl_docRefLineaId,
			ingl_prId,
			ingl_loteId,
			ingl_descripcion, 
			ingl_cantidad, 
			ingl_costo, 
			ingl_costo_gl,
			ingl_odp_id,
			ingl_usrreg, 
			ingl_fecreg 
			) 
			VALUES 
			(
			:ingl_id,
			:ingl_docRefTipo,
			:ingl_docRefId,
			:ingl_docRefLineaId,			
			:ingl_prId, 
			:ingl_loteId, 
			:ingl_descripcion, 
			:ingl_cantidad,  
			:ingl_costo, 
			:ingl_costo_gl,
			:ingl_odp_id,
			:usuario, 
			:fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':ingl_id', $IngresoLineaObj->ingl_id);
		$comando->bindParam(':ingl_docRefTipo', $IngresoLineaObj->ingl_docRefTipo);
		$comando->bindParam(':ingl_docRefId', $IngresoLineaObj->ingl_docRefId);
		$comando->bindParam(':ingl_docRefLineaId', $IngresoLineaObj->ingl_docRefLineaId);
		$comando->bindParam(':ingl_prId', $IngresoLineaObj->ingl_prId);
		$comando->bindParam(':ingl_loteId', $IngresoLineaObj->ingl_loteId);
		$comando->bindParam(':ingl_descripcion', $IngresoLineaObj->ingl_descripcion);
		$comando->bindParam(':ingl_cantidad', $IngresoLineaObj->ingl_cantidad);
		$comando->bindParam(':ingl_costo', $IngresoLineaObj->ingl_costo);
		$comando->bindParam(':ingl_costo_gl', $IngresoLineaObj->ingl_costo_gl);
		$comando->bindParam(':ingl_odp_id', $IngresoLineaObj->ingl_odp_id);
		$comando->bindParam(':usuario', $usuario);
		$comando->bindParam(':fecreg', $fecreg);
		$comando->execute();

		$query	 = "
			SELECT DISTINCT max(ingl_lineaId) as id 
			FROM im_ingresolinea 
			WHERE ingl_fecreg = '".$fecreg."' 
				AND ingl_usrreg = '".$usuario."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function update($IngresoLineaObj){
		global $usuario, $PDO;
/*
		if ($IngresoLineaObj->ingl_docRefTipo){
			$set .= ",ingl_docRefTipo = :ingl_docRefTipo";
		}
		if ($IngresoLineaObj->ingl_docRefId){
			$set .= ",ingl_docRefId = :ingl_docRefId";
		}
		if ($IngresoLineaObj->ingl_docRefLineaId){
			$set .= ",ingl_docRefLineaId = :ingl_docRefLineaId";
		}
		if ($IngresoLineaObj->ingl_prId){
			$set .= ",ingl_prId = :ingl_prId";
		}
		if ($IngresoLineaObj->ingl_loteId){
			$set .= ",ingl_loteId = :ingl_loteId";
		}
		if ($IngresoLineaObj->ingl_descripcion){
			$set .= ",ingl_descripcion = :ingl_descripcion";
		}
*/
		if ($IngresoLineaObj->ingl_prId){
			$where .= " AND ingl_prId = :ingl_prId";
		}
		if ($IngresoLineaObj->ingl_lineaId){
			$where .= " AND ingl_lineaId = :ingl_lineaId";
		}
		
		if ($IngresoLineaObj->ingl_cantidad){
			$set .= ",ingl_cantidad = :ingl_cantidad";
		}
		if ($IngresoLineaObj->ingl_costo){
			$set .= ",ingl_costo = :ingl_costo";
		}
		if ($IngresoLineaObj->ingl_costo_gl){
			$set .= ",ingl_costo_gl = :ingl_costo_gl";
		}
		if ($set && $where){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_ingresolinea
				SET 
					$set
					,ingl_usract = :usuario
				WHERE 
					ingl_id = :ingl_id
					$where	
				";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':ingl_id', $IngresoLineaObj->ingl_id);
			$comando->bindParam(':usuario', $IngresoLineaObj->ingl_usract);
			if ($IngresoLineaObj->ingl_lineaId){
				$comando->bindParam(':ingl_lineaId', $IngresoLineaObj->ingl_lineaId);
			}
			if ($IngresoLineaObj->ingl_prId){
				$comando->bindParam(':ingl_prId', $IngresoLineaObj->ingl_prId);
			}
			if ($IngresoLineaObj->ingl_cantidad){
				$comando->bindParam(':ingl_cantidad', $IngresoLineaObj->ingl_cantidad);
			}
			if ($IngresoLineaObj->ingl_costo){
				$comando->bindParam(':ingl_costo', $IngresoLineaObj->ingl_costo);
			}
			if ($IngresoLineaObj->ingl_costo_gl){
				$comando->bindParam(':ingl_costo_gl', $IngresoLineaObj->ingl_costo_gl);
			}
			$comando->execute();
			return $IngresoLineaObj->ingl_lineaId;
		}
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ingresolinea
			WHERE ingl_lineaId = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ingresolinea
				LEFT JOIN im_producto P ON ingl_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE ingl_id = :ingl_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':ingl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["ingl_id"]				= $row["ingl_id"];
			$a_linea["ingl_lineaId"]		= $row["ingl_lineaId"];
			$a_linea["ingl_docRefTipo"]		= $row["ingl_docRefTipo"];
			$a_linea["ingl_docRefId"]		= $row["ingl_docRefId"];
			$a_linea["ingl_docRefLineaId"]	= $row["ingl_docRefLineaId"];
			$a_linea["ingl_prId"]			= $row["ingl_prId"];
			$a_linea["ingl_loteId"]			= $row["ingl_loteId"];
			$a_linea["ingl_descripcion"]	= $row["ingl_descripcion"];
			$a_linea["ingl_cantidad"]		= $row["ingl_cantidad"];
			$a_linea["ingl_costo"]			= $row["ingl_costo"];
			$a_linea["ingl_costo_gl"]		= $row["ingl_costo_gl"];
			$a_linea["ingl_odp_id"]			= $row["ingl_odp_id"];
			$a_linea["ingl_usrreg"]			= $row["ingl_usrreg"];
			$a_linea["ingl_usract"]			= $row["ingl_usract"];
			$a_linea["ingl_fecreg"]			= $row["ingl_fecreg"];
			$a_linea["ingl_fecact"]			= $row["ingl_fecact"];
			$a_linea["pr_productoId"]		= $row["pr_productoId"];
			$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
			$a_linea["pr_uom"]				= $row["pr_uom"];
			$a_linea["subtotal"]			= $row["ingl_cantidad"]*$row["ingl_costo"];
			$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
			$a_ingresolinea[]				= $a_linea;
		}
		return $a_ingresolinea;
			

	}


	public function selectUniqueIdGroupPrId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
			SUM(ingl_cantidad) AS tot_cant,
			SUM(ingl_costo*ingl_cantidad) AS tot_costo,
			SUM(ingl_costo_gl*ingl_cantidad) AS tot_costo_gl
			FROM im_ingresolinea
				LEFT JOIN im_producto P ON ingl_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE ingl_id = :ingl_id
			GROUP BY ingl_prId
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':ingl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["ingl_id"]				= $row["ingl_id"];
			$a_linea["ingl_lineaId"]		= $row["ingl_lineaId"];
			$a_linea["ingl_docRefTipo"]		= $row["ingl_docRefTipo"];
			$a_linea["ingl_docRefId"]		= $row["ingl_docRefId"];
			$a_linea["ingl_docRefLineaId"]	= $row["ingl_docRefLineaId"];
			$a_linea["ingl_prId"]			= $row["ingl_prId"];
			$a_linea["ingl_loteId"]			= $row["ingl_loteId"];
			$a_linea["ingl_descripcion"]	= $row["ingl_descripcion"];
			$a_linea["ingl_cantidad"]		= $row["tot_cant"];
			$a_linea["ingl_costo"]			= $row["tot_costo"] / $row["tot_cant"];
			$a_linea["ingl_costo_gl"]		= $row["tot_costo_gl"] / $row["tot_cant"];
			$a_linea["ingl_odp_id"]			= $row["ingl_odp_id"];
			$a_linea["ingl_usrreg"]			= $row["ingl_usrreg"];
			$a_linea["ingl_usract"]			= $row["ingl_usract"];
			$a_linea["ingl_fecreg"]			= $row["ingl_fecreg"];
			$a_linea["ingl_fecact"]			= $row["ingl_fecact"];
			$a_linea["pr_productoId"]		= $row["pr_productoId"];
			$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
			$a_linea["pr_uom"]				= $row["pr_uom"];
			$a_linea["subtotal"]			= $row["ingl_cantidad"]*$row["ingl_costo"];
			$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
			$a_ingresolinea[]				= $a_linea;
		}
		return $a_ingresolinea;
			

	}



	public function selectUniqueIdDev($id,$tipoDev,$almacenDev=''){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		if ($tipoDev=='DPI'){
			$join = " LEFT JOIN im_stock_lote ON ingl_prId = stkl_prId AND stkl_almacenId = '".$almacenDev."' AND ing_loteId = stkl_loteId ";			
			$stockDev =	"stkl_fisico";
		}elseif($tipoDev=='DCN'){
			$join = " LEFT JOIN im_stock ON ingl_prId = stk_prId AND stk_almacenId = '".$almacenDev."' ";			
			$stockDev =	"stk_fisico";
		}
		$sql = "
			SELECT *
			FROM im_ingresolinea
				LEFT JOIN im_ingreso ON ingl_id = ing_id
				LEFT JOIN im_producto P ON ingl_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				LEFT JOIN im_ordenDespachopendiente ON ingl_odp_id = odp_id
				$join
			WHERE ingl_id = :ingl_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':ingl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["ingl_id"]				= $row["ingl_id"];
			$a_linea["ingl_lineaId"]		= $row["ingl_lineaId"];
			$a_linea["ingl_docRefTipo"]		= $row["ingl_docRefTipo"];
			$a_linea["ingl_docRefId"]		= $row["ingl_docRefId"];
			$a_linea["ingl_docRefLineaId"]	= $row["ingl_docRefLineaId"];
			$a_linea["ingl_prId"]			= $row["ingl_prId"];
			$a_linea["ingl_loteId"]			= $row["ingl_loteId"];
			$a_linea["ingl_descripcion"]	= $row["ingl_descripcion"];
			$a_linea["ingl_cantidad"]		= $row["ingl_cantidad"];
			$a_linea["ingl_costo"]			= $row["ingl_costo"];
			$a_linea["ingl_costo_gl"]		= $row["ingl_costo_gl"];
			$a_linea["ingl_odp_id"]			= $row["ingl_odp_id"];
			$a_linea["odp_od_id"]			= $row["odp_od_id"];
			$a_linea["odp_id"]			= $row["odp_id"];
			$a_linea["odp_refDocId"]		= $row["odp_refDocId"];
			$a_linea["ingl_usrreg"]			= $row["ingl_usrreg"];
			$a_linea["ingl_usract"]			= $row["ingl_usract"];
			$a_linea["ingl_fecreg"]			= $row["ingl_fecreg"];
			$a_linea["ingl_fecact"]			= $row["ingl_fecact"];
			$a_linea["pr_productoId"]		= $row["pr_productoId"];
			$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
			$a_linea["pr_uom"]				= $row["pr_uom"];
			$a_linea["subtotal"]			= $row["ingl_cantidad"]*$row["ingl_costo"];
			$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
			if ($row[$stockDev] > 0){
				$a_linea[$stockDev]			= $row[$stockDev];
			}else{
				$a_linea[$stockDev]			= 0;	
			}
			$a_ingresolinea[]				= $a_linea;
		}
		return $a_ingresolinea;
			

	}


	public function select($IngresoFilter){
		global $PDO;
		if ($IngresoFilter->ingl_id){
			$where .=  " AND ingl_id = :ingl_id";
		}
		if ($IngresoFilter->ingl_lineaId){
			$where .=  " AND ingl_lineaId = :ingl_lineaId";
		}
		if ($IngresoFilter->ingl_prId){
			$where .=  " AND ingl_prId = :ingl_prId";
		}
		if ($IngresoFilter->ingl_loteId){
			$where .=  " AND ingl_loteId = :ingl_loteId";
		}
		if ($IngresoFilter->pr_ctrlSerie){
			$where .=  " AND pr_ctrlSerie = :pr_ctrlSerie";
		}
		
		if ($where){
			$sql = "
				SELECT *
				FROM im_ingresolinea
				LEFT JOIN im_producto ON ingl_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($IngresoFilter->ingl_id){
				$comando->bindParam(':ingl_id', $IngresoFilter->ingl_id);
			}
			if ($IngresoFilter->ingl_lineaId){
				$comando->bindParam(':ingl_lineaId', $IngresoFilter->ingl_lineaId);
			}
			if ($IngresoFilter->ingl_prId){
				$comando->bindParam(':ingl_prId', $IngresoFilter->ingl_prId);
			}
			if ($IngresoFilter->pr_ctrlSerie){
				$comando->bindParam(':pr_ctrlSerie', $IngresoFilter->pr_ctrlSerie);
			}
			$comando->execute();
			//print_r($comando->errorInfo());
			while($row = $comando->fetch()){
				$a_linea["ingl_id"]				= $row["ingl_id"];
				$a_linea["ingl_lineaId"]		= $row["ingl_lineaId"];
				$a_linea["ingl_prId"]			= $row["ingl_prId"];
				$a_linea["ingl_loteId"]			= $row["ingl_loteId"];				
				$a_linea["ingl_descripcion"]	= $row["ingl_descripcion"];
				$a_linea["ingl_cantidad"]		= $row["ingl_cantidad"];
				$a_linea["ingl_costo"]			= $row["ingl_costo"];
				$a_linea["ingl_costo_gl"]		= $row["ingl_costo_gl"];
				$a_linea["ingl_usrreg"]			= $row["ingl_usrreg"];
				$a_linea["ingl_usract"]			= $row["ingl_usract"];
				$a_linea["ingl_fecreg"]			= $row["ingl_fecreg"];
				$a_linea["ingl_fecact"]			= $row["ingl_fecact"];
				$a_linea["pr_ctrlSerie"]		= $row["pr_ctrlSerie"];
				$a_linea["pr_productoId"]		= $row["pr_productoId"];
				$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
				$a_linea["pr_uom"]				= $row["pr_uom"];
				$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
				$a_ingresolinea[]				= $a_linea;
			}
			if ($IngresoFilter->ingl_id==2){
				print_r($a_ingresolinea);
			}
			return $a_ingresolinea;
			
		}
	}

	public function selectLineaArticulo($ingresoId,$productoId){
		global $PDO;
		if (!$ingresoId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ingresolinea
			WHERE ingl_id = '".$ingresoId."'				
				AND ingl_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["ingl_prId"] = $row["ingl_prId"];
		}
		return $a_linea;
	}

}



class ImIngresoSerieModel{

	public function insert($IngresoSerieObj){
		global $usuario,$PDO;
		$fecreg = date("Y-m-d H:i:s");
		$sql = "
			INSERT INTO 
				im_ingresoserie 
			(
			ings_ing_id, 
			ings_lineaId,
			ings_ser_id,
			ings_usrreg, 
			ings_fecreg 
			) 
			VALUES 
			(
			'".$IngresoSerieObj->ings_ing_id."', 
			'".$IngresoSerieObj->ings_lineaId."', 
			'".$IngresoSerieObj->ings_ser_id."', 			
			'".$usuario."', 
			'".$fecreg."'
			);			
		";
		$PDO->query($sql);
		$query	 = "
			SELECT DISTINCT max(ings_id) as id 
			FROM im_ingresoserie
			WHERE ings_fecreg = '".$fecreg."' 
				AND ings_usrreg = '".$usuario."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}

	public function delete($id){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ingresoserie
			WHERE ings_id = :ings_id
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':ings_id', $id);
		$comando->execute();
		return $lineaId;
	}

	public function deleteSeriesLinea($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ingresoserie
			WHERE ings_lineaId = :lineaId
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}

	public function select($IngresoFilter){
		global $PDO;
		if ($IngresoFilter->ings_ing_id){
			$where .=  " AND ings_ing_id = :ings_ing_id";
		}
		if ($IngresoFilter->ings_lineaId){
			$where .=  " AND ings_lineaId = :ings_lineaId";
		}
		if ($IngresoFilter->ingl_prId){
			$where .=  " AND ingl_prId = :ingl_prId";
		}
		if ($IngresoFilter->ser_serie){
			$where .=  " AND ser_serie = :ser_serie";
		}

		if ($where){
			$sql = "
				SELECT *
				FROM im_ingresoserie
				LEFT JOIN im_ingresolinea ON ings_lineaId = ingl_lineaId
				LEFT JOIN im_serie ON ings_ser_id = ser_id
				LEFT JOIN im_producto ON ser_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($IngresoFilter->ings_ing_id){
				$comando->bindParam(':ings_ing_id', $IngresoFilter->ings_ing_id);
			}
			if ($IngresoFilter->ings_lineaId){
				$comando->bindParam(':ings_lineaId', $IngresoFilter->ings_lineaId);
			}
			if ($IngresoFilter->ingl_prId){
				$comando->bindParam(':ingl_prId', $IngresoFilter->ingl_prId);
			}
			if ($IngresoFilter->ser_serie){
				$comando->bindParam(':ser_serie', $IngresoFilter->ser_serie);
			}

			$comando->execute();
			//print_r($comando->errorInfo());
			while($row = $comando->fetch()){
				$a_linea["ings_id"]			= $row["ings_id"];
				$a_linea["ings_ing_id"]		= $row["ings_ing_id"];
				$a_linea["ings_lineaId"]	= $row["ings_lineaId"];
				$a_linea["ser_prId"]		= $row["ser_prId"];
				$a_linea["ser_serie"]		= $row["ser_serie"];
				$a_linea["pr_productoId"]	= $row["pr_productoId"];
				$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
				$a_linea["ings_usrreg"]		= $row["ings_usrreg"];
				$a_linea["ings_fecreg"]		= $row["ings_fecreg"];
				$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
				$a_despachoserie[]			= $a_linea;
			}
			return $a_despachoserie;
			
		}
	}


	public function selectSerieArticulo($salidaId,$productoId){
		global $PDO;
		if (!$salidaId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ingresoserie
				LEFT JOIN im_serie ON ings_ser_id = ser_id
			WHERE ings_ing_id = '".$salidaId."'				
				AND ser_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["ser_prId"] = $row["ser_prId"];
		}
		return $a_linea;
	}

}


?>