<?php


class ImLoteModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_Lote
			WHERE lt_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_Lote["lt_id"]			= $row["lt_id"];
		$a_Lote["lt_nombre"]		= $row["lt_nombre"];
		$a_Lote["lt_idRef"]			= $row["lt_idRef"];
		$a_Lote["lt_tipo"]			= $row["lt_tipo"];
		$a_Lote["lt_subInvenTipo"]	= $row["lt_subInvenTipo"];
		$a_Lote["lt_org_inv"]		= $row["lt_org_inv"];
		$a_Lote["lt_org_inv_gl"]	= $row["lt_org_inv_gl"];
		$a_Lote["lt_so"]			= $row["lt_so"];
		$a_Lote["lt_po"]			= $row["lt_po"];
		$a_Lote["lt_direcc1"]		= $row["lt_direcc1"];
		$a_Lote["lt_direcc2"]		= $row["lt_direcc2"];
		$a_Lote["lt_ciudad"]		= $row["lt_ciudad"];
		$a_Lote["lt_estado"]		= $row["lt_estado"];
		$a_Lote["lt_logico"]		= $row["lt_logico"];		
		$a_Lote["lt_agingMax"]		= $row["lt_agingMax"];
		$a_Lote["lt_contab"]		= $row["lt_contab"];
		$a_Lote["lt_status"]		= $row["lt_status"];
		$a_Lote["lt_usract"]		= $row["lt_usract"];
		$a_Lote["lt_fecact"]		= $row["lt_fecact"];
		return $a_Lote;
	}


	public function select($LoteObj,$limit=''){
		global $usuario, $PDO;
		if ($LoteObj->lt_id){
			$where .= "AND lt_id = :lt_id";
		}
		if ($LoteObj->lt_nombre){
			$where .= "AND lt_nombre LIKE :lt_nombre";
		}
		if ($LoteObj->lt_status){
			$where .= "AND lt_status = :lt_status";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($LoteObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY lt_nombre";
		}
		$sql = "
			SELECT *
			FROM im_lote 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($LoteObj->lt_id){
			$comando->bindParam(':lt_id', $LoteObj->lt_id);
		}
		if ($LoteObj->lt_idRef){
			$comando->bindParam(':lt_idRef', $LoteObj->lt_idRef);
		}
		if ($LoteObj->lt_nombre){
			$comando->bindParam(':lt_nombre', $LoteObj->lt_nombre);
		}
		if ($LoteObj->lt_status){
			$comando->bindParam(':lt_status', $LoteObj->lt_status);
		}
		if ($LoteObj->orderBy){
			$comando->bindParam(':orderBy', $LoteObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_Lote["lt_id"]			= $row["lt_id"];
			$a_Lote["lt_nombre"]		= $row["lt_nombre"];
			$a_Lote["lt_idRef"]			= $row["lt_idRef"];
			$a_Lote["lt_tipo"]			= $row["lt_tipo"];
			$a_Lote["lt_subInvenTipo"]	= $row["lt_subInvenTipo"];
			$a_Lote["lt_org_inv"]		= $row["lt_org_inv"];
			$a_Lote["lt_org_inv_gl"]	= $row["lt_org_inv_gl"];
			$a_Lote["lt_so"]			= $row["lt_so"];
			$a_Lote["lt_po"]			= $row["lt_po"];
			$a_Lote["lt_direcc1"]		= $row["lt_direcc1"];
			$a_Lote["lt_direcc2"]		= $row["lt_direcc2"];
			$a_Lote["lt_ciudad"]		= $row["lt_ciudad"];
			$a_Lote["lt_estado"]		= $row["lt_estado"];
			$a_Lote["lt_logico"]		= $row["lt_logico"];		
			$a_Lote["lt_agingMax"]		= $row["lt_agingMax"];
			$a_Lote["lt_contab"]		= $row["lt_contab"];
			$a_Lote["lt_status"]		= $row["lt_status"];
			$a_Lote["lt_usract"]		= $row["lt_usract"];
			$a_Lote["lt_fecact"]		= $row["lt_fecact"];
			$a_LoteList["listaPag"][] = $a_Lote;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_LoteList["total"] = $rowTotal["total"];
		return $a_LoteList;

	}


	public function update($LoteObj){
		global $usuario, $PDO;
		if ($LoteObj->lt_nombre){
			$set .= ", lt_nombre = :lt_nombre";
		}
		if ($LoteObj->lt_idRef){
			$set .= ", lt_idRef = :lt_idRef";
		}
		if ($LoteObj->lt_so){
			$set .= ", lt_so = :lt_so";
		}
		if ($LoteObj->lt_po){
			$set .= ", lt_po = :lt_po";
		}
		if ($LoteObj->lt_direcc1){
			$set .= ", lt_direcc1 = :lt_direcc1";
		}
		if ($LoteObj->lt_direcc2){
			$set .= ", lt_direcc2 = :lt_direcc2";
		}
		if ($LoteObj->lt_ciudad){
			$set .= ", lt_ciudad = :lt_ciudad";
		}
		if ($LoteObj->lt_estado){
			$set .= ", lt_estado = :lt_estado";
		}
		if ($LoteObj->lt_logico){
			$set .= ", lt_logico = :lt_logico";
		}
		if ($LoteObj->lt_agingMax){
			$set .= ", lt_agingMax = :lt_agingMax";
		}
		if ($LoteObj->lt_contab){
			$set .= ", lt_contab = :lt_contab";
		}
		if ($LoteObj->lt_kdxGL){
			//$set .= ", lt_kdxGL = :lt_kdxGL";
		}
		if ($LoteObj->lt_status){
			$set .= ", lt_status = :lt_status";
		}
		if ($set && $LoteObj->lt_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_Lote
				SET 
					$set
					,lt_usract = :lt_usract
				WHERE lt_id = :lt_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':lt_id', $LoteObj->lt_id);
			if ($LoteObj->lt_nombre){
				$comando->bindParam(':lt_nombre', $LoteObj->lt_nombre);
			}
			if ($LoteObj->lt_idRef){
				$comando->bindParam(':lt_idRef', $LoteObj->lt_idRef);
			}
			if ($LoteObj->lt_so){
				$comando->bindParam(':lt_so', $LoteObj->lt_so);
			}
			if ($LoteObj->lt_po){
				$comando->bindParam(':lt_po', $LoteObj->lt_po);
			}
			if ($LoteObj->lt_direcc1){
				$comando->bindParam(':lt_direcc1', $LoteObj->lt_direcc1);
			}
			if ($LoteObj->lt_direcc2){
				$comando->bindParam(':lt_direcc2', $LoteObj->lt_direcc2);
			}
			if ($LoteObj->lt_ciudad){
				$comando->bindParam(':lt_ciudad', $LoteObj->lt_ciudad);
			}
			if ($LoteObj->lt_estado){
				$comando->bindParam(':lt_estado', $LoteObj->lt_estado);
			}
			if ($LoteObj->lt_logico){
				$comando->bindParam(':lt_logico', $LoteObj->lt_logico);
			}
			if ($LoteObj->lt_agingMax){
				$comando->bindParam(':lt_agingMax', $LoteObj->lt_agingMax);
			}
			if ($LoteObj->lt_contab){
				$comando->bindParam(':lt_contab', $LoteObj->lt_contab);
			}
			if ($LoteObj->lt_kdxGL){
				//$comando->bindParam(':lt_kdxGL', $LoteObj->lt_kdxGL);
			}
			if ($LoteObj->lt_status){
				$comando->bindParam(':lt_status', $LoteObj->lt_status);
			}
			$comando->bindParam(':lt_usract', $usuario);
			$comando->execute();
			//print_r($comando->errorInfo());
			return $LoteObj->lt_id;
		}
	}

	public function insert($LoteObj){
		global $PDO;
		$sql = "
			INSERT INTO im_Lote 
			(
			lt_nombre, 
			lt_idRef,
			lt_tipo,
			lt_subInvenTipo,
			lt_org_inv,
			lt_org_inv_gl,
			lt_so,
			lt_po,
			lt_direcc1,
			lt_direcc2,
			lt_ciudad,
			lt_estado,
			lt_logico,
			lt_agingMax,
			lt_status, 
			lt_usract, 
			lt_fecact
			) 
			VALUES 
			(
			:lt_nombre, 
			:lt_idRef,
			:lt_tipo,
			:lt_subInvenTipo,
			:lt_org_inv,
			:lt_org_inv_gl,
			:lt_so,
			:lt_po,
			:lt_direcc1,
			:lt_direcc2,
			:lt_ciudad,
			:lt_estado,
			:lt_logico,
			:lt_agingMax,
			:lt_status, 
			:lt_usract,
			:lt_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':lt_nombre', $LoteObj->lt_nombre);
		$comando->bindParam(':lt_idRef', $LoteObj->lt_idRef);
		$comando->bindParam(':lt_tipo', $LoteObj->lt_tipo);
		$comando->bindParam(':lt_subInvenTipo', $LoteObj->lt_subInvenTipo);
		$comando->bindParam(':lt_org_inv', $LoteObj->lt_org_inv);
		$comando->bindParam(':lt_org_inv_gl', $LoteObj->lt_org_inv_gl);
		$comando->bindParam(':lt_so', $LoteObj->lt_so);
		$comando->bindParam(':lt_po', $LoteObj->lt_po);
		$comando->bindParam(':lt_direcc1', $LoteObj->lt_direcc1);
		$comando->bindParam(':lt_direcc2', $LoteObj->lt_direcc2);
		$comando->bindParam(':lt_estado', $LoteObj->lt_estado);
		$comando->bindParam(':lt_logico', $LoteObj->lt_logico);
		$comando->bindParam(':lt_agingMax', $LoteObj->lt_agingMax);	
		$comando->bindParam(':lt_status', $LoteObj->lt_status);
		$comando->bindParam(':lt_usract', $LoteObj->lt_usract);
		$comando->bindParam(':lt_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(lt_id) as id 
			FROM `im_Lote` 
			WHERE lt_usract = :lt_usract 
				AND lt_fecact = :lt_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':lt_usract', $LoteObj->lt_usract);
		$comando->bindParam(':lt_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>