<?php


class ImMarcaModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_marca
			WHERE mr_marcaId = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_marca["mr_marcaId"]  = $row["mr_marcaId"];
		$a_marca["mr_nombre"]	= $row["mr_nombre"];
		$a_marca["mr_status"]	= $row["mr_status"];
		$a_marca["mr_usract"]	= $row["mr_usract"];
		$a_marca["mr_fecact"]	= $row["mr_fecact"];
		return $a_marca;
	}


	public function select($MarcaObj,$limit=''){
		global $usuario, $PDO;
		if ($MarcaObj->mr_marcaId){
			$where .= "AND mr_marcaId = :mr_marcaId";
		}
		if ($MarcaObj->mr_nombre){
			$where .= "AND mr_nombre LIKE :mr_nombre";
		}
		if ($MarcaObj->mr_status){
			$where .= "AND mr_status = :mr_status";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($MarcaObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY mr_nombre";
		}
		$sql = "
			SELECT *
			FROM im_marca 
			WHERE 1 $where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($MarcaObj->mr_marcaId){
			$comando->bindParam(':mr_marcaId', $MarcaObj->mr_marcaId);
		}
		if ($MarcaObj->mr_nombre){
			$comando->bindParam(':mr_nombre', $MarcaObj->mr_nombre);
		}
		if ($MarcaObj->mr_status){
			$comando->bindParam(':mr_status', $MarcaObj->mr_status);
		}
		if ($MarcaObj->orderBy){
			$comando->bindParam(':orderBy', $MarcaObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_marca["mr_marcaId"]	= $row["mr_marcaId"];
			$a_marca["mr_nombre"]	= $row["mr_nombre"];
			$a_marca["mr_status"]	= $row["mr_status"];
			$a_marca["mr_usract"]	= $row["mr_usract"];
			$a_marca["mr_fecact"]	= $row["mr_fecact"];
			$a_marcaList["listaPag"][] = $a_marca;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_marcaList["total"] = $rowTotal["total"];
		return $a_marcaList;

	}


	public function update($MarcaObj){
		global $usuario, $PDO;
		if ($MarcaObj->mr_nombre){
			$set .= ", mr_nombre = :mr_nombre";
		}
		if ($MarcaObj->mr_status){
			$set .= ", mr_status = :mr_status";
		}
		if ($set && $MarcaObj->mr_marcaId){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_marca
				SET 
					$set
					,mr_usract = :mr_usract
				WHERE mr_marcaId = :mr_marcaId
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':mr_marcaId', $MarcaObj->mr_marcaId);
			if ($MarcaObj->mr_nombre){
				$comando->bindParam(':mr_nombre', $MarcaObj->mr_nombre);
			}
			if ($MarcaObj->mr_status){
				$comando->bindParam(':mr_status', $MarcaObj->mr_status);
			}
			$comando->bindParam(':mr_usract', $usuario);
			$comando->execute();
			return $MarcaObj->mr_marcaId;
		}
	}


	public function insert($MarcaObj){
		global $PDO;
		$sql = "
			INSERT INTO im_marca 
			(
			mr_nombre, 
			mr_status, 
			mr_usract, 
			mr_fecact
			) 
			VALUES 
			(
			:mr_nombre, 
			:mr_status, 
			:mr_usract,
			:mr_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':mr_nombre', $MarcaObj->mr_nombre);
		$comando->bindParam(':mr_status', $MarcaObj->mr_status);
		$comando->bindParam(':mr_usract', $MarcaObj->mr_usract);
		$comando->bindParam(':mr_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(mr_marcaId) as id 
			FROM `im_marca` 
			WHERE mr_usract = :mr_usract 
				AND mr_fecact = :mr_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':mr_usract', $MarcaObj->mr_usract);
		$comando->bindParam(':mr_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>