<?php

class ImOrdenDespachoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM im_ordenDespacho
				LEFT JOIN vt_cliente ON od_cli_id = cl_id 
				LEFT JOIN im_almacen ON od_almacenId = alm_id 
				LEFT JOIN xx_maestrolista MSTAT ON od_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'imOdStatus'
				LEFT JOIN xx_maestrolista MTIPO ON od_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'imOdTipo'
				LEFT JOIN im_salida ON od_id = sal_od_id
			WHERE od_id = :id
		";					
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_despacho["od_id"]			= $row["od_id"];
		$a_despacho["od_tipo"]			= $row["od_tipo"];
		$a_despacho["od_tipo_sunat"]	= $row["od_tipo_sunat"];
		$a_despacho["od_pdte_regulariza"] = $row["od_pdte_regulariza"];
		$a_despacho["od_almacenId"]		= $row["od_almacenId"];
		$a_despacho["od_cli_id"]		= $row["od_cli_id"];
		$a_despacho["od_cli_ruc"]		= $row["od_cli_ruc"];
		$a_despacho["od_cli_nombre"]	= $row["od_cli_nombre"];
		$a_despacho["od_contacto"]		= $row["od_contacto"];
		$a_despacho["od_so_id"]			= $row["od_so_id"];
		$a_despacho["od_wo_id"]			= $row["od_wo_id"];
		$a_despacho["od_refDocId"]		= $row["od_refDocId"];
		$a_despacho["od_refDocId2"]		= $row["od_refDocId2"];
		$a_despacho["od_refDocId3"]		= $row["od_refDocId3"];
		$a_despacho["od_fechaDoc"]		= $row["od_fechaDoc"];
		$a_despacho["od_fechaReq"]		= $row["od_fechaReq"];
		$a_despacho["od_fechaEnt"]		= $row["od_fechaEnt"];
		$a_despacho["od_tipo_entrega"]	= $row["od_tipo_entrega"];
		$a_despacho["od_direccion1"]	= $row["od_direccion1"];
		$a_despacho["od_direccion2"]	= $row["od_direccion2"];
		$a_despacho["od_ciudad"]		= $row["od_ciudad"];
		$a_despacho["od_estado"]		= $row["od_estado"];
		$a_despacho["od_pais"]			= $row["od_pais"];
		$a_despacho["od_obs"]			= $row["od_obs"];
		$a_despacho["od_glosa"]			= $row["od_glosa"];

		$a_despacho["od_ubigeo"]			= $row["od_ubigeo"];
		$a_despacho["od_tipo_transporte"]	= $row["od_tipo_transporte"];
		$a_despacho["od_transp_doc_tipo"]	= $row["od_transp_doc_tipo"];
		$a_despacho["od_transp_doc_nro"]	= $row["od_transp_doc_nro"];
		$a_despacho["od_transp_nombre"]		= $row["od_transp_nombre"];
		$a_despacho["od_transp_placa"]		= $row["od_transp_placa"];
		$a_despacho["od_cli_tipo_doc"]		= $row["od_cli_tipo_doc"];
		$a_despacho["od_cli_correo"]		= $row["od_cli_correo"];

		$a_despacho["od_status"]		= $row["od_status"];
		$a_despacho["od_usrreg"]		= $row["od_usrreg"];
		$a_despacho["od_usract"]		= $row["od_usract"];
		$a_despacho["od_fecreg"]		= $row["od_fecreg"];
		$a_despacho["od_fecact"]		= $row["od_fecact"];
		if (!$row["od_cli_nombre"]){
			$a_despacho["cli_nombre"] = $row["cli_nombre"];
		}else{
			$a_despacho["cli_nombre"] = $row["od_cli_nombre"];
		}
		$a_despacho["alm_nombre"]		= $row["alm_nombre"];
		$a_despacho["od_status_nombre"] = $row["status_nombre"];
		$a_despacho["od_tipo_nombre"]	= $row["tipo_nombre"];
		if ($row["sal_id"]){
			$a_despacho["sal_id"] = $row["sal_id"];
		}
		return $a_despacho;
	}

	public function select($OrdenDespachoObj,$limit=''){
		global $usuario, $PDO;
		if ($OrdenDespachoObj->od_id){
			$where .= " AND od_id = :od_id";
		}
		if ($OrdenDespachoObj->od_tipo){
			$where .= " AND od_tipo = :od_tipo";
		}
		if ($OrdenDespachoObj->od_tipo_sunat){
			$where .= " AND od_tipo_sunat = :od_tipo_sunat";
		}
		if ($OrdenDespachoObj->od_almacenId){
			$where .= " AND od_almacenId = :od_almacenId";
		}
		if ($OrdenDespachoObj->od_cli_id){
			$where .= " AND od_cli_id = :od_cli_id";
		}
		if ($OrdenDespachoObj->od_cli_ruc){
			$where .= " AND od_cli_ruc = :od_cli_ruc";
		}
		if ($OrdenDespachoObj->od_cli_nombre){
			$where .= " AND od_cli_nombre LIKE :od_cli_nombre";
		}
		if ($OrdenDespachoObj->od_so_id){
			$where .= " AND od_so_id = :od_so_id";
		}
		if ($OrdenDespachoObj->od_wo_id){
			$where .= " AND od_wo_id = :od_wo_id";
		}
		if ($OrdenDespachoObj->od_refDocId){
			$where .= " AND od_refDocId = :od_refDocId";
		}
		if ($OrdenDespachoObj->od_refDocId2){
			$where .= " AND od_refDocId2 = :od_refDocId2";
		}
		if ($OrdenDespachoObj->od_estado){
			$where .= " AND od_estado LIKE :od_estado";
		}
		if ($OrdenDespachoObj->od_ciudad){
			$where .= " AND od_ciudad LIKE :od_ciudad";
		}
		if ($OrdenDespachoObj->od_direccion2){
			$where .= " AND od_direccion2 LIKE :od_direccion2";
		}
		if ($OrdenDespachoObj->fechaIniDoc){
			$where .= " AND od_fechaDoc >= :fechaIniDoc";
		}
		if ($OrdenDespachoObj->fechaFinDoc){
			$where .= " AND od_fechaDoc <= :fechaFinDoc";
		}
		if ($OrdenDespachoObj->fechaReqIni){
			$where .= " AND od_fechaReq >= :fechaReqIni";
		}
		if ($OrdenDespachoObj->fechaReqFin){
			$where .= " AND od_fechaReq <= :fechaReqFin";
		}
		if ($OrdenDespachoObj->fechaReqIni){
			$where .= " AND od_fechaReq >= :fechaReqIni";
		}
		if ($OrdenDespachoObj->fechaEntFin){
			$where .= " AND od_fechaEnt <= :fechaEntFin";
		}
		if ($OrdenDespachoObj->od_status){
			$where .= " AND od_status = :od_status";
		}
		if ($OrdenDespachoObj->od_statusNoAnula){
			$where .= " AND od_status <> 'A' ";
		}
		if ($OrdenDespachoObj->pr_id){
			$where .= " AND odl_prId = :pr_id";
			$join .= " LEFT JOIN im_ordenDespacholinea ON od_id = odl_id";
		}
		if ($OrdenDespachoObj->od_existeId){
			$where .= " AND od_id <> :od_existeId";
		}

		if ($OrdenDespachoObj->ser_serie){
			$join .= " 
				LEFT JOIN im_ordenDespachoserie ON od_id = ods_od_id 
				LEFT JOIN im_serie ON ods_ser_id= ser_id 
				";
			$where .= " AND ser_serie LIKE :ser_serie";
		}

		
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}

		if ($OrdenDespachoObj->orderBy){
			$orderBy = " ORDER BY ".$OrdenDespachoObj->orderBy;
		}else{
			$orderBy = " ORDER BY od_fechaDoc, od_id";
		}

		$sql = "
			SELECT  *, 
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM im_ordenDespacho
				LEFT JOIN vt_cliente ON od_cli_id = cl_id 
				LEFT JOIN im_almacen ON od_almacenId = alm_id 
				LEFT JOIN xx_maestrolista MSTAT ON od_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'imOdStatus'
				LEFT JOIN xx_maestrolista MTIPO ON od_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'imOdTipo'
				LEFT JOIN xx_maestrolista MTIPO2 ON od_tipo_sunat = MTIPO2.mlst_valorId AND MTIPO2.mlst_listaId = 'imOdTipoSunat'
				LEFT JOIN im_salida ON od_id = sal_od_id
				$join
			WHERE 1 $where
			GROUP BY od_id
			$orderBy
			$limit
		";
		$comando = $PDO->prepare($sql);
		if ($OrdenDespachoObj->od_id){
			$comando->bindParam(':od_id', $OrdenDespachoObj->od_id);
		}
		if ($OrdenDespachoObj->od_tipo){
			$comando->bindParam(':od_tipo', $OrdenDespachoObj->od_tipo);
		}
		if ($OrdenDespachoObj->od_tipo_sunat){
			$comando->bindParam(':od_tipo_sunat', $OrdenDespachoObj->od_tipo_sunat);
		}
		if ($OrdenDespachoObj->fechaIniDoc){
			$comando->bindParam(':fechaIniDoc', $OrdenDespachoObj->fechaIniDoc);
		}
		if ($OrdenDespachoObj->fechaFinDoc){
			$comando->bindParam(':fechaFinDoc', $OrdenDespachoObj->fechaFinDoc);
		}
		if ($OrdenDespachoObj->fechaReqIni){
			$comando->bindParam(':fechaReqIni', $OrdenDespachoObj->fechaReqIni);
		}
		if ($OrdenDespachoObj->fechaReqFin){
			$comando->bindParam(':fechaReqFin', $OrdenDespachoObj->fechaReqFin);
		}
		if ($OrdenDespachoObj->fechaEntIni){
			$comando->bindParam(':fechaEntIni', $OrdenDespachoObj->fechaEntIni);
		}
		if ($OrdenDespachoObj->fechaEntFin){
			$comando->bindParam(':fechaEntFin', $OrdenDespachoObj->fechaEntFin);
		}
		if ($OrdenDespachoObj->od_almacenId){
			$comando->bindParam(':od_almacenId', $OrdenDespachoObj->od_almacenId);
		}
		if ($OrdenDespachoObj->od_cli_id){
			$comando->bindParam(':od_cli_id', $OrdenDespachoObj->od_cli_id);
		}
		if ($OrdenDespachoObj->od_cli_ruc){
			$comando->bindParam(':od_cli_ruc', $OrdenDespachoObj->od_cli_ruc);
		}
		if ($OrdenDespachoObj->od_cli_nombre){
			$comando->bindParam(':od_cli_nombre', $OrdenDespachoObj->od_cli_nombre);
		}
		if ($OrdenDespachoObj->od_estado){
			$comando->bindParam(':od_estado', $OrdenDespachoObj->od_estado);
		}
		if ($OrdenDespachoObj->od_ciudad){
			$comando->bindParam(':od_ciudad', $OrdenDespachoObj->od_ciudad);
		}
		if ($OrdenDespachoObj->od_direccion2){
			$comando->bindParam(':od_direccion2', $OrdenDespachoObj->od_direccion2);
		}
		if ($OrdenDespachoObj->od_so_id){
			$comando->bindParam(':od_so_id', $OrdenDespachoObj->od_so_id);
		}
		if ($OrdenDespachoObj->od_wo_id){
			$comando->bindParam(':od_wo_id', $OrdenDespachoObj->od_wo_id);
		}
		if ($OrdenDespachoObj->od_refDocId){
			$comando->bindParam(':od_refDocId', $OrdenDespachoObj->od_refDocId);
		}
		if ($OrdenDespachoObj->od_refDocId2){
			$comando->bindParam(':od_refDocId2', $OrdenDespachoObj->od_refDocId2);
		}		
		if ($OrdenDespachoObj->pr_id){
			$comando->bindParam(':pr_id', $OrdenDespachoObj->pr_id);
		}
		if ($OrdenDespachoObj->od_status){
			$comando->bindParam(':od_status', $OrdenDespachoObj->od_status);
		}
		if ($OrdenDespachoObj->od_existeId){
			$comando->bindParam(':od_existeId', $OrdenDespachoObj->od_existeId);
		}
		if ($OrdenDespachoObj->ser_serie){
			$comando->bindParam(':ser_serie', $OrdenDespachoObj->ser_serie);
		}
		

		$comando->execute();
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_despacho["od_id"]			= $row["od_id"];
			$a_despacho["od_tipo"]			= $row["od_tipo"];
			$a_despacho["od_tipo_sunat"]	= $row["od_tipo_sunat"];
			$a_despacho["od_almacenId"]		= $row["od_almacenId"];
			$a_despacho["od_cli_id"]		= $row["od_cli_id"];
			$a_despacho["od_cli_ruc"]		= $row["od_cli_ruc"];
			$a_despacho["od_cli_nombre"]	= $row["od_cli_nombre"];
			$a_despacho["od_contacto"]		= $row["od_contacto"];
			$a_despacho["od_so_id"]			= $row["od_so_id"];
			$a_despacho["od_wo_id"]			= $row["od_wo_id"];
			$a_despacho["od_refDocId"]		= $row["od_refDocId"];
			$a_despacho["od_refDocId2"]		= $row["od_refDocId2"];
			$a_despacho["od_refDocId3"]		= $row["od_refDocId3"];
			$a_despacho["od_fechaDoc"]		= $row["od_fechaDoc"];
			$a_despacho["od_fechaReq"]		= $row["od_fechaReq"];
			$a_despacho["od_fechaEnt"]		= $row["od_fechaEnt"];
			$a_despacho["od_tipo_entrega"]	= $row["od_tipo_entrega"];
			$a_despacho["od_direccion1"]	= $row["od_direccion1"];
			$a_despacho["od_direccion2"]	= $row["od_direccion2"];
			$a_despacho["od_ciudad"]		= $row["od_ciudad"];
			$a_despacho["od_estado"]		= $row["od_estado"];
			$a_despacho["od_pais"]			= $row["od_pais"];
			$a_despacho["od_obs"]			= $row["od_obs"];
			$a_despacho["od_glosa"]			= $row["od_glosa"];
			$a_despacho["od_ubigeo"]			= $row["od_ubigeo"];
			$a_despacho["od_tipo_transporte"]	= $row["od_tipo_transporte"];
			$a_despacho["od_transp_doc_tipo"]	= $row["od_transp_doc_tipo"];
			$a_despacho["od_transp_doc_nro"]	= $row["od_transp_doc_nro"];
			$a_despacho["od_transp_nombre"]		= $row["od_transp_nombre"];
			$a_despacho["od_transp_placa"]		= $row["od_transp_placa"];
			$a_despacho["od_cli_tipo_doc"]		= $row["od_cli_tipo_doc"];
			$a_despacho["od_cli_correo"]		= $row["od_cli_correo"];
			$a_despacho["od_status"]		= $row["od_status"];
			$a_despacho["od_usrreg"]		= $row["od_usrreg"];
			$a_despacho["od_usract"]		= $row["od_usract"];
			$a_despacho["od_fecreg"]		= $row["od_fecreg"];
			$a_despacho["od_fecact"]		= $row["od_fecact"];
			$a_despacho["ser_serie"]		= $row["ser_serie"];

			if (!$row["od_cli_nombre"]){
				$a_despacho["cli_nombre"] = $row["cl_nombre"];
			}else{
				$a_despacho["cli_nombre"] = $row["od_cli_nombre"];
			}
			$a_despacho["alm_nombre"]		= $row["alm_nombre"];
			$a_despacho["od_status_nombre"] = $row["status_nombre"];
			$a_despacho["od_tipo_nombre"]	= $row["tipo_nombre"];
			if ($row["sal_id"]){
				$a_despacho["sal_id"] = $row["sal_id"];
			}
			if ($OrdenDespachoObj->incDetalle){
				$query = "
					SELECT *
					FROM im_ordenDespacholinea
						LEFT JOIN im_producto ON odl_prId = pr_id
					WHERE odl_id = ".$a_despacho["od_id"];
				$sentencia2 = $PDO->query($query);
				$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
				while ($row2 = $sentencia2->fetch()){
					$a_odl["pr_productoId"] = $row2["pr_productoId"];
					$a_odl["odl_cantidad"] = $row2["odl_cantidad"];
					$query3 = "
						SELECT *
						FROM im_ordenDespachoserie
							LEFT JOIN im_serie ON ods_ser_id = ser_id
						WHERE ods_lineaId = ".$row2["odl_lineaId"];
					$sentencia3 = $PDO->query($query3);
					$sentencia3->setFetchMode(PDO::FETCH_ASSOC);
					while ($row3 = $sentencia3->fetch()){
						$a_odl["series"][] = $row3["ser_serie"];			
					}
					$a_linea[] = $a_odl;
					unset($a_odl);
				}
				$a_despacho["detalle"]	= $a_linea;
				unset($a_linea);
			}			
			$a_despachoList[]				= $a_despacho;
		}
		return $a_despachoList;

	}


	public function update($OrdenDespachoObj){
		global $usuario, $PDO;

		if ($OrdenDespachoObj->od_tipo){
			$set .= ",od_tipo = :od_tipo";
		}
		if ($OrdenDespachoObj->od_tipo_sunat){
			$set .= ",od_tipo_sunat = :od_tipo_sunat";
		}
		if ($OrdenDespachoObj->od_almacenId){
			$set .= ",od_almacenId = :od_almacenId";
		}
		if (isset($OrdenDespachoObj->od_pdte_regulariza)){
			$set .= ",od_pdte_regulariza = :od_pdte_regulariza";
		}
		if ($OrdenDespachoObj->od_cli_id){
			$set .= ",od_cli_id = :od_cli_id";
		}
		if ($OrdenDespachoObj->od_cli_ruc){
			$set .= ",od_cli_ruc = :od_cli_ruc";
		}
		if ($OrdenDespachoObj->od_cli_nombre){
			$set .= ",od_cli_nombre = :od_cli_nombre";
		}
		if ($OrdenDespachoObj->od_contacto){
			$set .= ",od_loteId = :od_contacto";
		}
		if ($OrdenDespachoObj->od_so_id){
			$set .= ",od_so_id = :od_so_id";
		}
		if ($OrdenDespachoObj->od_wo_id){
			$set .= ",od_wo_id = :od_wo_id";
		}
		if ($OrdenDespachoObj->od_refDocId){
			$set .= ",od_refDocId = :od_refDocId";
		}
		if ($OrdenDespachoObj->od_refDocId2){
			$set .= ",od_refDocId2 = :od_refDocId2";
		}
		if ($OrdenDespachoObj->od_fechaDoc){
			$set .= ",od_fechaDoc = :od_fechaDoc";
		}
		if ($OrdenDespachoObj->od_fechaReq){
			$set .= ",od_fechaReq = :od_fechaReq";
		}
		if ($OrdenDespachoObj->od_fechaEnt){
			$set .= ",od_fechaEnt = :od_fechaEnt";
		}
		if ($OrdenDespachoObj->od_tipo_entrega){
			$set .= ",od_tipo_entrega = :od_tipo_entrega";
		}
		if ($OrdenDespachoObj->od_direccion1){
			$set .= ",od_direccion1 = :od_direccion1";
		}
		if ($OrdenDespachoObj->od_direccion2){
			$set .= ",od_direccion2 = :od_direccion2";
		}
		if ($OrdenDespachoObj->od_ciudad){
			$set .= ",od_ciudad = :od_ciudad";
		}
		if ($OrdenDespachoObj->od_estado){
			$set .= ",od_estado = :od_estado";
		}
		if ($OrdenDespachoObj->od_pais){
			$set .= ",od_pais = :od_pais";
		}
		if ($OrdenDespachoObj->od_obs){
			$set .= ",od_obs = :od_obs";
		}
		if ($OrdenDespachoObj->od_glosa){
			$set .= ",od_glosa = :od_glosa";
		}

		if ($OrdenDespachoObj->od_ubigeo){
			$set .= ",od_ubigeo = :od_ubigeo";
		}
		if ($OrdenDespachoObj->od_tipo_transporte){
			$set .= ",od_tipo_transporte = :od_tipo_transporte";
		}
		if ($OrdenDespachoObj->od_transp_doc_tipo){
			$set .= ",od_transp_doc_tipo = :od_transp_doc_tipo";
		}
		if ($OrdenDespachoObj->od_transp_doc_nro){
			$set .= ",od_transp_doc_nro = :od_transp_doc_nro";
		}
		if ($OrdenDespachoObj->od_transp_nombre){
			$set .= ",od_transp_nombre = :od_transp_nombre";
		}
		if ($OrdenDespachoObj->od_transp_placa){
			$set .= ",od_transp_placa = :od_transp_placa";
		}
		if ($OrdenDespachoObj->od_cli_tipo_doc){
			$set .= ",od_cli_tipo_doc = :od_cli_tipo_doc";
		}
		if ($OrdenDespachoObj->od_cli_correo){
			$set .= ",od_cli_correo = :od_cli_correo";
		}

		if ($OrdenDespachoObj->od_status){
			$set .= ",od_status = :od_status";
		}
		if ($set){
			$set = substr($set,1);
			$OrdenDespachoObj->od_fecact = date("Y-m-d H:i:s");
			$sql2 = "
				UPDATE im_ordenDespacho
				SET 
					$set
					,od_usract = :usract
					,od_fecact = :fecact
				WHERE od_id = :od_id
				LIMIT 1";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':od_id', $OrdenDespachoObj->od_id);
			$comando->bindParam(':usract', $usuario);
			$comando->bindParam(':fecact', $OrdenDespachoObj->od_fecact);

			if ($OrdenDespachoObj->od_tipo){
				$comando->bindParam(':od_tipo', $OrdenDespachoObj->od_tipo);
			}
			if ($OrdenDespachoObj->od_tipo_sunat){
				$comando->bindParam(':od_tipo_sunat', $OrdenDespachoObj->od_tipo_sunat);
			}
			if ($OrdenDespachoObj->od_almacenId){
				$comando->bindParam(':od_almacenId', $OrdenDespachoObj->od_almacenId);
			}
			if (isset($OrdenDespachoObj->od_pdte_regulariza)){			
				$comando->bindParam(':od_pdte_regulariza', $OrdenDespachoObj->od_pdte_regulariza);
			}
			if ($OrdenDespachoObj->od_cli_id){
				$comando->bindParam(':od_cli_id', $OrdenDespachoObj->od_cli_id);
			}
			if ($OrdenDespachoObj->od_cli_ruc){
				$comando->bindParam(':od_cli_ruc', $OrdenDespachoObj->od_cli_ruc);
			}
			if ($OrdenDespachoObj->od_cli_nombre){
				$comando->bindParam(':od_cli_nombre', $OrdenDespachoObj->od_cli_nombre);
			}
			if ($OrdenDespachoObj->od_contacto){
				$comando->bindParam(':od_contacto', $OrdenDespachoObj->od_contacto);
			}
			if ($OrdenDespachoObj->od_so_id){
				$comando->bindParam(':od_so_id', $OrdenDespachoObj->od_so_id);
			}
			if ($OrdenDespachoObj->od_wo_id){
				$comando->bindParam(':od_wo_id', $OrdenDespachoObj->od_wo_id);
			}
			if ($OrdenDespachoObj->od_refDocId){
				$comando->bindParam(':od_refDocId', $OrdenDespachoObj->od_refDocId);
			}
			if ($OrdenDespachoObj->od_refDocId2){
				$comando->bindParam(':od_refDocId2', $OrdenDespachoObj->od_refDocId2);
			}
			if ($OrdenDespachoObj->od_fechaDoc){
				$comando->bindParam(':od_fechaDoc', $OrdenDespachoObj->od_fechaDoc);
			}
			if ($OrdenDespachoObj->od_fechaReq){
				$comando->bindParam(':od_fechaReq', $OrdenDespachoObj->od_fechaReq);
			}
			if ($OrdenDespachoObj->od_fechaEnt){
				$comando->bindParam(':od_fechaEnt', $OrdenDespachoObj->od_fechaEnt);
			}
			if ($OrdenDespachoObj->od_tipo_entrega){
				$comando->bindParam(':od_tipo_entrega', $OrdenDespachoObj->od_tipo_entrega);
			}
			if ($OrdenDespachoObj->od_direccion1){
				$comando->bindParam(':od_direccion1', $OrdenDespachoObj->od_direccion1);
			}
			if ($OrdenDespachoObj->od_direccion2){
				$comando->bindParam(':od_direccion2', $OrdenDespachoObj->od_direccion2);
			}
			if ($OrdenDespachoObj->od_ciudad){
				$comando->bindParam(':od_ciudad', $OrdenDespachoObj->od_ciudad);
			}
			if ($OrdenDespachoObj->od_estado){
				$comando->bindParam(':od_estado', $OrdenDespachoObj->od_estado);
			}
			if ($OrdenDespachoObj->od_pais){
				$comando->bindParam(':od_pais', $OrdenDespachoObj->od_pais);
			}
			if ($OrdenDespachoObj->od_obs){
				$comando->bindParam(':od_obs', $OrdenDespachoObj->od_obs);
			}
			if ($OrdenDespachoObj->od_glosa){
				$comando->bindParam(':od_glosa', $OrdenDespachoObj->od_glosa);
			}


			if ($OrdenDespachoObj->od_ubigeo){
				$comando->bindParam(':od_ubigeo', $OrdenDespachoObj->od_ubigeo);
			}
			if ($OrdenDespachoObj->od_tipo_transporte){
				$comando->bindParam(':od_tipo_transporte', $OrdenDespachoObj->od_tipo_transporte);
			}
			if ($OrdenDespachoObj->od_transp_doc_tipo){
				$comando->bindParam(':od_transp_doc_tipo', $OrdenDespachoObj->od_transp_doc_tipo);
			}
			if ($OrdenDespachoObj->od_transp_doc_nro){
				$comando->bindParam(':od_transp_doc_nro', $OrdenDespachoObj->od_transp_doc_nro);
			}
			if ($OrdenDespachoObj->od_transp_nombre){
				$comando->bindParam(':od_transp_nombre', $OrdenDespachoObj->od_transp_nombre);
			}
			if ($OrdenDespachoObj->od_transp_placa){
				$comando->bindParam(':od_transp_placa', $OrdenDespachoObj->od_transp_placa);
			}
			if ($OrdenDespachoObj->od_cli_tipo_doc){
				$comando->bindParam(':od_cli_tipo_doc', $OrdenDespachoObj->od_cli_tipo_doc);
			}
			if ($OrdenDespachoObj->od_cli_correo){
				$comando->bindParam(':od_cli_correo', $OrdenDespachoObj->od_cli_correo);
			}

			if ($OrdenDespachoObj->od_status){
				$comando->bindParam(':od_status', $OrdenDespachoObj->od_status);
			}

			$comando->execute();
			print_r($comando->errorInfo());
			return $OrdenDespachoObj->od_id;
		}
	}


	public function insert($OrdenDespachoObj){
		global $usuario,$PDO;
		$OrdenDespachoObj->od_status = 'P';
		$sql = "
			INSERT INTO `im_ordenDespacho` 
			(
			od_tipo,
			od_tipo_sunat,
			od_almacenId,
			od_pdte_regulariza,
			od_cli_id,
			od_cli_ruc,
			od_cli_nombre,
			od_contacto,
			od_so_id,
			od_wo_id,
			od_refDocId,
			od_refDocId2,
			od_fechaDoc,
			od_fechaReq,
			od_fechaEnt,
			od_tipo_entrega,
			od_direccion1,
			od_direccion2,
			od_ciudad,
			od_estado,
			od_pais,
			od_obs,
			od_glosa,
			od_ubigeo,
			od_tipo_transporte, 
			od_transp_doc_tipo,
			od_transp_doc_nro,
			od_transp_nombre,
			od_transp_placa,
			od_cli_tipo_doc,
			od_cli_correo,
			od_status,
			od_fecreg,
			od_usrreg
			) 
			VALUES 
			(
			:od_tipo,
			:od_tipo_sunat,
			:od_almacenId,
			:od_pdte_regulariza,
			:od_cli_id,
			:od_cli_ruc,
			:od_cli_nombre,
			:od_contacto,
			:od_so_id,
			:od_wo_id,
			:od_refDocId,
			:od_refDocId2,
			:od_fechaDoc,
			:od_fechaReq,
			:od_fechaEnt,
			:od_tipo_entrega,
			:od_direccion1,
			:od_direccion2,
			:od_ciudad,
			:od_estado,
			:od_pais,
			:od_obs,
			:od_glosa,
			:od_ubigeo,
			:od_tipo_transporte, 
			:od_transp_doc_tipo,
			:od_transp_doc_nro,
			:od_transp_nombre,
			:od_transp_placa,
			:od_cli_tipo_doc,
			:od_cli_correo,
			:od_status,
			:od_fecreg,
			:od_usrreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$OrdenDespachoObj->od_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':od_tipo', $OrdenDespachoObj->od_tipo);
		$comando->bindParam(':od_tipo_sunat', $OrdenDespachoObj->od_tipo_sunat);
		$comando->bindParam(':od_almacenId', $OrdenDespachoObj->od_almacenId);
		$comando->bindParam(':od_pdte_regulariza', $OrdenDespachoObj->od_pdte_regulariza);
		$comando->bindParam(':od_cli_id', $OrdenDespachoObj->od_cli_id);
		$comando->bindParam(':od_cli_ruc', $OrdenDespachoObj->od_cli_ruc);
		$comando->bindParam(':od_cli_nombre', $OrdenDespachoObj->od_cli_nombre);
		$comando->bindParam(':od_contacto', $OrdenDespachoObj->od_contacto);
		$comando->bindParam(':od_so_id', $OrdenDespachoObj->od_so_id);
		$comando->bindParam(':od_wo_id', $OrdenDespachoObj->od_wo_id);
		$comando->bindParam(':od_refDocId', $OrdenDespachoObj->od_refDocId);
		$comando->bindParam(':od_refDocId2', $OrdenDespachoObj->od_refDocId2);
		$comando->bindParam(':od_fechaDoc', $OrdenDespachoObj->od_fechaDoc);
		$comando->bindParam(':od_fechaReq', $OrdenDespachoObj->od_fechaReq);
		$comando->bindParam(':od_fechaEnt', $OrdenDespachoObj->od_fechaEnt);
		$comando->bindParam(':od_tipo_entrega', $OrdenDespachoObj->od_tipo_entrega);
		$comando->bindParam(':od_direccion1', $OrdenDespachoObj->od_direccion1);
		$comando->bindParam(':od_direccion2', $OrdenDespachoObj->od_direccion2);	
		$comando->bindParam(':od_ciudad', $OrdenDespachoObj->od_ciudad);
		$comando->bindParam(':od_estado', $OrdenDespachoObj->od_estado);
		$comando->bindParam(':od_pais', $OrdenDespachoObj->od_pais);
		$comando->bindParam(':od_obs', $OrdenDespachoObj->od_obs);
		$comando->bindParam(':od_glosa', $OrdenDespachoObj->od_glosa);

		$comando->bindParam(':od_ubigeo', $OrdenDespachoObj->od_ubigeo);
		$comando->bindParam(':od_tipo_transporte', $OrdenDespachoObj->od_tipo_transporte);
		$comando->bindParam(':od_transp_doc_tipo', $OrdenDespachoObj->od_transp_doc_tipo);
		$comando->bindParam(':od_transp_doc_nro', $OrdenDespachoObj->od_transp_doc_nro);
		$comando->bindParam(':od_transp_nombre', $OrdenDespachoObj->od_transp_nombre);
		$comando->bindParam(':od_transp_placa', $OrdenDespachoObj->od_transp_placa);
		$comando->bindParam(':od_cli_tipo_doc', $OrdenDespachoObj->od_cli_tipo_doc);
		$comando->bindParam(':od_cli_correo', $OrdenDespachoObj->od_cli_correo);

		$comando->bindParam(':od_status', $OrdenDespachoObj->od_status);
		$comando->bindParam(':od_fecreg', $OrdenDespachoObj->od_fecreg);
		$comando->bindParam(':od_usrreg', $OrdenDespachoObj->od_usrreg);
		$comando->execute();
//print_r($comando->errorInfo());
		$query	 = "
			SELECT 
			DISTINCT max(od_id) as id 
			FROM im_ordenDespacho 
			WHERE od_fecreg = '".$OrdenDespachoObj->od_fecreg."' AND od_usrreg = '".$OrdenDespachoObj->od_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}
}



class ImOrdenDespachoLineaModel{

	public function insert($OrdenDespachoLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			im_ordenDespacholinea 
			(
			odl_id, 
			odl_prId,
			odl_cantidad,
			odl_peso,
			odl_obs,
			odl_odp_id,
			odl_fecreg,
			odl_usrreg
			) 
			VALUES 
			(
			:odl_id,
			:odl_prId,
			:odl_cantidad,		
			:odl_peso,
			:odl_obs, 
			:odl_odp_id, 
			:odl_fecreg, 
			:odl_usrreg
			);			
		";
		if (!$OrdenDespachoLineaObj->odl_odp_id){
			$OrdenDespachoLineaObj->odl_odp_id = '';
		}
		$comando = $PDO->prepare($sql);
		$OrdenDespachoLineaObj->odl_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':odl_id', $OrdenDespachoLineaObj->odl_id);
		$comando->bindParam(':odl_prId', $OrdenDespachoLineaObj->odl_prId);
		$comando->bindParam(':odl_cantidad', $OrdenDespachoLineaObj->odl_cantidad);
		$comando->bindParam(':odl_peso', $OrdenDespachoLineaObj->odl_peso);
		$comando->bindParam(':odl_obs', $OrdenDespachoLineaObj->odl_obs);
		$comando->bindParam(':odl_odp_id', $OrdenDespachoLineaObj->odl_odp_id);
		$comando->bindParam(':odl_fecreg', $OrdenDespachoLineaObj->odl_fecreg);
		$comando->bindParam(':odl_usrreg', $OrdenDespachoLineaObj->odl_usrreg);
		$comando->execute();
//print_r($comando->errorInfo());
//exit;
		$query	 = "
			SELECT DISTINCT max(odl_lineaId) as id 
			FROM im_ordenDespacholinea 
			WHERE odl_fecreg = '".$OrdenDespachoLineaObj->odl_fecreg."' 
				AND odl_usrreg = '".$OrdenDespachoLineaObj->odl_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function update($OrdenDespachoLineaObj){
		global $usuario, $PDO;
		if ($OrdenDespachoLineaObj->odl_prId){
			$set .= ",odl_prId = :odl_prId";
		}
		if ($OrdenDespachoLineaObj->odl_cantidad){
			$set .= ",odl_cantidad = :odl_cantidad";
		}
		if ($OrdenDespachoLineaObj->odl_peso){
			$set .= ",odl_peso = :odl_peso";
		}
		if ($OrdenDespachoLineaObj->odl_cantidad_resta){
			$set .= ",odl_cantidad = (odl_cantidad - :odl_cantidad_resta)";
		}
		if ($OrdenDespachoLineaObj->odl_obs){
			$set .= ",odl_obs = :odl_obs";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_ordenDespacholinea
				SET 
					$set
					,odl_usract = :odl_usract
				WHERE 
					odl_id = :odl_id
					AND odl_lineaId = :odl_lineaId
				LIMIT 1";		
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':odl_id', $OrdenDespachoLineaObj->odl_id);
			$comando->bindParam(':odl_lineaId', $OrdenDespachoLineaObj->odl_lineaId);
			$comando->bindParam(':odl_usract', $usuario);
			if ($OrdenDespachoLineaObj->odl_prId){
				$comando->bindParam(':odl_prId', $OrdenDespachoLineaObj->odl_prId);
			}
			if ($OrdenDespachoLineaObj->odl_cantidad){
				$comando->bindParam(':odl_cantidad', $OrdenDespachoLineaObj->odl_cantidad);
			}
			if ($OrdenDespachoLineaObj->odl_peso){
				$comando->bindParam(':odl_peso', $OrdenDespachoLineaObj->odl_peso);
			}
			if ($OrdenDespachoLineaObj->odl_cantidad_resta){
				$comando->bindParam(':odl_cantidad_resta', $OrdenDespachoLineaObj->odl_cantidad_resta);
			}
			if ($OrdenDespachoLineaObj->odl_obs){
				$comando->bindParam(':odl_obs', $OrdenDespachoLineaObj->odl_obs);
			}
			$comando->execute();
			return $OrdenDespachoLineaObj->odl_lineaId;
		}
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ordenDespacholinea
			WHERE odl_lineaId = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id,$chkCant=''){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		if ($chkCant){
			$where = " AND odl_cantidad > 0 ";
		}
		$sql = "
			SELECT *
			FROM im_ordenDespacholinea
				LEFT JOIN im_producto P ON odl_prId = pr_id
				LEFT JOIN im_ordenDespachopendiente ON odl_odp_id = odp_id
				LEFT JOIN im_ordenDespacho D ON odl_id = od_id
				LEFT JOIN im_stock ON odl_prId = stk_prId AND od_almacenId = stk_almacenId
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE odl_id = :odl_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':odl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["odl_id"]			= $row["odl_id"];
			$a_linea["odl_lineaId"]		= $row["odl_lineaId"];
			$a_linea["odl_prId"]		= $row["odl_prId"];
			$a_linea["odl_cantidad"]	= $row["odl_cantidad"];
			$a_linea["odl_peso"]		= $row["odl_peso"];
			$a_linea["odl_obs"]			= $row["odl_obs"];
			$a_linea["od_glosa"]		= $row["od_glosa"];
			$a_linea["odl_odp_id"]		= $row["odl_odp_id"];			
			$a_linea["odl_usrreg"]		= $row["odl_usrreg"];
			$a_linea["odl_usract"]		= $row["odl_usract"];
			$a_linea["odl_fecreg"]		= $row["odl_fecreg"];
			$a_linea["odl_fecact"]		= $row["odl_fecact"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_linea["pr_uom"]			= $row["pr_uom"];
			$a_linea["pr_ctrlSerie"]	= $row["pr_ctrlSerie"];			
			$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
			$a_linea["stk_fisico"]		= $row["stk_fisico"];
			$a_linea["odp_refDocId"]	= $row["odp_refDocId"];
			
			$a_despacholinea[]			= $a_linea;
		}
		return $a_despacholinea;
			

	}


	public function selectUniqueIdGroupPrId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, SUM(odl_cantidad) AS cantidad, odl_peso AS peso
			FROM im_ordenDespacholinea
				LEFT JOIN im_producto P ON odl_prId = pr_id
				LEFT JOIN im_ordenDespacho D ON odl_id = od_id
				LEFT JOIN im_stock ON odl_prId = stk_prId AND od_almacenId = stk_almacenId
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE odl_id = :odl_id
			$where
			GROUP BY odl_prId
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':odl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["odl_id"]			= $row["odl_id"];
			$a_linea["odl_lineaId"]		= $row["odl_lineaId"];
			$a_linea["odl_prId"]		= $row["odl_prId"];
			$a_linea["odl_cantidad"]	= $row["cantidad"];
			$a_linea["odl_peso"]		= $row["peso"];
			$a_linea["odl_obs"]			= $row["odl_obs"];
			$a_linea["odl_usrreg"]		= $row["odl_usrreg"];
			$a_linea["odl_usract"]		= $row["odl_usract"];
			$a_linea["odl_fecreg"]		= $row["odl_fecreg"];
			$a_linea["odl_fecact"]		= $row["odl_fecact"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_linea["pr_uom"]			= $row["pr_uom"];
			$a_linea["pr_ctrlSerie"]	= $row["pr_ctrlSerie"];			
			$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
			$a_linea["stk_fisico"]		= $row["stk_fisico"];
			$a_despacholinea[]			= $a_linea;
		}
		return $a_despacholinea;
			

	}



	public function select($OrdenDespachoFilter){
		global $PDO;
		if ($OrdenDespachoFilter->odl_id){
			$where .=  " AND odl_id = :odl_id";
		}
		if ($OrdenDespachoFilter->pr_ctrlSerie){
			$where .=  " AND pr_ctrlSerie = :pr_ctrlSerie";
		}
		if ($OrdenDespachoFilter->odl_lineaId){
			$where .=  " AND odl_lineaId = :odl_lineaId";
		}
		if ($OrdenDespachoFilter->odl_prId){
			$where .=  " AND odl_prId = :odl_prId";
		}
		if ($where){
			$sql = "
				SELECT *
				FROM im_ordenDespacholinea
				LEFT JOIN im_ordenDespachopendiente ON odl_odp_id = odp_id
				LEFT JOIN im_producto ON odl_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($OrdenDespachoFilter->odl_id){
				$comando->bindParam(':odl_id', $OrdenDespachoFilter->odl_id);
			}
			if ($OrdenDespachoFilter->odl_lineaId){
				$comando->bindParam(':odl_lineaId', $OrdenDespachoFilter->odl_lineaId);
			}
			if ($OrdenDespachoFilter->odl_prId){
				$comando->bindParam(':odl_prId', $OrdenDespachoFilter->odl_prId);
			}
			if ($OrdenDespachoFilter->pr_ctrlSerie){
				$comando->bindParam(':pr_ctrlSerie', $OrdenDespachoFilter->pr_ctrlSerie);
			}

			$comando->execute();
			//print_r($comando->errorInfo());
			while($row = $comando->fetch()){
				$a_linea["odl_id"]			= $row["odl_id"];
				$a_linea["odl_lineaId"]		= $row["odl_lineaId"];
				$a_linea["odl_prId"]		= $row["odl_prId"];
				$a_linea["odl_cantidad"]	= $row["odl_cantidad"];
				$a_linea["odl_peso"]		= $row["odl_peso"];
				$a_linea["odl_obs"]			= $row["odl_obs"];
				$a_linea["odl_usrreg"]		= $row["odl_usrreg"];
				$a_linea["odl_usract"]		= $row["odl_usract"];
				$a_linea["odl_fecreg"]		= $row["odl_fecreg"];
				$a_linea["odl_fecact"]		= $row["odl_fecact"];
				$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
				$a_linea["pr_productoId"]	= $row["pr_productoId"];
				$a_linea["pr_ctrlSerie"]	= $row["pr_ctrlSerie"];
				$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
				$a_linea["odp_refDocId"]	= $row["odp_refDocId"];
				$a_despacholinea[]			= $a_linea;
			}
			return $a_despacholinea;
			
		}
	}

	public function selectLineaArticulo($despachoId,$productoId){
		global $PDO;
		if (!$despachoId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ordenDespacholinea
				LEFT JOIN im_producto ON odl_prId = pr_id
			WHERE odl_id = '".$despachoId."'				
				AND odl_prId = '".$productoId."'
		";
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["odl_prId"]		= $row["odl_prId"];
			$a_linea["odl_cantidad"]	= $row["odl_cantidad"];
			$a_linea["odl_peso"]		= $row["odl_peso"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["odl_lineaId"]		= $row["odl_lineaId"];
		}
		return $a_linea;
	}

}













class ImOrdenDespachoSerieModel{

	public function insert($OrdenDespachoSerieObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			im_ordenDespachoserie 
			( 
			ods_od_id,
			ods_lineaId,
			ods_ser_id,
			ods_fecreg,
			ods_usrreg
			) 
			VALUES 
			(
			:ods_od_id,
			:ods_lineaId,
			:ods_ser_id,			
			:ods_fecreg, 
			:ods_usrreg
			);			
		";
		$comando = $PDO->prepare($sql);
		if (!$usuario){
			$OrdenDespachoSerieObj->ods_usrreg = "no-identificado";
		}else{
			$OrdenDespachoSerieObj->ods_usrreg = $usuario;
		}
		$OrdenDespachoSerieObj->ods_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':ods_od_id', $OrdenDespachoSerieObj->ods_od_id);
		$comando->bindParam(':ods_lineaId', $OrdenDespachoSerieObj->ods_lineaId);
		$comando->bindParam(':ods_ser_id', $OrdenDespachoSerieObj->ods_ser_id);
		$comando->bindParam(':ods_fecreg', $OrdenDespachoSerieObj->ods_fecreg);
		$comando->bindParam(':ods_usrreg', $OrdenDespachoSerieObj->ods_usrreg);
		$comando->execute();

		$query	 = "
			SELECT DISTINCT max(ods_id) as id 
			FROM im_ordenDespachoserie 
			WHERE ods_fecreg = '".$OrdenDespachoSerieObj->ods_fecreg."' 
				AND ods_usrreg = '".$OrdenDespachoSerieObj->ods_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}



	public function delete($id){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ordenDespachoserie
			WHERE ods_id = :ods_id
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':ods_id', $id);
		$comando->execute();
		return $lineaId;
	}

	public function deleteSeriesLinea($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM im_ordenDespachoserie
			WHERE ods_lineaId = :lineaId
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ordenDespachoserie
				LEFT JOIN im_serie ON ods_ser_id = ser_id
				LEFT JOIN im_producto P ON ser_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE odl_id = :odl_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':odl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["ods_id"]			= $row["ods_id"];
			$a_linea["ods_lineaId"]		= $row["ods_lineaId"];
			$a_linea["ods_prId"]		= $row["ser_prId"];
			$a_linea["ods_usrreg"]		= $row["ods_usrreg"];
			$a_linea["ods_fecreg"]		= $row["ods_fecreg"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
			$a_despacholinea[]			= $a_linea;
		}
		return $a_despacholinea;
			

	}


	public function select($OrdenDespachoFilter){
		global $PDO;
		if ($OrdenDespachoFilter->ods_od_id){
			$where .=  " AND ods_od_id = :ods_od_id";
		}
		if ($OrdenDespachoFilter->ods_lineaId){
			$where .=  " AND ods_lineaId = :ods_lineaId";
		}
		if ($OrdenDespachoFilter->odl_prId){
			$where .=  " AND odl_prId = :odl_prId";
		}
		if ($OrdenDespachoFilter->ser_serie){
			$where .=  " AND ser_serie = :ser_serie";
		}

		if ($where){
			$sql = "
				SELECT *
				FROM im_ordenDespachoserie
				LEFT JOIN im_ordenDespacholinea ON ods_lineaId = odl_lineaId
				LEFT JOIN im_serie ON ods_ser_id = ser_id
				LEFT JOIN im_producto ON ser_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($OrdenDespachoFilter->ods_od_id){
				$comando->bindParam(':ods_od_id', $OrdenDespachoFilter->ods_od_id);
			}
			if ($OrdenDespachoFilter->ods_lineaId){
				$comando->bindParam(':ods_lineaId', $OrdenDespachoFilter->ods_lineaId);
			}
			if ($OrdenDespachoFilter->odl_prId){
				$comando->bindParam(':odl_prId', $OrdenDespachoFilter->odl_prId);
			}
			if ($OrdenDespachoFilter->ser_serie){
				$comando->bindParam(':ser_serie', $OrdenDespachoFilter->ser_serie);
			}

			$comando->execute();
//			print_r($OrdenDespachoFilter);
//			exit($sql);
			//print_r($comando->errorInfo());
			while($row = $comando->fetch()){
				$a_linea["ods_id"]			= $row["ods_id"];
				$a_linea["ods_od_id"]		= $row["ods_od_id"];
				$a_linea["ods_lineaId"]		= $row["ods_lineaId"];
				$a_linea["ser_prId"]		= $row["ser_prId"];
				$a_linea["ser_serie"]		= $row["ser_serie"];
				$a_linea["ser_id"]			= $row["ser_id"];
				$a_linea["ods_ser_id"]		= $row["ods_ser_id"];
				$a_linea["pr_productoId"]	= $row["pr_productoId"];
				$a_linea["ods_usrreg"]		= $row["ods_usrreg"];
				$a_linea["ods_fecreg"]		= $row["ods_fecreg"];
				$a_linea["sfm_nombre"]		= $row["sfm_nombre"];
				$a_despachoserie[]			= $a_linea;
			}
			return $a_despachoserie;
			
		}
	}

	public function selectSerieArticulo($despachoId,$productoId){
		global $PDO;
		if (!$despachoId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_ordenDespachoserie
				LEFT JOIN im_serie ON ods_ser_id = ser_id
			WHERE ods_od_id = '".$despachoId."'				
				AND ser_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["ser_prId"] = $row["ser_prId"];
		}
		return $a_linea;
	}

}



/*
class ImOrdenDespachoPdteModel{

	public function insert($OrdenDespachoLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO im_ordenDespachopendiente
			(
			odp_tipo, 
			odp_od_id,
			odp_cli_id,
			odp_cli_nombre,
			odp_fecha,
			odp_refDocId,
			odp_refDocId2,
			odp_pr_id,
			odp_cantidad,
			odp_cantidad_pdte,
			odp_obs
			)
			VALUES
			(
			:odp_tipo, 
			:odp_od_id,
			:odp_cli_id,
			:odp_cli_nombre,
			:odp_fecha,
			:odp_refDocId,
			:odp_refDocId2,
			:odp_pr_id,
			:odp_cantidad,
			:odp_cantidad_pdte,
			:odp_obs
			);		
		";
		$comando = $PDO->prepare($sql);
		$OrdenDespachoLineaObj->odp_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':odp_tipo', $OrdenDespachoLineaObj->odp_tipo);
		$comando->bindParam(':odp_od_id', $OrdenDespachoLineaObj->odp_od_id);
		$comando->bindParam(':odp_cli_id', $OrdenDespachoLineaObj->odp_cli_id);
		$comando->bindParam(':odp_cli_nombre', $OrdenDespachoLineaObj->odp_cli_nombre);
		$comando->bindParam(':odp_fecha', $OrdenDespachoLineaObj->odp_fecha);
		$comando->bindParam(':odp_refDocId', $OrdenDespachoLineaObj->odp_refDocId);
		$comando->bindParam(':odp_refDocId2', $OrdenDespachoLineaObj->odp_refDocId2);
		$comando->bindParam(':odp_pr_id', $OrdenDespachoLineaObj->odp_pr_id);
		$comando->bindParam(':odp_cantidad', $OrdenDespachoLineaObj->odp_cantidad);
		$comando->bindParam(':odp_cantidad_pdte', $OrdenDespachoLineaObj->odp_cantidad_pdte);
		$comando->bindParam(':odp_obs', $OrdenDespachoLineaObj->odp_obs);
		$comando->execute();
		$query	 = "
			SELECT DISTINCT max(odp_id) as id 
			FROM im_ordenDespachopendiente 
			WHERE odp_fecact = '".$OrdenDespachoLineaObj->odp_fecreg."' 
				AND odp_usract = '".$usuario."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}
}

*/




?>