<?php

class ImSolicDespachoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM im_solicDespacho
				LEFT JOIN xx_maestrolista MSTAT ON sd_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'imSdStatus'
				LEFT JOIN xx_maestrolista MTIPO ON sd_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'imSdTipo'
			WHERE sd_id = :id
		";					
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_despacho["sd_id"]			= $row["sd_id"];
		$a_despacho["sd_tipo"]			= $row["sd_tipo"];
		$a_despacho["sd_obs"]			= $row["sd_obs"];
		$a_despacho["sd_status"]		= $row["sd_status"];
		$a_despacho["sd_docRefId"]		= $row["sd_docRefId"];		
		$a_despacho["sd_usrreg"]		= $row["sd_usrreg"];
		$a_despacho["sd_usraprob"]		= $row["sd_usraprob"];
		$a_despacho["sd_usract"]		= $row["sd_usract"];
		$a_despacho["sd_fecreg"]		= $row["sd_fecreg"];
		$a_despacho["sd_fecaprob"]		= $row["sd_fecaprob"];
		$a_despacho["sd_fecact"]		= $row["sd_fecact"];
		$a_despacho["sd_status_nombre"] = $row["status_nombre"];
		$a_despacho["sd_tipo_nombre"]	= $row["tipo_nombre"];
		return $a_despacho;
	}



	public function select($ImSolicDespachoObj,$limit=''){
		global $usuario, $PDO;
		if ($ImSolicDespachoObj->sd_id){
			$where .= " AND sd_id = :sd_id";
		}
		if ($ImSolicDespachoObj->sd_tipo){
			$where .= " AND sd_tipo = :sd_tipo";
		}
		if ($ImSolicDespachoObj->sd_usrreg){
			$where .= " AND sd_usrreg = :sd_usrreg";
		}
		if ($ImSolicDespachoObj->fechaIni){
			$where .= " AND sd_fecreg >= :fechaIni";
		}
		if ($ImSolicDespachoObj->fechaFin){
			$where .= " AND sd_fecreg <= :fechaFin";
		}
		if ($ImSolicDespachoObj->sd_status){
			if ($ImSolicDespachoObj->sd_status != '*'){
				$where .= " AND sd_status = :sd_status";
			}else{
				$where .= " AND sd_status = ''";
			}
		}
		if ($ImSolicDespachoObj->orderBy){
			$orderBy = " ORDER BY ".$ImSolicDespachoObj->orderBy;
		}else{
			$orderBy = " ORDER BY sd_id";
		}

		$sql = "
			SELECT  *, 
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM im_solicDespacho
				LEFT JOIN xx_maestrolista MSTAT ON sd_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'imSdStatus'
				LEFT JOIN xx_maestrolista MTIPO ON sd_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'imSdTipo'
			WHERE 1 $where
			GROUP BY sd_id
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($ImSolicDespachoObj->sd_id){
			$comando->bindParam(':sd_id', $ImSolicDespachoObj->sd_id);
		}
		if ($ImSolicDespachoObj->sd_tipo){
			$comando->bindParam(':sd_tipo', $ImSolicDespachoObj->sd_tipo);
		}
		if ($ImSolicDespachoObj->sd_usrreg){
			$comando->bindParam(':sd_usrreg', $ImSolicDespachoObj->sd_usrreg);
		}
		if ($ImSolicDespachoObj->fechaIni){
			$comando->bindParam(':fechaIni', $ImSolicDespachoObj->fechaIni);
		}		
		if ($ImSolicDespachoObj->fechaFin){
			$comando->bindParam(':fechaFin', $ImSolicDespachoObj->fechaFin);
		}
		if ($ImSolicDespachoObj->sd_status){
			if ($ImSolicDespachoObj->sd_status != '*'){
				$comando->bindParam(':sd_status', $ImSolicDespachoObj->sd_status);
			}
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_despacho["sd_id"]			= $row["sd_id"];
			$a_despacho["sd_tipo"]			= $row["sd_tipo"];
			$a_despacho["sd_obs"]			= $row["sd_obs"];
			$a_despacho["sd_docRefId"]		= $row["sd_docRefId"];
			$a_despacho["sd_status"]		= $row["sd_status"];
			$a_despacho["sd_usrreg"]		= $row["sd_usrreg"];
			$a_despacho["sd_usraprob"]		= $row["sd_usraprob"];
			$a_despacho["sd_usract"]		= $row["sd_usract"];
			$a_despacho["sd_fecreg"]		= $row["sd_fecreg"];
			$a_despacho["sd_fecaprob"]		= $row["sd_fecaprob"];
			$a_despacho["sd_fecact"]		= $row["sd_fecact"];
			$a_despacho["sd_status_nombre"] = $row["status_nombre"];
			$a_despacho["sd_tipo_nombre"]	= $row["tipo_nombre"];
			$a_despachoList[]				= $a_despacho;
		}
		return $a_despachoList;

	}




	public function update($ImSolicDespachoObj){
		global $usuario, $PDO;

		if (isset($ImSolicDespachoObj->sd_tipo)){
			$set .= ",sd_tipo = :sd_tipo";
		}
		if (isset($ImSolicDespachoObj->sd_obs)){
			$set .= ",sd_obs = :sd_obs";
		}
		if (isset($ImSolicDespachoObj->sd_status)){
			$set .= ",sd_status = :sd_status";
		}
		if ($set){
			$set = substr($set,1);
			$ImSolicDespachoObj->sd_fecact = date("Y-m-d H:i:s");
			$sql2 = "
				UPDATE im_solicDespacho
				SET 
					$set
					,sd_usract = :usract
					,sd_fecact = :fecact
				WHERE sd_id = :sd_id
				LIMIT 1";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':sd_id', $ImSolicDespachoObj->sd_id);
			$comando->bindParam(':usract', $usuario);
			$comando->bindParam(':fecact', $ImSolicDespachoObj->sd_fecact);
			if (isset($ImSolicDespachoObj->sd_tipo)){
				$comando->bindParam(':sd_tipo', $ImSolicDespachoObj->sd_tipo);
			}
			if (isset($ImSolicDespachoObj->sd_obs)){
				$comando->bindParam(':sd_obs', $ImSolicDespachoObj->sd_obs);
			}			
			if (isset($ImSolicDespachoObj->sd_status)){
				$comando->bindParam(':sd_status', $ImSolicDespachoObj->sd_status);
			}
			$comando->execute();
			return $ImSolicDespachoObj->sd_id;
		}
	}


	public function insert($ImSolicDespachoObj){
		global $usuario,$PDO;
//		$ImSolicDespachoObj->sd_status = 'P';
		$sql = "
			INSERT INTO `im_solicDespacho` 
			(
			  sd_tipo,
			  sd_obs,
			  sd_status,
			  sd_docRefId,
			  sd_fecreg,
			  sd_usrreg
			) 
			VALUES 
			(
			  :sd_tipo,
			  :sd_obs,
			  :sd_status,
			  :sd_docRefId,
			  :sd_fecreg,
			  :sd_usrreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$ImSolicDespachoObj->sd_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':sd_tipo', $ImSolicDespachoObj->sd_tipo);
		$comando->bindParam(':sd_obs', $ImSolicDespachoObj->sd_obs);
		$comando->bindParam(':sd_status', $ImSolicDespachoObj->sd_status);
		$comando->bindParam(':sd_docRefId', $ImSolicDespachoObj->sd_docRefId);	
		$comando->bindParam(':sd_fecreg', $ImSolicDespachoObj->sd_fecreg);
		$comando->bindParam(':sd_usrreg', $usuario);
		$comando->execute();

		$query	 = "
			SELECT 
			DISTINCT max(sd_id) as id 
			FROM im_solicDespacho 
			WHERE sd_fecreg = '".$ImSolicDespachoObj->sd_fecreg."' AND sd_usrreg = '".$usuario."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}
}



class ImSolicDespachoLineaModel{

	public function insert($GuiaLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			im_solicDespacholinea 
			(
			sdl_sd_id,
			sdl_pr_id,
			sdl_cantidad,
			sdl_refId,
			sdl_fecreg,
			sdl_usrreg
			) 
			VALUES 
			(
			:sdl_sd_id,
			:sdl_pr_id,
			:sdl_cantidad,
			:sdl_refId,			
			:sdl_fecreg, 
			:sdl_usrreg
			);			
		";
		if (!$GuiaLineaObj->sdl_refId){
			$GuiaLineaObj->sdl_refId = '';
		}
		$comando = $PDO->prepare($sql);
		$GuiaLineaObj->sdl_usrreg = $usuario;
		$GuiaLineaObj->sdl_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':sdl_sd_id', $GuiaLineaObj->sdl_sd_id);
		$comando->bindParam(':sdl_pr_id', $GuiaLineaObj->sdl_pr_id);
		$comando->bindParam(':sdl_cantidad', $GuiaLineaObj->sdl_cantidad);
		$comando->bindParam(':sdl_refId', $GuiaLineaObj->sdl_refId);
		$comando->bindParam(':sdl_fecreg', $GuiaLineaObj->sdl_fecreg);
		$comando->bindParam(':sdl_usrreg', $GuiaLineaObj->sdl_usrreg);
		$comando->execute();
		$query	 = "
			SELECT DISTINCT max(sdl_id) as id 
			FROM im_solicDespacholinea 
			WHERE sdl_fecreg = '".$GuiaLineaObj->sdl_fecreg."' 
				AND sdl_usrreg = '".$GuiaLineaObj->sdl_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}



	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM im_solicDespacholinea
			WHERE sdl_id = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_solicDespacholinea
				LEFT JOIN im_producto P ON sdl_pr_id = pr_id
				LEFT JOIN im_solicDespacho D ON sdl_sd_id = sd_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE sdl_sd_id = :sdl_sd_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':sdl_sd_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["sdl_id"]			= $row["sdl_id"];
			$a_linea["sdl_sd_id"]		= $row["sdl_sd_id"];
			$a_linea["sdl_pr_id"]		= $row["sdl_pr_id"];
			$a_linea["sdl_cantidad"]	= $row["sdl_cantidad"];
			$a_linea["sdl_refId"]		= $row["sdl_refId"];
			$a_linea["sdl_usrreg"]		= $row["sdl_usrreg"];
			$a_linea["sdl_fecreg"]		= $row["sdl_fecreg"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_linea["sfm_nombre"]		= $row["sfm_nombre"];			
			$a_despacholinea[]			= $a_linea;
		}
		return $a_despacholinea;
			

	}


	public function selectUniqueIdGroupPrId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, SUM(sdl_cantidad) AS cantidad
			FROM im_solicDespacholinea
				LEFT JOIN im_producto P ON sdl_prId = pr_id
				LEFT JOIN im_solicDespacho D ON sdl_id = sd_id
			WHERE sdl_id = :sdl_id
			$where
			GROUP BY sdl_prId
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':sdl_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["sdl_id"]			= $row["sdl_id"];
			$a_linea["sdl_sd_id"]		= $row["sdl_sd_id"];
			$a_linea["sdl_pr_id"]		= $row["sdl_pr_id"];
			$a_linea["sdl_cantidad"]	= $row["cantidad"];
			$a_linea["sdl_refId"]		= $row["sdl_refId"];
			$a_linea["sdl_usrreg"]		= $row["sdl_usrreg"];
			$a_linea["sdl_fecreg"]		= $row["sdl_fecreg"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_despacholinea[]			= $a_linea;
		}
		return $a_despacholinea;
	}



	public function select($SolicDespachoFilter){
		global $PDO;
		if ($SolicDespachoFilter->sdl_id){
			$where .=  " AND sdl_id = :sdl_id";
		}
		if ($SolicDespachoFilter->sdl_sd_id){
			$where .=  " AND sdl_sd_id = :sdl_sd_id";
		}
		if ($SolicDespachoFilter->sdl_pr_id){
			$where .=  " AND sdl_pr_id = :sdl_pr_id";
		}
		if ($SolicDespachoFilter->sdl_refId){
			$where .=  " AND sdl_refId = :sdl_refId";
		}
		if ($where){
			$sql = "
				SELECT *
				FROM im_solicDespacholinea
					LEFT JOIN im_solicDespacho ON sdl_sd_id = sd_id
				LEFT JOIN im_producto ON sdl_pr_id = pr_id
				WHERE sd_status <> 'A' $where
			";			
			$comando = $PDO->prepare($sql);
			if ($SolicDespachoFilter->sdl_id){
				$comando->bindParam(':sdl_id', $SolicDespachoFilter->sdl_id);
			}
			if ($SolicDespachoFilter->sdl_sd_id){
				$comando->bindParam(':sdl_sd_id', $SolicDespachoFilter->sdl_sd_id);
			}
			if ($SolicDespachoFilter->sdl_pr_id){
				$comando->bindParam(':sdl_pr_id', $SolicDespachoFilter->sdl_pr_id);
			}
			if ($SolicDespachoFilter->sdl_refId){
				$comando->bindParam(':sdl_refId', $SolicDespachoFilter->sdl_refId);
			}
			$comando->execute();
			while($row = $comando->fetch()){
				$a_linea["sdl_id"]			= $row["sdl_id"];
				$a_linea["sdl_sd_id"]		= $row["sdl_sd_id"];
				$a_linea["sdl_pr_id"]		= $row["sdl_pr_id"];
				$a_linea["sdl_cantidad"]	= $row["sdl_cantidad"];
				$a_linea["sdl_refId"]		= $row["sdl_refId"];
				$a_linea["sdl_usrreg"]		= $row["sdl_usrreg"];
				$a_linea["sdl_fecreg"]		= $row["sdl_fecreg"];
				$a_linea["sdl_fecha"]		= substr($row["sdl_fecreg"],0,10);
				$a_linea["pr_productoId"]	= $row["pr_productoId"];
				$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
				$a_despacholinea[]			= $a_linea;
			}

			return $a_despacholinea;
			
		}
	}

	public function selectLineaArticulo($despachoId,$productoId){
		global $PDO;
		if (!$despachoId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_solicDespacholinea
				LEFT JOIN im_producto ON sdl_pr_id = pr_id
			WHERE sdl_sd_id = '".$despachoId."'				
				AND sdl_pr_id = '".$productoId."'
		";
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["sdl_id"]			= $row["sdl_id"];
			$a_linea["sdl_pr_id"]		= $row["sdl_pr_id"];
			$a_linea["sdl_cantidad"]	= $row["sdl_cantidad"];
			$a_linea["pr_productoId"]	= $row["pr_productoId"];
			$a_linea["sdl_id"]			= $row["sdl_id"];
		}
		return $a_linea;
	}


	public function deleteLineasGuia($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			DELETE
			FROM im_solicDespacholinea
			WHERE sdl_id = ".$id;
		$comando = $PDO->query($sql);
		return $id;
	}
}


?>