<?php


class ImStockLoteModel{

	public function selectUniqueId($almId,$prId,$loteId){
		global $PDO;
		if (!$almId OR !$prId OR !$loteId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_stock_lote
				LEFT JOIN im_producto ON stkl_prId = pr_id 
				LEFT JOIN im_almacen ON stkl_almacenId = alm_id 
				LEFT JOIN im_stockmov ON stkl_movIdUlt = smv_id
			WHERE stkl_almacenId = '".$almId."'
				AND stkl_prId = '".$prId."'
				AND stkl_loteId = '".$loteId."'
			LIMIT 1
		";	
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		$a_stock["stkl_almacenId"]		= $row["stkl_almacenId"];
		$a_stock["stkl_prId"]			= $row["stkl_prId"];
		$a_stock["stkl_loteId"]			= $row["stkl_loteId"];
		$a_stock["stkl_fisico"]			= $row["stkl_fisico"];
		$a_stock["stkl_reserva"]		= $row["stkl_reserva"];
		$a_stock["stkl_costoProm"]		= $row["stkl_costoProm"];
		$a_stock["stkl_costoProm_gl"]	= $row["stkl_costoProm_gl"];
		$a_stock["stkl_costoUlt"]		= $row["stkl_costoUlt"];
		$a_stock["stkl_movIdUlt"]		= $row["stkl_movIdUlt"];
		$a_stock["stkl_movIngSalUlt"]	= $row["stkl_movIngSalUlt"];
		$a_stock["stkl_movTipoUlt"]		= $row["stkl_movTipoUlt"];
		$a_stock["stkl_fecact"]			= $row["stkl_fecact"];
		$a_stock["smv_docum"]			= $row["smv_docum"];
		return $a_stock;
	}


	public function select($StockObj,$limit=''){
		global $usuario, $PDO;
		if ($StockObj->pr_id){
			$where .= " AND pr_id = :pr_id";
		}
		if ($StockObj->pr_productoId){
			$where .= " AND pr_productoId LIKE :pr_productoId";
		}
		if ($StockObj->stkl_almacenId){
			$where .= " AND stkl_almacenId = :stkl_almacenId";
		}
		if ($StockObj->stkl_loteId){
			$where .= " AND stkl_loteId = :stkl_loteId";
		}
		if ($StockObj->pr_familiaId){
			$where .= " AND pr_familiaId LIKE :pr_familiaId";
		}
		if ($StockObj->stkl_fisico){
			$where .= " AND stkl_fisico > 0";
		}
		if ($StockObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY pr_productoId,stkl_almacenId,stkl_loteId";
		}
		if ($StockObj->groupBy){
			$StockObj->groupBy = str_replace(" ","",$StockObj->groupBy);
			$groupBy = " GROUP BY ".$StockObj->groupBy;
			$fields = ", SUM(stkl_fisico) AS stkl_tot_fisico, SUM(stkl_reserva)  AS stkl_tot_reserva, SUM(stkl_fisico*stkl_costoProm)  AS stkl_tot_costoProm";
		}
		$sql = "
			SELECT *
			$fields
			FROM im_stock_lote
				LEFT JOIN im_producto ON stkl_prId = pr_id 
				LEFT JOIN im_almacen ON stkl_almacenId = alm_id 
				LEFT JOIN im_lote ON stkl_loteId = lt_id 
				LEFT JOIN im_stockmov ON stkl_movIdUlt = smv_id
				LEFT JOIN im_familia ON pr_familiaId = fm_familiaId 
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE 1 $where
			$groupBy
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($StockObj->pr_id){
			$comando->bindParam(':pr_id', $StockObj->pr_id);
		}
		if ($StockObj->pr_productoId){
			$comando->bindParam(':pr_productoId', $StockObj->pr_productoId);
		}
		if ($StockObj->stkl_almacenId){
			$comando->bindParam(':stkl_almacenId', $StockObj->stkl_almacenId);
		}
		if ($StockObj->stkl_loteId){
			$comando->bindParam(':stkl_loteId', $StockObj->stkl_loteId);
		}
		if ($StockObj->pr_familiaId){
			$comando->bindParam(':pr_familiaId', $StockObj->pr_familiaId);
		}
		if ($StockObj->orderBy){
			$comando->bindParam(':orderBy', $StockObj->orderBy);
		}			
		
		$comando->execute();
		while($row = $comando->fetch()){
			$a_almacen["fm_nombre"]			= $row["fm_nombre"];
			$a_almacen["pr_id"]				= $row["pr_id"];
			$a_almacen["pr_productoId"]		= $row["pr_productoId"];
			$a_almacen["pr_descripcion"]	= $row["pr_descripcion"];
			$a_almacen["stkl_almacenId"]		= $row["stkl_almacenId"];
			$a_almacen["alm_nombre"]		= $row["alm_nombre"];
			$a_almacen["lt_nombre"]			= $row["lt_nombre"];
			$a_almacen["stkl_loteId"]		= $row["stkl_loteId"];
			$a_almacen["stkl_fisico"]		= $row["stkl_fisico"];
			$a_almacen["stkl_reserva"]		= $row["stkl_reserva"];
			$a_almacen["stkl_costoProm"]		= $row["stkl_costoProm"];
			$a_almacen["stkl_costoProm_gl"]	= $row["stkl_costoProm_gl"];
			$a_almacen["stkl_costoUlt"]		= $row["stkl_costoUlt"];
			$a_almacen["stkl_fecact"]		= $row["stkl_fecact"];
//			$a_almacen["stkl_fecact_dia"]	= substr($row["stkl_fecact"],0,10);
			$a_almacen["stkl_fecact_dia"]	= $row["smv_fecha"];
			$a_almacen["stkl_tot_fisico"]	= $row["stkl_tot_fisico"];
			$a_almacen["stkl_tot_reserva"]	= $row["stkl_tot_reserva"];
			$a_almacen["stkl_tot_costoProm"]	= $row["stkl_tot_costoProm"];			
			$a_almacen["pr_familiaId"]		= $row["pr_familiaId"];
			$a_almacen["sfm_nombre"]			= $row["sfm_nombre"];
			$a_stockList["listaPag"][] = $a_almacen;
		}
		return $a_stockList;

	}


}


?>