<?php

include ("class/imStockMovimModel.class.php");
include ("class/imStock.class.php");

class ImStockMovim {
    // Define una sola instancia de ImStockMovimModel
    private $imStockMovimModel;

    public function __construct() {
        $this->imStockMovimModel = new ImStockMovimModel();
    }

    public function consultarId($id) {
        return $this->imStockMovimModel->selectUniqueId($id);
    }

    public function consultar($ImStockMovFilter) {
        return $this->imStockMovimModel->select($ImStockMovFilter);
    }

    public function consultarListaArtKdx($ImStockMovFilter) {
        return $this->imStockMovimModel->selectListaArtKdx($ImStockMovFilter);
    }

    public function consultarListaArtKdx_Periodo2($ImStockMovFilter) {
        return $this->imStockMovimModel->selectListaArtKdx_Periodo2($ImStockMovFilter);
    }

    public function consulta_ultSaldo_Periodo2($smv_prId, $fechaIni1) {
        return $this->imStockMovimModel->select_ultSaldo_Periodo2($smv_prId, $fechaIni1);
    }

    public function consulta_ultSaldo($smv_prId, $fechaIni) {
        return $this->imStockMovimModel->select_ultSaldo($smv_prId, $fechaIni);
    }

    public function consultar_resumen($ImStockMovFilter) {
        return $this->imStockMovimModel->select_resumen($ImStockMovFilter);
    }

    public function consultar_resumenGL($ImStockMovFilter) {
        return $this->imStockMovimModel->select_resumenGL($ImStockMovFilter);
    }

    public function agregar($Movimiento) {
        global $usuario;
        if (!$usuario) {
            $usuario = "no-usr";
        }

        $errores = [];

        if (!$Movimiento->smv_prId) $errores[] = "Item no indicado";
        if (!$Movimiento->smv_almacenId) $errores[] = "Almacen no indicado";
        if (!$Movimiento->smv_fecha) $errores[] = "Fecha de movimiento no indicada";
        if (!$Movimiento->smv_ingSal) $errores[] = "Tipo Ingreso o Salida no indicado";
        if (!$Movimiento->smv_tipo) $errores[] = "Tipo movimiento no indicado";
        if (!$Movimiento->smv_docum) $errores[] = "Documento para el movimiento no indicado";
        if (!$Movimiento->smv_documTipo) $errores[] = "Tipo documento (I/S/AJ) para el movimiento no indicado";
        if (!$Movimiento->smv_cantidad) $errores[] = "Cantidad debe ser mayor a 0";
        if (!$Movimiento->smv_tc_contab) $errores[] = "Tipo cambio no definido";

        if (!empty($errores)) {
            throw new Exception("ERROR: " . implode(", ", $errores));
            return false;
        }

        if ($Movimiento->smv_ingSal == 'S' && $Movimiento->smv_almacenId && $Movimiento->smv_prId && $Movimiento->smv_cantidad > 0) {
            $Stock = new ImStock();
            $a_stock = $Stock->consultarId($Movimiento->smv_almacenId, $Movimiento->smv_prId);
            if ($a_stock["stk_fisico"] < $Movimiento->smv_cantidad) {
                throw new Exception("Stock del item " . $Movimiento->smv_prId . " en el almacen " . $Movimiento->smv_almacenId . " es insuficiente (" . $a_stock["stk_fisico"] . ")");
            }
        }

        if ($Movimiento->smv_tipo == 'INI') {
            $Stock = new ImStock();
            $a_stock = $Stock->consultarId($Movimiento->smv_almacenId, $Movimiento->smv_prId);
            if (is_numeric($a_stock["stk_fisico"])) {
                throw new Exception("No se puede cargar INVENTARIO INICIAL si el item " . $Movimiento->smv_prId . " ya tuvo stock / movimiento");
            }
        }

        $this->imStockMovimModel->insert($Movimiento, $usuario);
    }

	public function modificar($ImStockMovimObj){
		if (!$ImStockMovimObj->smv_id){
			print_r($ImStockMovimObj);
			exit("noooo");
			return FALSE;
		}
		$ImStockMovimObjUpd	  = NEW ImStockMovimModel();	
		return $ImStockMovimObjUpd->update($ImStockMovimObj);		
	}

}

?>
