<?php


class ImSubFamiliaModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM im_subFamilia
			WHERE sfm_subFamiliaId = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_familia["sfm_subFamiliaId"] = $row["sfm_subFamiliaId"];
		$a_familia["sfm_familiaId"] = $row["sfm_familiaId"];
		$a_familia["sfm_nombre"]	= $row["sfm_nombre"];
		$a_familia["sfm_glAccount"]	= $row["sfm_glAccount"];
		$a_familia["sfm_status"]	= $row["sfm_status"];
		$a_familia["sfm_usract"]	= $row["sfm_usract"];
		$a_familia["sfm_fecact"]	= $row["sfm_fecact"];
		return $a_familia;
	}


	public function select($SubFamiliaObj,$limit=''){
		global $usuario, $PDO;
		if ($SubFamiliaObj->sfm_subFamiliaId){
			$where .= " AND sfm_subFamiliaId = :sfm_subFamiliaId";
		}
		if ($SubFamiliaObj->sfm_familiaId){
			$where .= " AND sfm_familiaId = :sfm_familiaId";
		}
		if ($SubFamiliaObj->sfm_nombre){
			$where .= " AND sfm_nombre LIKE :sfm_nombre";
		}
		if ($SubFamiliaObj->sfm_status){
			$where .= " AND sfm_status = :sfm_status";
		}
		if (!$SubFamiliaObj->inc_inativo){
			$where .= " AND sfm_status <> 'I'";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($SubFamiliaObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY sfm_nombre";
		}
		$sql = "
			SELECT *
			FROM im_subFamilia 
				LEFT JOIN im_familia ON sfm_familiaId = fm_familiaId
			WHERE 1 $where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($SubFamiliaObj->sfm_subFamiliaId){
			$comando->bindParam(':sfm_subFamiliaId', $SubFamiliaObj->sfm_subFamiliaId);
		}
		if ($SubFamiliaObj->sfm_familiaId){
			$comando->bindParam(':sfm_familiaId', $SubFamiliaObj->sfm_familiaId);
		}
		if ($SubFamiliaObj->sfm_nombre){
			$comando->bindParam(':sfm_nombre', $SubFamiliaObj->sfm_nombre);
		}
		if ($SubFamiliaObj->sfm_status){
			$comando->bindParam(':sfm_status', $SubFamiliaObj->sfm_status);
		}
		if ($SubFamiliaObj->orderBy){
			$comando->bindParam(':orderBy', $SubFamiliaObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_familia["sfm_subFamiliaId"]	= $row["sfm_subFamiliaId"];
			$a_familia["sfm_familiaId"]	= $row["sfm_familiaId"];
			$a_familia["sfm_nombre"]	= $row["sfm_nombre"];
			$a_familia["sfm_glAccount"]	= $row["sfm_glAccount"];
			$a_familia["fm_nombre"]		= $row["fm_nombre"];
			$a_familia["sfm_status"]	= $row["sfm_status"];
			$a_familia["sfm_usract"]	= $row["sfm_usract"];
			$a_familia["sfm_fecact"]	= $row["sfm_fecact"];
			$a_familiaList["listaPag"][] = $a_familia;
		}

		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_familiaList["total"] = $rowTotal["total"];
		return $a_familiaList;

	}


	public function update($SubFamiliaObj){
		global $usuario, $PDO;
		$set .= ", sfm_familiaId = :sfm_familiaId";
		$set .= ", sfm_nombre = :sfm_nombre";
		$set .= ", sfm_status = :sfm_status";
		$set .= ", sfm_glAccount = :sfm_glAccount";
		if ($set && $SubFamiliaObj->sfm_familiaId){
			$set = substr($set,1);
			$sql2 = "
				UPDATE im_subFamilia
				SET 
					$set
					,sfm_usract = :sfm_usract
				WHERE sfm_subFamiliaId = :sfm_subFamiliaId
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':sfm_subFamiliaId', $SubFamiliaObj->sfm_subFamiliaId);
			$comando->bindParam(':sfm_familiaId', $SubFamiliaObj->sfm_familiaId);
			$comando->bindParam(':sfm_nombre', $SubFamiliaObj->sfm_nombre);
			$comando->bindParam(':sfm_glAccount', $SubFamiliaObj->sfm_glAccount);
			$comando->bindParam(':sfm_status', $SubFamiliaObj->sfm_status);
			$comando->bindParam(':sfm_usract', $usuario);
			$comando->execute();
			return $SubFamiliaObj->sfm_subFamiliaId;
		}
	}


	public function insert($SubFamiliaObj){
		global $PDO;
		$sql = "
			INSERT INTO im_subFamilia 
			(
			sfm_familiaId,
			sfm_nombre, 
			sfm_glAccount,
			sfm_status, 
			sfm_usract, 
			sfm_fecact
			) 
			VALUES 
			(
			:sfm_familiaId,
			:sfm_nombre, 
			:sfm_glAccount,
			:sfm_status, 
			:sfm_usract,
			:sfm_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':sfm_familiaId', $SubFamiliaObj->sfm_familiaId);
		$comando->bindParam(':sfm_nombre', $SubFamiliaObj->sfm_nombre);
		$comando->bindParam(':sfm_glAccount', $SubFamiliaObj->sfm_glAccount);		
		$comando->bindParam(':sfm_status', $SubFamiliaObj->sfm_status);
		$comando->bindParam(':sfm_usract', $SubFamiliaObj->sfm_usract);
		$comando->bindParam(':sfm_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(sfm_subFamiliaId) as id 
			FROM `im_subFamilia` 
			WHERE sfm_usract = :sfm_usract 
				AND sfm_fecact = :sfm_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':sfm_usract', $SubFamiliaObj->sfm_usract);
		$comando->bindParam(':sfm_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>