<?php


class PoFacturaModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_factura
				LEFT JOIN po_proveedor ON fcpo_prv_id = prv_id  
				LEFT JOIN xx_maestrolista ON fcpo_status = mlst_valorId AND mlst_listaId = 'poFacStatus'
			WHERE fcpo_id = :id
		";					
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_factura["fcpo_id"]					= $row["fcpo_id"];
		$a_factura["fcpo_serie"]				= $row["fcpo_serie"];
		$a_factura["fcpo_numero"]				= $row["fcpo_numero"];
		$a_factura["fcpo_fecha"]				= $row["fcpo_fecha"];
		$a_factura["fcpo_fecha_vcto"]			= $row["fcpo_fecha_vcto"];
		$a_factura["fcpo_fecha_gl"]				= $row["fcpo_fecha_gl"];
		$a_factura["fcpo_tipo_compra"]			= $row["fcpo_tipo_compra"];
		$a_factura["fcpo_motivo_traslado"]		= $row["fcpo_motivo_traslado"];
		$a_factura["fcpo_bienes_serv_adq"]		= $row["fcpo_bienes_serv_adq"];
		$a_factura["fcpo_nac_ext"]				= $row["fcpo_nac_ext"];
		$a_factura["fcpo_glAccount"]			= $row["fcpo_glAccount"];		
		$a_factura["fcpo_po"]					= $row["fcpo_po"];
		$a_factura["fcpo_tipo_detracc"]			= $row["fcpo_tipo_detracc"];
		$a_factura["fcpo_prv_id"]				= $row["fcpo_prv_id"];
		$a_factura["fcpo_prv_nombre"]			= $row["fcpo_prv_nombre"];
		$a_factura["fcpo_terms"]				= $row["fcpo_terms"];
		$a_factura["fcpo_gravada"]				= $row["fcpo_gravada"];
		$a_factura["fcpo_gravada_factor"]		= $row["fcpo_gravada_factor"];
		$a_factura["fcpo_moneda"]				= $row["fcpo_moneda"];
		$a_factura["fcpo_tipoCambio"]			= $row["fcpo_tipoCambio"];
		$a_factura["fcpo_glosa"]				= $row["fcpo_glosa"];
		$a_factura["fcpo_obs"]					= $row["fcpo_obs"];
		$a_factura["fcpo_total_base_imponible"]	= $row["fcpo_total_base_imponible"];
		$a_factura["fcpo_total_imp"]			= $row["fcpo_total_imp"];
		$a_factura["fcpo_status"]				= $row["fcpo_status"];
		$a_factura["fcpo_fecreg"]				= $row["fcpo_fecreg"];
		$a_factura["fcpo_fecact"]				= $row["fcpo_fecact"];
		$a_factura["fcpo_usrreg"]				= $row["fcpo_usrreg"];
		$a_factura["fcpo_usract"]				= $row["fcpo_usract"];
		$a_factura["prv_nombre"]				= $row["prv_nombre"];
		$a_factura["status_nombre"]				= $row["mlst_valorDsc"];
		return $a_factura;
	}

	public function select($FacturaObj,$limit=''){
		global $usuario, $PDO;
		if ($FacturaObj->fcpo_id){
			$where .= " AND fcpo_id = :fcpo_id";
		}
		if ($FacturaObj->fcpo_serie){
			$where .= " AND fcpo_serie = :fcpo_serie";
		}
		if ($FacturaObj->fcpo_numero){
			$where .= " AND fcpo_numero = :fcpo_numero";
		}
		if ($FacturaObj->fechaIniFac){
			$where .= " AND fcpo_fecha >= :fechaIniFac";
		}
		if ($FacturaObj->fechaFinFac){
			$where .= " AND fcpo_fecha <= :fechaFinFac";
		}
		if ($FacturaObj->fechaIniGl){
			$where .= " AND fcpo_fecha_gl >= :fechaIniGl";
		}
		if ($FacturaObj->fechaFinGl){
			$where .= " AND fcpo_fecha_gl <= :fechaFinGl";
		}
		if ($FacturaObj->fcpo_tipo_compra){
			$where .= " AND fcpo_tipo_compra = :fcpo_tipo_compra";
		}
		if ($FacturaObj->prv_nombre){
			$where .= " AND prv_nombre LIKE :prv_nombre";
		}
		if ($FacturaObj->fcpo_status){
			$where .= " AND fcpo_status = :fcpo_status";
		}

		if ($FacturaObj->orderBy){
			$FacturaObj->orderBy = str_replace(" ","",$FacturaObj->orderBy);
			$orderBy = " ORDER BY ".$FacturaObj->orderBy;
		}else{
			$orderBy = " ORDER BY fcpo_id";
		}
		$sql = "
			SELECT *
			FROM po_factura
				LEFT JOIN po_proveedor ON fcpo_prv_id = prv_id 
			WHERE 1 $where
			$orderBy
		";		
		$comando = $PDO->prepare($sql);
		if ($FacturaObj->fcpo_id){
			$comando->bindParam(':fcpo_id', $FacturaObj->fcpo_id);
		}
		if ($FacturaObj->fcpo_serie){
			$comando->bindParam(':fcpo_serie', $FacturaObj->fcpo_serie);
		}
		if ($FacturaObj->fcpo_numero){
			$comando->bindParam(':fcpo_numero', $FacturaObj->fcpo_numero);
		}
		if ($FacturaObj->fechaIniFac){
			$comando->bindParam(':fechaIniFac', $FacturaObj->fechaIniFac);
		}
		if ($FacturaObj->fechaFinFac){
			$comando->bindParam(':fechaFinFac', $FacturaObj->fechaFinFac);
		}
		if ($FacturaObj->fechaIniGl){
			$comando->bindParam(':fechaIniGl', $FacturaObj->fechaIniGl);
		}
		if ($FacturaObj->fechaFinGl){
			$comando->bindParam(':fechaFinGl', $FacturaObj->fechaFinGl);
		}
		if ($FacturaObj->fcpo_tipo_compra){
			$comando->bindParam(':fcpo_tipo_compra', $FacturaObj->fcpo_tipo_compra);
		}
		if ($FacturaObj->prv_nombre){
			$comando->bindParam(':prv_nombre', $FacturaObj->prv_nombre);
		}
		if ($FacturaObj->fcpo_status){
			$comando->bindParam(':fcpo_status', $FacturaObj->fcpo_status);
		}
		$comando->execute();
		//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_factura["fcpo_id"]					= $row["fcpo_id"];
			$a_factura["fcpo_serie"]				= $row["fcpo_serie"];
			$a_factura["fcpo_numero"]				= $row["fcpo_numero"];
			$a_factura["fcpo_fecha"]				= $row["fcpo_fecha"];
			$a_factura["fcpo_fecha_vcto"]			= $row["fcpo_fecha_vcto"];
			$a_factura["fcpo_fecha_gl"]				= $row["fcpo_fecha_gl"];
			$a_factura["fcpo_tipo_compra"]			= $row["fcpo_tipo_compra"];
			$a_factura["fcpo_motivo_traslado"]		= $row["fcpo_motivo_traslado"];
			$a_factura["fcpo_bienes_serv_adq"]		= $row["fcpo_bienes_serv_adq"];
			$a_factura["fcpo_nac_ext"]				= $row["fcpo_nac_ext"];
			$a_factura["fcpo_glAccount"]			= $row["fcpo_glAccount"];
			$a_factura["fcpo_po"]					= $row["fcpo_po"];
			$a_factura["fcpo_tipo_detracc"]			= $row["fcpo_tipo_detracc"];
			$a_factura["fcpo_prv_id"]				= $row["fcpo_prv_id"];
			$a_factura["fcpo_terms"]				= $row["fcpo_terms"];
			$a_factura["fcpo_gravada"]				= $row["fcpo_gravada"];
			$a_factura["fcpo_gravada_factor"]		= $row["fcpo_gravada_factor"];
			$a_factura["fcpo_moneda"]				= $row["fcpo_moneda"];
			$a_factura["fcpo_tipoCambio"]			= $row["fcpo_tipoCambio"];
			$a_factura["fcpo_glosa"]				= $row["fcpo_glosa"];
			$a_factura["fcpo_obs"]					= $row["fcpo_obs"];
			$a_factura["fcpo_total_base_imponible"]	= $row["fcpo_total_base_imponible"];
			$a_factura["fcpo_total_imp"]			= $row["fcpo_total_imp"];
			$a_factura["fcpo_status"]				= $row["fcpo_status"];
			$a_factura["fcpo_fecreg"]				= $row["fcpo_fecreg"];
			$a_factura["fcpo_fecact"]				= $row["fcpo_fecact"];
			$a_factura["fcpo_usrreg"]				= $row["fcpo_usrreg"];
			$a_factura["fcpo_usract"]				= $row["fcpo_usract"];
			$a_factura["prv_nombre"]				= $row["prv_nombre"];
			$a_factura["status_nombre"]				= $row["mlst_valorDsc"];
			$a_facturaList[]						= $a_factura;
		}
		return $a_facturaList;

	}


	public function update($FacturaObj){
		global $usuario, $PDO;
		if ($FacturaObj->fcpo_serie){
			$set .= ",fcpo_serie = :fcpo_serie";
		}
		if ($FacturaObj->fcpo_numero){
			$set .= ",fcpo_numero = :fcpo_numero";
		}
		if ($FacturaObj->fcpo_fecha){
			$set .= ",fcpo_fecha = :fcpo_fecha";
		}
		if ($FacturaObj->fcpo_fecha_vcto){
			$set .= ",fcpo_fecha_vcto = :fcpo_fecha_vcto";
		}
		if ($FacturaObj->fcpo_fecha_gl){
			$set .= ",fcpo_fecha_gl = :fcpo_fecha_gl";
		}
		if ($FacturaObj->fcpo_tipo_compra){
			$set .= ",fcpo_tipo_compra = :fcpo_tipo_compra";
		}
		if ($FacturaObj->fcpo_motivo_traslado){
			$set .= ",fcpo_motivo_traslado = :fcpo_motivo_traslado";
		}
		if ($FacturaObj->fcpo_bienes_serv_adq){
			$set .= ",fcpo_bienes_serv_adq = :fcpo_bienes_serv_adq";
		}
		if ($FacturaObj->fcpo_nac_ext){
			$set .= ",fcpo_nac_ext = :fcpo_nac_ext";
		}
		if ($FacturaObj->fcpo_glAccount){
			$set .= ",fcpo_glAccount = :fcpo_glAccount";
		}
		if ($FacturaObj->fcpo_po){
			$set .= ",fcpo_po = :fcpo_po";
		}
		if ($FacturaObj->fcpo_tipo_detracc){
			$set .= ",fcpo_tipo_detracc = :fcpo_tipo_detracc";
		}
		if ($FacturaObj->fcpo_prv_id){
			$set .= ",fcpo_prv_id = :fcpo_prv_id";
		}
		if ($FacturaObj->fcpo_terms){
			$set .= ",fcpo_terms = :fcpo_terms";
		}
		if ($FacturaObj->fcpo_gravada){
			$set .= ",fcpo_gravada = :fcpo_gravada";
		}
		if ($FacturaObj->fcpo_gravada_factor){
			$set .= ",fcpo_gravada_factor = :fcpo_gravada_factor";
		}
		if ($FacturaObj->fcpo_moneda){
			$set .= ",fcpo_moneda = :fcpo_moneda";
		}
		if ($FacturaObj->fcpo_tipoCambio){
			$set .= ",fcpo_tipoCambio = :fcpo_tipoCambio";
		}
		if ($FacturaObj->fcpo_glosa){
			$set .= ",fcpo_glosa = :fcpo_glosa";
		}
		if ($FacturaObj->fcpo_obs){
			$set .= ",fcpo_obs = :fcpo_obs";
		}
		if ($FacturaObj->fcpo_total_base_imponible){
			$set .= ",fcpo_total_base_imponible = :fcpo_total_base_imponible";
		}
		if ($FacturaObj->fcpo_total_imp){
			$set .= ",fcpo_total_imp = :fcpo_total_imp";
		}
		if ($FacturaObj->fcpo_status){
			$set .= ",fcpo_status = :fcpo_status";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_factura
				SET 
					$set
					,fcpo_usract = :usract
				WHERE fcpo_id = :fcpo_id
				LIMIT 1";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':fcpo_id', $FacturaObj->fcpo_id);
			$comando->bindParam(':usract', $FacturaObj->fcpo_usract);
			if ($FacturaObj->fcpo_serie){
				$comando->bindParam(':fcpo_serie', $FacturaObj->fcpo_serie);
			}
			if ($FacturaObj->fcpo_numero){
				$comando->bindParam(':fcpo_numero', $FacturaObj->fcpo_numero);
			}
			if ($FacturaObj->fcpo_fecha){
				$comando->bindParam(':fcpo_fecha', $FacturaObj->fcpo_fecha);
			}
			if ($FacturaObj->fcpo_fecha_vcto){
				$comando->bindParam(':fcpo_fecha_vcto', $FacturaObj->fcpo_fecha_vcto);
			}
			if ($FacturaObj->fcpo_fecha_gl){
				$comando->bindParam(':fcpo_fecha_gl', $FacturaObj->fcpo_fecha_gl);
			}
			if ($FacturaObj->fcpo_tipo_compra){
				$comando->bindParam(':fcpo_tipo_compra', $FacturaObj->fcpo_tipo_compra);
			}
			if ($FacturaObj->fcpo_motivo_traslado){
				$comando->bindParam(':fcpo_motivo_traslado', $FacturaObj->fcpo_motivo_traslado);
			}
			if ($FacturaObj->fcpo_bienes_serv_adq){
				$comando->bindParam(':fcpo_bienes_serv_adq', $FacturaObj->fcpo_bienes_serv_adq);
			}
			if ($FacturaObj->fcpo_nac_ext){
				$comando->bindParam(':fcpo_nac_ext', $FacturaObj->fcpo_nac_ext);
			}
			if ($FacturaObj->fcpo_glAccount){
				$comando->bindParam(':fcpo_glAccount', $FacturaObj->fcpo_glAccount);
			}
			if ($FacturaObj->fcpo_po){
				$comando->bindParam(':fcpo_po', $FacturaObj->fcpo_po);
			}
			if ($FacturaObj->fcpo_tipo_detracc){
				$comando->bindParam(':fcpo_tipo_detracc', $FacturaObj->fcpo_tipo_detracc);
			}
			if ($FacturaObj->fcpo_prv_id){
				$comando->bindParam(':fcpo_prv_id', $FacturaObj->fcpo_prv_id);
			}
			if ($FacturaObj->fcpo_terms){
				$comando->bindParam(':fcpo_terms', $FacturaObj->fcpo_terms);
			}
			if ($FacturaObj->fcpo_gravada){
				$comando->bindParam(':fcpo_gravada', $FacturaObj->fcpo_gravada);
			}
			if ($FacturaObj->fcpo_gravada_factor){
				$comando->bindParam(':fcpo_gravada_factor', $FacturaObj->fcpo_gravada_factor);
			}
			if ($FacturaObj->fcpo_moneda){
				$comando->bindParam(':fcpo_moneda', $FacturaObj->fcpo_moneda);
			}
			if ($FacturaObj->fcpo_tipoCambio){
				$comando->bindParam(':fcpo_tipoCambio', $FacturaObj->fcpo_tipoCambio);
			}
			if ($FacturaObj->fcpo_glosa){
				$comando->bindParam(':fcpo_glosa', $FacturaObj->fcpo_glosa);
			}
			if ($FacturaObj->fcpo_obs){
				$comando->bindParam(':fcpo_obs', $FacturaObj->fcpo_obs);
			}
			if ($FacturaObj->fcpo_total_base_imponible){
				$comando->bindParam(':fcpo_total_base_imponible', $FacturaObj->fcpo_total_base_imponible);
			}
			if ($FacturaObj->fcpo_total_imp){
				$comando->bindParam(':fcpo_total_imp', $FacturaObj->fcpo_total_imp);
			}
			if ($FacturaObj->fcpo_status){
				$comando->bindParam(':fcpo_status', $FacturaObj->fcpo_status);
			}
			$comando->execute();
			return $FacturaObj->fcpo_id;
		}
	}


	public function insert($FacturaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO `po_factura` 
			(
			fcpo_serie, 
			fcpo_numero,
			fcpo_fecha,
			fcpo_fecha_vcto,	
			fcpo_fecha_gl, 
			fcpo_tipo_compra, 
			fcpo_motivo_traslado, 
			fcpo_bienes_serv_adq, 
			fcpo_nac_ext,
			fcpo_glAccount,
			fcpo_po, 			
			fcpo_tipo_detracc, 
			fcpo_prv_id,
			fcpo_terms,
			fcpo_gravada,			
			fcpo_gravada_factor,
			fcpo_moneda,
			fcpo_tipoCambio,
			fcpo_glosa,
			fcpo_obs,
			fcpo_total_base_imponible,
			fcpo_total_imp,
			fcpo_status,
			fcpo_usrreg,
			fcpo_fecreg
			) 
			VALUES 
			(
			:fcpo_serie,
			:fcpo_numero,
			:fcpo_fecha,
			:fcpo_fecha_vcto,
			:fcpo_fecha_gl,
			:fcpo_tipo_compra, 
			:fcpo_motivo_traslado, 
			:fcpo_bienes_serv_adq, 
			:fcpo_nac_ext, 
			:fcpo_glAccount,
			:fcpo_po, 
			:fcpo_tipo_detracc, 
			:fcpo_prv_id, 
			:fcpo_terms,
			:fcpo_gravada,
			:fcpo_gravada_factor,
			:fcpo_moneda,
			:fcpo_tipoCambio,
			:fcpo_glosa,
			:fcpo_obs,
			:fcpo_total_base_imponible,
			:fcpo_total_imp,
			:fcpo_status,
			:fcpo_usrreg,
			:fcpo_fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$FacturaObj->fcpo_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':fcpo_serie', $FacturaObj->fcpo_serie);
		$comando->bindParam(':fcpo_numero', $FacturaObj->fcpo_numero);
		$comando->bindParam(':fcpo_fecha', $FacturaObj->fcpo_fecha);
		$comando->bindParam(':fcpo_fecha_vcto', $FacturaObj->fcpo_fecha_vcto);
		$comando->bindParam(':fcpo_fecha_gl', $FacturaObj->fcpo_fecha_gl);
		$comando->bindParam(':fcpo_tipo_compra', $FacturaObj->fcpo_tipo_compra);
		$comando->bindParam(':fcpo_motivo_traslado', $FacturaObj->fcpo_motivo_traslado);
		$comando->bindParam(':fcpo_bienes_serv_adq', $FacturaObj->fcpo_bienes_serv_adq);
		$comando->bindParam(':fcpo_nac_ext', $FacturaObj->fcpo_nac_ext);
		$comando->bindParam(':fcpo_glAccount', $FacturaObj->fcpo_glAccount);
		$comando->bindParam(':fcpo_po', $FacturaObj->fcpo_po);
		$comando->bindParam(':fcpo_tipo_detracc', $FacturaObj->fcpo_tipo_detracc);
		$comando->bindParam(':fcpo_prv_id', $FacturaObj->fcpo_prv_id);
		$comando->bindParam(':fcpo_terms', $FacturaObj->fcpo_terms);
		$comando->bindParam(':fcpo_gravada', $FacturaObj->fcpo_gravada);
		$comando->bindParam(':fcpo_gravada_factor', $FacturaObj->fcpo_gravada_factor);
		$comando->bindParam(':fcpo_moneda', $FacturaObj->fcpo_moneda);
		$comando->bindParam(':fcpo_tipoCambio', $FacturaObj->fcpo_tipoCambio);
		$comando->bindParam(':fcpo_glosa', $FacturaObj->fcpo_glosa);
		$comando->bindParam(':fcpo_obs', $FacturaObj->fcpo_obs);
		$comando->bindParam(':fcpo_total_base_imponible', $FacturaObj->fcpo_total_base_imponible);
		$comando->bindParam(':fcpo_total_imp', $FacturaObj->fcpo_total_imp);
		$comando->bindParam(':fcpo_status', $FacturaObj->fcpo_status);
		$comando->bindParam(':fcpo_usrreg', $FacturaObj->fcpo_usrreg);
		$comando->bindParam(':fcpo_fecreg', $FacturaObj->fcpo_fecreg);
		$comando->execute();
		$query	 = "SELECT DISTINCT max(fcpo_id) as id FROM po_factura where fcpo_fecreg = '".$FacturaObj->fcpo_fecreg."' AND fcpo_usrreg = '".$FacturaObj->fcpo_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}

}



class PoFacturaLineaModel{

	public function insert($FacturaLineaObj){
		global $usuario,$PDO;
		if (!$FacturaLineaObj->fcpol_prId){
			$FacturaLineaObj->fcpol_prId = '';
		}
		$sql = "
			INSERT INTO 
			po_facturalinea 
			(
			fcpol_fcpo_id, 
			fcpol_prId,
			fcpol_descripcion,
			fcpol_cantidad,
			fcpol_costo,
			fcpol_costoMDoc, 
			fcpol_costoInput,
			fcpol_costoBase,
			fcpol_dcto,
			fcpol_subtotal,
			fcpol_costoMN,
			fcpol_impuestoMN,
			fcpol_subtotalMN,
			fcpol_gravada, 
			fcpol_detracc_factor,
			fcpol_detracc,			
			fcpol_costo_imp, 
			fcpol_obs, 
			fcpol_usrreg,
			fcpol_fecreg
			) 
			VALUES 
			(
			:fcpol_fcpo_id,
			:fcpol_prId,
			:fcpol_descripcion,
			:fcpol_cantidad,			
			:fcpol_costo, 
			:fcpol_costoMDoc, 
			:fcpol_costoInput,
			:fcpol_costoBase,
			:fcpol_dcto,
			:fcpol_subtotal,
			:fcpol_costoMN,
			:fcpol_impuestoMN,
			:fcpol_subtotalMN,			
			:fcpol_gravada,
			:fcpol_detracc_factor,
			:fcpol_detracc,			
			:fcpol_costo_imp,  
			:fcpol_obs, 
			:fcpol_usrreg, 
			:fcpol_fecreg 
			);			
		";
		$comando = $PDO->prepare($sql);
		$FacturaLineaObj->fcpol_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':fcpol_fcpo_id', $FacturaLineaObj->fcpol_fcpo_id);
		$comando->bindParam(':fcpol_prId', $FacturaLineaObj->fcpol_prId);
		$comando->bindParam(':fcpol_descripcion', $FacturaLineaObj->fcpol_descripcion);
		$comando->bindParam(':fcpol_cantidad', $FacturaLineaObj->fcpol_cantidad);
		$comando->bindParam(':fcpol_costo', $FacturaLineaObj->fcpol_costo);
		$comando->bindParam(':fcpol_costoMDoc', $FacturaLineaObj->fcpol_costoMDoc);
		$comando->bindParam(':fcpol_costoInput', $FacturaLineaObj->fcpol_costoInput);
		$comando->bindParam(':fcpol_costoBase', $FacturaLineaObj->fcpol_costoBase);
		$comando->bindParam(':fcpol_dcto', $FacturaLineaObj->fcpol_dcto);
		$comando->bindParam(':fcpol_subtotal', $FacturaLineaObj->fcpol_subtotal);
		$comando->bindParam(':fcpol_costoMN', $FacturaLineaObj->fcpol_costoMN);
		$comando->bindParam(':fcpol_impuestoMN', $FacturaLineaObj->fcpol_impuestoMN);
		$comando->bindParam(':fcpol_subtotalMN', $FacturaLineaObj->fcpol_subtotalMN);	
		$comando->bindParam(':fcpol_gravada', $FacturaLineaObj->fcpol_gravada);
		$comando->bindParam(':fcpol_detracc_factor', $FacturaLineaObj->fcpol_detracc_factor);
		$comando->bindParam(':fcpol_detracc', $FacturaLineaObj->fcpol_detracc);
		$comando->bindParam(':fcpol_costo_imp', $FacturaLineaObj->fcpol_costo_imp);
		$comando->bindParam(':fcpol_obs', $FacturaLineaObj->fcpol_obs);
		$comando->bindParam(':fcpol_usrreg', $FacturaLineaObj->fcpol_usrreg);
		$comando->bindParam(':fcpol_fecreg', $FacturaLineaObj->fcpol_fecreg);
		$comando->execute();
print_r($comando->errorInfo());
exit;
		$query	 = "
			SELECT DISTINCT max(fcpol_lineaId) as id 
			FROM po_facturalinea 
			WHERE fcpol_fecreg = '".$FacturaLineaObj->fcpol_fecreg."' 
				AND fcpol_usrreg = '".$FacturaLineaObj->fcpol_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function update($FacturaLineaObj){
		global $usuario, $PDO;
		if ($FacturaLineaObj->fcpol_prId){
			$set .= ",fcpol_prId = :fcpol_prId";
		}
		if ($FacturaLineaObj->fcpol_descripcion){
			$set .= ",fcpol_descripcion = :fcpol_descripcion";
		}
		if ($FacturaLineaObj->fcpol_cantidad){
			$set .= ",fcpol_cantidad = :fcpol_cantidad";
		}
		if ($FacturaLineaObj->fcpol_costo){
			$set .= ",fcpol_costo = :fcpol_costo";
		}
		if ($FacturaLineaObj->fcpol_costoMDoc){
			$set .= ",fcpol_costoMDoc = :fcpol_costoMDoc";
		}
		if ($FacturaLineaObj->fcpol_costoInput){
			$set .= ",fcpol_costoInput = :fcpol_costoInput";
		}
		if ($FacturaLineaObj->fcpol_costoBase){
			$set .= ",fcpol_costoBase = :fcpol_costoBase";
		}
		if ($FacturaLineaObj->fcpol_dcto){
			$set .= ",fcpol_dcto = :fcpol_dcto";
		}
		if ($FacturaLineaObj->fcpol_subtotal){
			$set .= ",fcpol_subtotal = :fcpol_subtotal";
		}
		if ($FacturaLineaObj->fcpol_costoMN){
			$set .= ",fcpol_costoMN = :fcpol_costoMN";
		}
		if ($FacturaLineaObj->fcpol_impuestoMN){
			$set .= ",fcpol_impuestoMN = :fcpol_impuestoMN";
		}
		if ($FacturaLineaObj->fcpol_subtotalMN){
			$set .= ",fcpol_subtotalMN = :fcpol_subtotalMN";
		}
		if ($FacturaLineaObj->fcpol_gravada){
			$set .= ",fcpol_gravada = :fcpol_gravada";
		}
		if ($FacturaLineaObj->fcpol_detracc_factor){
			$set .= ",fcpol_detracc_factor = :fcpol_detracc_factor";
		}
		if ($FacturaLineaObj->fcpol_detracc){
			$set .= ",fcpol_detracc = :fcpol_detracc";
		}
		if ($FacturaLineaObj->fcpol_costo_imp){
			$set .= ",fcpol_costo_imp = :fcpol_costo_imp";
		}
		if ($FacturaLineaObj->fcpol_obs){
			$set .= ",fcpol_obs = :fcpol_obs";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_facturalinea
				SET 
					$set
					,fcpol_usract = :fcpol_usract
				WHERE 
					AND fcpol_lineaId = :fcpol_lineaId
				LIMIT 1";			
			$comando->bindParam(':fcpol_lineaId', $FacturaLineaObj->fcpol_lineaId);
			$comando->bindParam(':fcpol_usract', $FacturaLineaObj->fcpol_usract);
			if ($FacturaLineaObj->fcpol_prId){
				$comando->bindParam(':fcpol_prId', $FacturaLineaObj->fcpol_prId);
			}
			if ($FacturaLineaObj->fcpol_descripcion){
				$comando->bindParam(':fcpol_descripcion', $FacturaLineaObj->fcpol_descripcion);
			}
			if ($FacturaLineaObj->fcpol_cantidad){
				$comando->bindParam(':fcpol_cantidad', $FacturaLineaObj->fcpol_cantidad);
			}
			if ($FacturaLineaObj->fcpol_costo){
				$comando->bindParam(':fcpol_costo', $FacturaLineaObj->fcpol_costo);
			}
			if ($FacturaLineaObj->fcpol_costoMDoc){
				$comando->bindParam(':fcpol_costoMDoc', $FacturaLineaObj->fcpol_costoMDoc);
			}
			if ($FacturaLineaObj->fcpol_costoInput){
				$comando->bindParam(':fcpol_costoInput', $FacturaLineaObj->fcpol_costoInput);
			}
			if ($FacturaLineaObj->fcpol_costoBase){
				$comando->bindParam(':fcpol_costoBase', $FacturaLineaObj->fcpol_costoBase);
			}
			if ($FacturaLineaObj->fcpol_dcto){
				$comando->bindParam(':fcpol_dcto', $FacturaLineaObj->fcpol_dcto);
			}
			if ($FacturaLineaObj->fcpol_subtotal){
				$comando->bindParam(':fcpol_subtotal', $FacturaLineaObj->fcpol_subtotal);
			}
			if ($FacturaLineaObj->fcpol_costoMN){
				$comando->bindParam(':fcpol_costoMN', $FacturaLineaObj->fcpol_costoMN);
			}
			if ($FacturaLineaObj->fcpol_impuestoMN){
				$comando->bindParam(':fcpol_impuestoMN', $FacturaLineaObj->fcpol_impuestoMN);
			}
			if ($FacturaLineaObj->fcpol_subtotalMN){
				$comando->bindParam(':fcpol_subtotalMN', $FacturaLineaObj->fcpol_subtotalMN);
			}
			if ($FacturaLineaObj->fcpol_gravada){
				$comando->bindParam(':fcpol_gravada', $FacturaLineaObj->fcpol_gravada);
			}
			if ($FacturaLineaObj->fcpol_detracc_factor){
				$comando->bindParam(':fcpol_detracc_factor', $FacturaLineaObj->fcpol_detracc_factor);
			}
			if ($FacturaLineaObj->fcpol_detracc){
				$comando->bindParam(':fcpol_detracc', $FacturaLineaObj->fcpol_detracc);
			}
			if ($FacturaLineaObj->fcpol_costo_imp){
				$comando->bindParam(':fcpol_costo_imp', $FacturaLineaObj->fcpol_costo_imp);
			}
			if ($FacturaLineaObj->fcpol_obs){
				$comando->bindParam(':fcpol_obs', $FacturaLineaObj->fcpol_obs);
			}
			$comando->execute();
			return $FacturaLineaObj->fcpol_lineaId;
		}
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM po_facturalinea
			WHERE fcpol_lineaId = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_facturalinea
				LEFT JOIN po_factura ON fcpol_fcpo_id = fcpo_id
01				LEFT JOIN im_producto P ON fcpol_prId = pr_id
			WHERE fcpol_fcpo_id = :fcpol_fcpo_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':fcpol_fcpo_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["fcpol_fcpo_id"]			= $row["fcpol_fcpo_id"];
			$a_linea["fcpol_lineaId"]			= $row["fcpol_lineaId"];
			$a_linea["fcpol_prId"]				= $row["fcpol_prId"];
			$a_linea["fcpol_descripcion"]		= $row["fcpol_descripcion"];
			$a_linea["fcpol_cantidad"]			= $row["fcpol_cantidad"];
			$a_linea["fcpol_costo"]				= $row["fcpol_costo"];
			$a_linea["fcpol_costoMDoc"]			= $row["fcpol_costoMDoc"];
			$a_linea["fcpol_costoInput"]		= $row["fcpol_costoInput"];
			$a_linea["fcpol_costoBase"]			= $row["fcpol_costoBase"];
			$a_linea["fcpol_dcto"]				= $row["fcpol_dcto"];
			$a_linea["fcpol_subtotal"]			= $row["fcpol_subtotal"];
			$a_linea["fcpol_impuestoMN"]		= $row["fcpol_impuestoMN"];
			$a_linea["fcpol_subtotalMN"]		= $row["fcpol_subtotalMN"];
			$a_linea["fcpol_gravada"]			= $row["fcpol_gravada"];
			$a_linea["fcpol_detracc_factor"]	= $row["fcpol_detracc_factor"];
			$a_linea["fcpol_detracc"]			= $row["fcpol_detracc"];
			$a_linea["fcpol_costo_imp"]			= $row["fcpol_costo_imp"];
			$a_linea["fcpol_obs"]				= $row["fcpol_obs"];
			$a_linea["fcpol_usrreg"]			= $row["fcpol_usrreg"];
			$a_linea["fcpol_fecreg"]			= $row["fcpol_fecreg"];
			$a_linea["pr_productoId"]			= $row["pr_productoId"];
			$a_linea["pr_descripcion"]			= $row["pr_descripcion"];
			$a_linea["pr_uom"]					= $row["pr_uom"];
			$a_linea["subtotal"]				= $row["fcpol_cantidad"]*$row["fcpol_costo"];
			$a_linea["fcpo_id"]					= $row["fcpo_id"];
			$a_linea["fcpo_serie"]				= $row["fcpo_serie"];
			$a_linea["fcpo_numero"]				= $row["fcpo_numero"];
			$a_linea["fcpo_fecha"]				= $row["fcpo_fecha"];
			$a_linea["fcpo_prv_nombre"]			= $row["fcpo_prv_nombre"];
			$a_facturalinea[]					= $a_linea;
		}
		return $a_facturalinea;
			

	}

	public function select($FacturaFilter){
		global $PDO;
		if ($FacturaFilter->fcpol_fcpo_id){
			$where .=  "AND fcpol_fcpo_id = :fcpol_fcpo_id";
		}
		if ($FacturaFilter->fcpol_lineaId){
			$where .=  "AND fcpol_lineaId = :fcpol_lineaId";
		}
		if ($FacturaFilter->fcpo_prv_nombre){
			$where .=  "AND fcpo_prv_nombre = :fcpo_prv_nombre";
		}
		if ($FacturaFilter->fcpo_numero){
			$where .=  "AND fcpo_numero = :fcpo_numero";
		}
		if ($FacturaFilter->fechaIni){
			$where .= " AND fcpo_fecha >= :fechaIni";
		}
		if ($FacturaFilter->fechaFin){
			$where .= " AND fcpo_fecha <= :fechaFin";
		}

		if ($where){
			$sql = "
				SELECT *
				FROM po_facturalinea
					LEFT JOIN po_factura ON fcpol_fcpo_id = fcpo_id
					LEFT JOIN po_proveedor ON fcpo_prv_id = prv_id  
					LEFT JOIN im_producto P ON fcpol_prId = pr_id
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($FacturaFilter->fcpol_fcpo_id){
				$comando->bindParam(':fcpol_fcpo_id', $FacturaFilter->fcpol_fcpo_id);
			}
			if ($FacturaFilter->fcpol_lineaId){
				$comando->bindParam(':fcpol_lineaId', $FacturaFilter->fcpol_lineaId);
			}
			if ($FacturaFilter->fcpo_prv_nombre){
				$comando->bindParam(':fcpo_prv_nombre', $FacturaFilter->fcpo_prv_nombre);
			}
			if ($FacturaFilter->fcpo_numero){
				$comando->bindParam(':fcpo_numero', $FacturaFilter->fcpo_numero);
			}
			if ($FacturaFilter->fechaIni){
				$comando->bindParam(':fechaIni', $FacturaFilter->fechaIni);
			}
			if ($FacturaFilter->fechaFin){
				$comando->bindParam(':fechaFin', $FacturaFilter->fechaFin);
			}
			$comando->execute();
//			print_r($comando->errorInfo());
//			exit($sql);
//echo "<pre>".$sql."</pre>";
			while($row = $comando->fetch()){
				$a_linea["fcpo_id"]					= $row["fcpo_id"];
				$a_linea["fcpo_serie"]				= $row["fcpo_serie"];
				$a_linea["fcpo_numero"]				= $row["fcpo_numero"];
				$a_linea["fcpo_fecha"]				= $row["fcpo_fecha"];
				$a_linea["fcpo_moneda"]				= $row["fcpo_moneda"];
				$a_linea["fcpo_tipoCambio"]			= $row["fcpo_tipoCambio"];
				$a_linea["fcpol_fcpo_id"]			= $row["fcpol_fcpo_id"];
				$a_linea["fcpol_lineaId"]			= $row["fcpol_lineaId"];
				$a_linea["fcpol_prId"]				= $row["fcpol_prId"];
				$a_linea["fcpol_descripcion"]		= $row["fcpol_descripcion"];
				$a_linea["fcpol_cantidad"]			= $row["fcpol_cantidad"];
				$a_linea["fcpol_costo"]				= $row["fcpol_costo"];
				$a_linea["fcpol_costoMDoc"]			= $row["fcpol_costoMDoc"];
				$a_linea["fcpol_costoInput"]		= $row["fcpol_costoInput"];
				$a_linea["fcpol_costoBase"]			= $row["fcpol_costoBase"];
				$a_linea["fcpol_dcto"]				= $row["fcpol_dcto"];
				$a_linea["fcpol_subtotal"]			= $row["fcpol_subtotal"];
				$a_linea["fcpol_impuestoMN"]		= $row["fcpol_impuestoMN"];
				$a_linea["fcpol_subtotalMN"]		= $row["fcpol_subtotalMN"];
				$a_linea["fcpol_gravada"]			= $row["fcpol_gravada"];
				$a_linea["fcpol_detracc_factor"]	= $row["fcpol_detracc_factor"];
				$a_linea["fcpol_detracc"]			= $row["fcpol_detracc"];
				$a_linea["fcpol_costo_imp"]			= $row["fcpol_costo_imp"];
				$a_linea["fcpol_obs"]				= $row["fcpol_obs"];
				$a_linea["fcpol_usrreg"]			= $row["fcpol_usrreg"];
				$a_linea["fcpol_fecreg"]			= $row["fcpol_fecreg"];
				$a_linea["pr_productoId"]			= $row["pr_productoId"];
				$a_linea["pr_descripcion"]			= $row["pr_descripcion"];
				$a_linea["pr_uom"]					= $row["pr_uom"];
				$a_linea["subtotal"]				= $row["fcpol_cantidad"]*$row["fcpol_costo"];
				$a_linea["fcpo_prv_nombre"]			= $row["fcpo_prv_nombre"];
				$a_facturalinea[]					= $a_linea;
			}
			return $a_facturalinea;
			
		}
	}

	public function selectLineaArticulo($facturaId,$productoId){
		global $PDO;
		if (!$facturaId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_facturalinea
			WHERE fcpol_fcpo_id = '".$facturaId."'				
				AND fcpol_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["fcpol_prId"] = $row["fcpol_prId"];
		}
		return $a_linea;
	}

}

?>