<?php
/*

CREATE TABLE `po_orden` (
  `po_pagoTermsAdelPorc` int(11) DEFAULT NULL,
  `po_almacenId` int(11) NOT NULL,
  `po_envioTransportId` int(11) NOT NULL,
  `po_proyectoIdDefault` int(11) NOT NULL,
  `po_obs` text COLLATE latin1_general_ci NOT NULL,
  `po_status` varchar(2) CHARACTER SET latin1 NOT NULL,
  `po_usraprob1` varchar(1) CHARACTER SET latin1 NOT NULL,
  `po_usraprob2` varchar(1) CHARACTER SET latin1 NOT NULL,
  `po_usraprob3` varchar(1) CHARACTER SET latin1 NOT NULL,
  `po_fecaprob1` date NOT NULL,
  `po_fecaprob2` date NOT NULL,
  `po_fecaprob3` date NOT NULL,
  `po_usrreg` varchar(15) COLLATE latin1_general_ci NOT NULL,
  `po_fecreg` datetime NOT NULL,
  `po_usract` varchar(15) COLLATE latin1_general_ci NOT NULL,
  `po_fecact` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP
*/

class PoPoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
				PRV_TRANS.prv_nombre AS po_envioTransportNombre,
				PRV.prv_direccion1 AS vendor_direccion1,
				PRV.prv_direccion2 AS vendor_direccion2,
				PRV.prv_ciudad AS vendor_ciudad,
				PRV.prv_estado AS vendor_estado,
				PRV.prv_pais AS vendor_pais,
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre,
				MMONEDA.mlst_valorDsc as moneda_sym
			FROM po_orden
				LEFT JOIN po_proveedor PRV_TRANS ON po_envioTransportId = PRV_TRANS.prv_id AND PRV_TRANS.prv_poTransp = 'Y' 
				LEFT JOIN po_proveedor PRV ON po_proveedorId = PRV.prv_id AND PRV.prv_poTransp <> 'Y' 
				LEFT JOIN im_almacen ON po_alm_id = alm_id
				LEFT JOIN xx_maestrolista MSTAT ON po_status = mlst_valorId AND mlst_listaId = 'poPoStatus'
				LEFT JOIN xx_maestrolista MTIPO ON po_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'poPoTipo'
				LEFT JOIN xx_maestrolista MMONEDA ON po_moneda = MMONEDA.mlst_valorId AND MMONEDA.mlst_listaId = 'moneda'
				LEFT JOIN xx_pais ON PRV.prv_pais = pai_ISO2
			WHERE po_id = :id
		";				
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_po["po_id"]					= $row["po_id"];
		$a_po["po_tipo"]				= $row["po_tipo"];
		$a_po["po_proveedorId"]			= $row["po_proveedorId"];
		$a_po["po_proveedorNombre"]		= $row["po_proveedorNombre"];
		$a_po["po_proveedorContacto"]	= $row["po_proveedorContacto"];
		$a_po["po_proveedorDocRef"]		= $row["po_proveedorDocRef"];
		$a_po["po_fecha"]				= $row["po_fecha"];
		$a_po["po_fechaReqDefault"]		= $row["po_fechaReqDefault"];
		$a_po["po_fechaProgDefault"]	= $row["po_fechaProgDefault"];
		$a_po["po_alm_id"]				= $row["po_alm_id"];
		$a_po["po_shipTo"]				= $row["po_shipTo"];
		$a_po["po_shipTo_id"]			= $row["po_shipTo_id"];
		$a_po["po_shipTo_direccion1"]	= $row["po_shipTo_direccion1"];
		$a_po["po_shipTo_direccion2"]	= $row["po_shipTo_direccion2"];
		$a_po["po_shipTo_ciudad"]		= $row["po_shipTo_ciudad"];
		$a_po["po_shipTo_estado"]		= $row["po_shipTo_estado"];
		$a_po["po_shipTo_pais"]			= $row["po_shipTo_pais"];
		$a_po["po_precioTipo"]			= $row["po_precioTipo"];
		$a_po["po_incoterm"]			= $row["po_incoterm"];
		$a_po["po_moneda"]				= $row["po_moneda"];
		$a_po["po_moneda_sym"]			= $row["moneda_sym"];
		$a_po["po_tipoCambio"]			= $row["po_tipoCambio"];	
		$a_po["po_pagoTerms"]			= $row["po_pagoTerms"];
		$a_po["po_pagoMetodo"]			= $row["po_pagoMetodo"];
		$a_po["po_pagoTermsAdelPorc"]	= $row["po_pagoTermsAdelPorc"];
		$a_po["po_almacenId"]			= $row["po_almacenId"];
		$a_po["po_envioTransportId"]	= $row["po_envioTransportId"];
		$a_po["po_proyectoIdDefault"]	= $row["po_proyectoIdDefault"];
		$a_po["po_obs"]					= $row["po_obs"];
		$a_po["po_envioTransportObs"]	= $row["po_envioTransportObs"];	
		$a_po["po_envioTransportNombre"]= $row["po_envioTransportNombre"];			
		$a_po["po_status"]				= $row["po_status"];
		$a_po["po_status_nombre"]		= $row["status_nombre"];
		$a_po["po_tipo_nombre"]			= $row["tipo_nombre"];
		$a_po["po_usraprob1"]			= $row["po_usraprob1"];
		$a_po["po_usraprob2"]			= $row["po_usraprob2"];
		$a_po["po_usraprob3"]			= $row["po_usraprob3"];
		$a_po["po_fecaprob1"]			= $row["po_fecaprob1"];
		$a_po["po_fecaprob2"]			= $row["po_fecaprob2"];
		$a_po["po_fecaprob3"]			= $row["po_fecaprob3"];
		$a_po["po_usrreg"]				= $row["po_usrreg"];
		$a_po["po_usract"]				= $row["po_usract"];
		$a_po["po_fecreg"]				= $row["po_fecreg"];
		$a_po["po_fecact"]				= $row["po_fecact"];
		$a_po["alm_direcc1"]			= $row["alm_direcc1"];
		$a_po["alm_direcc2"]			= $row["alm_direcc2"];
		$a_po["alm_ciudad"]				= $row["alm_ciudad"];
		$a_po["alm_estado"]				= $row["alm_estado"];
		$a_po["prv_direccion1"]			= $row["vendor_direccion1"];
		$a_po["prv_direccion2"]			= $row["vendor_direccion2"];
		$a_po["prv_ciudad"]				= $row["vendor_ciudad"];
		$a_po["prv_estado"]				= $row["vendor_estado"];
		$a_po["prv_pais"]				= $row["vendor_pais"];
		$a_po["vendor_pai_nombre"]		= $row["pai_nombre"];
		return $a_po;
	}

	public function select($PoReqObj,$limit=''){
		global $usuario, $PDO;
		if ($PoReqObj->po_id){
			$where .= " AND po_id = :po_id";
		}
		if ($PoReqObj->po_tipo){
			$where .= " AND po_tipo = :po_tipo";
		}
		if ($PoReqObj->fechaIni){
			$where .= " AND po_fecha >= :fechaIni";
		}
		if ($PoReqObj->fechaFin){
			$where .= " AND po_fecha <= :fechaFin";
		}

		if ($PoReqObj->po_status=='*'){
			$where .= " AND po_status = ''";
		}elseif ($PoReqObj->po_status){
			$where .= " AND po_status = '".$PoReqObj->po_status."'";
		}
		if ($PoReqObj->orderBy){
			$orderBy = " ORDER BY ".$PoReqObj->orderBy;
		}else{
			$orderBy = " ORDER BY po_fecha, po_id";
		}
		$sql = "
			SELECT *
			FROM po_orden
				LEFT JOIN po_ordenlinea ON po_id = pol_id
				LEFT JOIN im_producto ON pol_prId = pr_id
				LEFT JOIN im_almacen ON po_alm_id = alm_id
			WHERE 1 $where
			GROUP BY po_id
			$orderBy
			$limit
		";		
		$comando = $PDO->prepare($sql);
		if ($PoReqObj->po_id){
			$comando->bindParam(':po_id', $PoReqObj->po_id);
		}
		if ($PoReqObj->po_tipo){
			$comando->bindParam(':po_tipo', $PoReqObj->po_tipo);
		}
		if ($PoReqObj->fechaIni){
			$comando->bindParam(':fechaIni', $PoReqObj->fechaIni);
		}
		if ($PoReqObj->fechaFin){
			$comando->bindParam(':fechaFin', $PoReqObj->fechaFin);
		}
		if ($PoReqObj->pr_id){
			$comando->bindParam(':pr_id', $PoReqObj->pr_id);
		}
		if ($PoReqObj->pr_familiaId){
			$comando->bindParam(':pr_familiaId', $PoReqObj->pr_familiaId);
		}
		
		$comando->execute();
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_po["po_id"]					= $row["po_id"];
			$a_po["po_tipo"]				= $row["po_tipo"];
			$a_po["po_proveedorId"]			= $row["po_proveedorId"];
			$a_po["po_proveedorNombre"]		= $row["po_proveedorNombre"];
			$a_po["po_proveedorContacto"]	= $row["po_proveedorContacto"];
			$a_po["po_proveedorDocRef"]		= $row["po_proveedorDocRef"];
			$a_po["po_fecha"]				= $row["po_fecha"];
			$a_po["po_fechaReqDefault"]		= $row["po_fechaReqDefault"];
			$a_po["po_fechaProgDefault"]	= $row["po_fechaProgDefault"];
			$a_po["po_alm_id"]				= $row["po_alm_id"];
			$a_po["po_shipTo"]				= $row["po_shipTo"];
			$a_po["po_shipTo_id"]			= $row["po_shipTo_id"];
			$a_po["po_shipTo_direccion1"]	= $row["po_shipTo_direccion1"];
			$a_po["po_shipTo_direccion2"]	= $row["po_shipTo_direccion2"];
			$a_po["po_shipTo_ciudad"]		= $row["po_shipTo_ciudad"];
			$a_po["po_shipTo_estado"]		= $row["po_shipTo_estado"];
			$a_po["po_shipTo_pais"]			= $row["po_shipTo_pais"];
			$a_po["po_precioTipo"]			= $row["po_precioTipo"];
			$a_po["po_incoterm"]			= $row["po_incoterm"];
			$a_po["po_moneda"]				= $row["po_moneda"];
			$a_po["po_tipoCambio"]			= $row["po_tipoCambio"];	
			$a_po["po_pagoTerms"]			= $row["po_pagoTerms"];
			$a_po["po_pagoMetodo"]			= $row["po_pagoMetodo"];
			$a_po["po_pagoTermsAdelPorc"]	= $row["po_pagoTermsAdelPorc"];
			$a_po["po_almacenId"]			= $row["po_almacenId"];
			$a_po["po_envioTransportId"]	= $row["po_envioTransportId"];
			$a_po["po_proyectoIdDefault"]	= $row["po_proyectoIdDefault"];
			$a_po["po_obs"]					= $row["po_obs"];
			$a_po["po_envioTransportObs"]	= $row["po_envioTransportObs"];
			$a_po["po_status"]				= $row["po_status"];
			$a_po["po_usraprob1"]			= $row["po_usraprob1"];
			$a_po["po_usraprob2"]			= $row["po_usraprob2"];
			$a_po["po_usraprob3"]			= $row["po_usraprob3"];
			$a_po["po_fecaprob1"]			= $row["po_fecaprob1"];
			$a_po["po_fecaprob2"]			= $row["po_fecaprob2"];
			$a_po["po_fecaprob3"]			= $row["po_fecaprob3"];
			$a_po["po_usrreg"]				= $row["po_usrreg"];
			$a_po["po_usract"]				= $row["po_usract"];
			$a_po["po_fecreg"]				= $row["po_fecreg"];
			$a_po["po_fecact"]				= $row["po_fecact"];
			$a_po["alm_direcc1"]			= $row["alm_direcc1"];
			$a_po["alm_direcc2"]			= $row["alm_direcc2"];
			$a_po["alm_ciudad"]				= $row["alm_ciudad"];
			$a_po["alm_estado"]				= $row["alm_estado"];
			$a_poList[]				= $a_po;
		}
		return $a_poList;

	}


	public function update($PoReqObj){
		global $usuario, $PDO;

		if ($PoReqObj->po_tipo){
			$set .= ",po_tipo = :po_tipo";
		}
		if ($PoReqObj->po_proveedorId){
			$set .= ",po_proveedorId = :po_proveedorId";
		}
		if ($PoReqObj->po_proveedorNombre){
			$set .= ",po_proveedorNombre = :po_proveedorNombre";
		}
		if ($PoReqObj->po_proveedorContacto){
			$set .= ",po_proveedorContacto = :po_proveedorContacto";
		}
		if ($PoReqObj->po_proveedorDocRef){
			$set .= ",po_proveedorDocRef = :po_proveedorDocRef";
		}
		if ($PoReqObj->po_fecha){
			$set .= ",po_fecha = :po_fecha";
		}
		if ($PoReqObj->po_fechaReqDefault){
			$set .= ",po_fechaReqDefault = :po_fechaReqDefault";
		}
		if ($PoReqObj->po_fechaProgDefault){
			$set .= ",po_fechaProgDefault = :po_fechaProgDefault";
		}
		if ($PoReqObj->po_alm_id){
			$set .= ",po_alm_id = :po_alm_id";
		}
		if ($PoReqObj->po_shipTo){
			$set .= ",po_shipTo = :po_shipTo";
		}
		//if ($PoReqObj->po_shipTo_id){
			$set .= ",po_shipTo_id = :po_shipTo_id";
		//}
		if ($PoReqObj->po_shipTo_direccion1){
			$set .= ",po_shipTo_direccion1 = :po_shipTo_direccion1";
		}
		if ($PoReqObj->po_shipTo_direccion2){
			$set .= ",po_shipTo_direccion2 = :po_shipTo_direccion2";
		}
		if ($PoReqObj->po_shipTo_ciudad){
			$set .= ",po_shipTo_ciudad = :po_shipTo_ciudad";
		}
		if ($PoReqObj->po_shipTo_estado){
			$set .= ",po_shipTo_estado = :po_shipTo_estado";
		}
		if ($PoReqObj->po_shipTo_pais){
			$set .= ",po_shipTo_pais = :po_shipTo_pais";
		}
		if ($PoReqObj->po_precioTipo){
			$set .= ",po_precioTipo = :po_precioTipo";
		}
		if ($PoReqObj->po_incoterm){
			$set .= ",po_incoterm = :po_incoterm";
		}
		if ($PoReqObj->po_moneda){
			$set .= ",po_moneda = :po_moneda";
		}
		if ($PoReqObj->po_envioTransportObs){
			$set .= ",po_envioTransportObs = :po_envioTransportObs";
		}
		if ($PoReqObj->po_tipoCambio){
			$set .= ",po_tipoCambio = :po_tipoCambio";
		}
		if ($PoReqObj->po_pagoTerms){
			$set .= ",po_pagoTerms = :po_pagoTerms";
		}
		if ($PoReqObj->po_pagoMetodo){
			$set .= ",po_pagoMetodo = :po_pagoMetodo";
		}
		if ($PoReqObj->po_pagoTermsAdelPorc){
			$set .= ",po_pagoTermsAdelPorc = :po_pagoTermsAdelPorc";
		}
		if ($PoReqObj->po_almacenId){
			$set .= ",po_almacenId = :po_almacenId";
		}
		if ($PoReqObj->po_envioTransportId){
			$set .= ",po_envioTransportId = :po_envioTransportId";
		}
		if ($PoReqObj->po_proyectoIdDefault){
			$set .= ",po_proyectoIdDefault = :po_proyectoIdDefault";
		}
		if ($PoReqObj->po_obs){
			$set .= ",po_obs = :po_obs";
		}
		if ($PoReqObj->po_status){
			$set .= ",po_status = :po_status";
		}
		if ($PoReqObj->po_usraprob1){
			$set .= ",po_usraprob1 = :po_usraprob1";
		}
		if ($PoReqObj->po_usraprob2){
			$set .= ",po_usraprob2 = :po_usraprob2";
		}
		if ($PoReqObj->po_usraprob3){
			$set .= ",po_usraprob3 = :po_usraprob3";
		}

		if ($PoReqObj->po_fecaprob1){
			$set .= ",po_fecaprob1 = :po_fecaprob1";
		}
		if ($PoReqObj->po_fecaprob2){
			$set .= ",po_fecaprob2 = :po_fecaprob2";
		}
		if ($PoReqObj->po_fecaprob3){
			$set .= ",po_fecaprob3 = :po_fecaprob3";
		}

		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_orden
				SET 
					$set
					,po_usract = :usract
				WHERE po_id = :po_id
				LIMIT 1";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':po_id', $PoReqObj->po_id);
			$comando->bindParam(':usract', $usuario);
			if ($PoReqObj->po_tipo){
				$comando->bindParam(':po_tipo', $PoReqObj->po_tipo);
			}

			if ($PoReqObj->po_proveedorId){
				$comando->bindParam(':po_proveedorId', $PoReqObj->po_proveedorId);
			}
			if ($PoReqObj->po_proveedorNombre){
				$comando->bindParam(':po_proveedorNombre', $PoReqObj->po_proveedorNombre);
			}
			if ($PoReqObj->po_proveedorContacto){
				$comando->bindParam(':po_proveedorContacto', $PoReqObj->po_proveedorContacto);
			}
			if ($PoReqObj->po_proveedorDocRef){
				$comando->bindParam(':po_proveedorDocRef', $PoReqObj->po_proveedorDocRef);
			}
			if ($PoReqObj->po_fecha){
				$comando->bindParam(':po_fecha', $PoReqObj->po_fecha);
			}
			if ($PoReqObj->po_fechaReqDefault){
				$comando->bindParam(':po_fechaReqDefault', $PoReqObj->po_fechaReqDefault);
			}
			if ($PoReqObj->po_fechaProgDefault){
				$comando->bindParam(':po_fechaProgDefault', $PoReqObj->po_fechaProgDefault);
			}
			if ($PoReqObj->po_alm_id){
				$comando->bindParam(':po_alm_id', $PoReqObj->po_alm_id);
			}
			if ($PoReqObj->po_shipTo){
				$comando->bindParam(':po_shipTo', $PoReqObj->po_shipTo);
			}
			if ($PoReqObj->po_shipTo_id){
				$comando->bindParam(':po_shipTo_id', $PoReqObj->po_shipTo_id);
			}
			if ($PoReqObj->po_shipTo_direccion1){
				$comando->bindParam(':po_shipTo_direccion1', $PoReqObj->po_shipTo_direccion1);
			}
			if ($PoReqObj->po_shipTo_direccion2){
				$comando->bindParam(':po_shipTo_direccion2', $PoReqObj->po_shipTo_direccion2);
			}
			if ($PoReqObj->po_shipTo_ciudad){
				$comando->bindParam(':po_shipTo_ciudad', $PoReqObj->po_shipTo_ciudad);
			}
			if ($PoReqObj->po_shipTo_estado){
				$comando->bindParam(':po_shipTo_estado', $PoReqObj->po_shipTo_estado);
			}
			if ($PoReqObj->po_shipTo_pais){
				$comando->bindParam(':po_shipTo_pais', $PoReqObj->po_shipTo_pais);
			}
			if ($PoReqObj->po_precioTipo){
				$comando->bindParam(':po_precioTipo', $PoReqObj->po_precioTipo);
			}
			if ($PoReqObj->po_incoterm){
				$comando->bindParam(':po_incoterm', $PoReqObj->po_incoterm);
			}
			if ($PoReqObj->po_moneda){
				$comando->bindParam(':po_moneda', $PoReqObj->po_moneda);
			}
			if ($PoReqObj->po_tipoCambio){
				$comando->bindParam(':po_tipoCambio', $PoReqObj->po_tipoCambio);
			}
			if ($PoReqObj->po_pagoTerms){
				$comando->bindParam(':po_pagoTerms', $PoReqObj->po_pagoTerms);
			}
			if ($PoReqObj->po_pagoTermsAdelPorc){
				$comando->bindParam(':po_pagoTermsAdelPorc', $PoReqObj->po_pagoTermsAdelPorc);
			}
			if ($PoReqObj->po_almacenId){
				$comando->bindParam(':po_almacenId', $PoReqObj->po_almacenId);
			}
			if ($PoReqObj->po_envioTransportId){
				$comando->bindParam(':po_envioTransportId', $PoReqObj->po_envioTransportId);
			}
			if ($PoReqObj->po_proyectoIdDefault){
				$comando->bindParam(':po_proyectoIdDefault', $PoReqObj->po_proyectoIdDefault);
			}
			if ($PoReqObj->po_obs){
				$comando->bindParam(':po_obs', $PoReqObj->po_obs);
			}
			if ($PoReqObj->po_envioTransportObs){
				$comando->bindParam(':po_envioTransportObs', $PoReqObj->po_envioTransportObs);
			}			
			if ($PoReqObj->po_status){
				$comando->bindParam(':po_status', $PoReqObj->po_status);
			}
			if ($PoReqObj->po_usraprob1){
				$comando->bindParam(':po_usraprob1', $PoReqObj->po_usraprob1);
			}
			if ($PoReqObj->po_usraprob2){
				$comando->bindParam(':po_usraprob2', $PoReqObj->po_usraprob2);
			}
			if ($PoReqObj->po_usraprob3){
				$comando->bindParam(':po_usraprob3', $PoReqObj->po_usraprob3);
			}
			if ($PoReqObj->po_fecaprob1){
				$comando->bindParam(':po_fecaprob1', $PoReqObj->po_fecaprob1);
			}
			if ($PoReqObj->po_fecaprob2){
				$comando->bindParam(':po_fecaprob2', $PoReqObj->po_fecaprob2);
			}
			if ($PoReqObj->po_fecaprob3){
				$comando->bindParam(':po_fecaprob3', $PoReqObj->po_fecaprob3);
			}			
			$comando->execute();
			return $PoReqObj->po_id;
		}
	}


	public function insert($PoReqObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO `po_orden` 
			(
			po_tipo, 
			po_proveedorId,
			po_proveedorNombre,
			po_proveedorContacto,
			po_proveedorDocRef,
			po_fecha,
			po_fechaReqDefault,
			po_fechaProgDefault,
			po_alm_id,
			po_precioTipo,
			po_incoterm,
			po_moneda, 			
			po_tipoCambio,
			po_pagoTerms,
			po_pagoMetodo,
			po_pagoTermsAdelPorc,
			po_almacenId,
			po_shipTo,
			po_shipTo_id,
			po_shipTo_direccion1,
			po_shipTo_direccion2,
			po_shipTo_ciudad,
			po_shipTo_estado,
			po_shipTo_pais,
			po_envioTransportId,
			po_proyectoIdDefault,
			po_obs,
			po_envioTransportObs,
			po_status, 
			po_usraprob1,
			po_usraprob2,
			po_usraprob3,
			po_fecaprob1,
			po_fecaprob2,
			po_fecaprob3,
			po_usrreg,
			po_fecreg
			) 
			VALUES 
			(
			:po_tipo, 
			:po_proveedorId,
			:po_proveedorNombre,
			:po_proveedorContacto,
			:po_proveedorDocRef,
			:po_fecha,
			:po_fechaReqDefault,
			:po_fechaProgDefault,
			:po_alm_id,
			:po_shipTo,
			:po_shipTo_id,
			:po_shipTo_direccion1,
			:po_shipTo_direccion2,
			:po_shipTo_ciudad,
			:po_shipTo_estado,
			:po_shipTo_pais,
			:po_precioTipo,
			:po_incoterm,
			:po_moneda, 			
			:po_tipoCambio,
			:po_pagoTerms,
			:po_pagoMetodo,
			:po_pagoTermsAdelPorc,
			:po_almacenId,
			:po_envioTransportId,
			:po_proyectoIdDefault,
			:po_obs,
			:po_envioTransportObs,
			:po_status, 
			:po_usraprob1,
			:po_usraprob2,
			:po_usraprob3,
			:po_fecaprob1,
			:po_fecaprob2,
			:po_fecaprob3,
			:usrreg,
			:fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':po_tipo', $PoReqObj->po_tipo);

		$comando->bindParam(':po_proveedorId', $PoReqObj->po_proveedorId);
		$comando->bindParam(':po_proveedorNombre', $PoReqObj->po_proveedorNombre);
		$comando->bindParam(':po_proveedorContacto', $PoReqObj->po_proveedorContacto);
		$comando->bindParam(':po_proveedorDocRef', $PoReqObj->po_proveedorDocRef);		
		$comando->bindParam(':po_fecha', $PoReqObj->po_fecha);

		$comando->bindParam(':po_fechaReqDefault', $PoReqObj->po_fechaReqDefault);
		$comando->bindParam(':po_fechaProgDefault', $PoReqObj->po_fechaProgDefault);
		$comando->bindParam(':po_alm_id', $PoReqObj->po_alm_id);
		$comando->bindParam(':po_shipTo', $PoReqObj->po_shipTo);
		$comando->bindParam(':po_shipTo_id', $PoReqObj->po_shipTo_id);
		$comando->bindParam(':po_shipTo_direccion1', $PoReqObj->po_shipTo_direccion1);
		$comando->bindParam(':po_shipTo_direccion2', $PoReqObj->po_shipTo_direccion2);
		$comando->bindParam(':po_shipTo_ciudad', $PoReqObj->po_shipTo_ciudad);
		$comando->bindParam(':po_shipTo_estado', $PoReqObj->po_shipTo_estado);
		$comando->bindParam(':po_shipTo_pais', $PoReqObj->po_shipTo_pais);
		$comando->bindParam(':po_precioTipo', $PoReqObj->po_precioTipo);
		$comando->bindParam(':po_incoterm', $PoReqObj->po_incoterm);
		$comando->bindParam(':po_moneda', $PoReqObj->po_tipoCambio);
		$comando->bindParam(':po_tipoCambio', $PoReqObj->po_tipoCambio);
		$comando->bindParam(':po_pagoTerms', $PoReqObj->po_pagoTerms);
		$comando->bindParam(':po_pagoMetodo', $PoReqObj->po_pagoMetodo);
		$comando->bindParam(':po_pagoTermsAdelPorc', $PoReqObj->po_pagoTermsAdelPorc);
		$comando->bindParam(':po_almacenId', $PoReqObj->po_almacenId);
		$comando->bindParam(':po_envioTransportId', $PoReqObj->po_envioTransportId);
		$comando->bindParam(':po_proyectoIdDefault', $PoReqObj->po_proyectoIdDefault);
		$comando->bindParam(':po_obs', $PoReqObj->po_obs);
		$comando->bindParam(':po_envioTransportObs', $PoReqObj->po_envioTransportObs);		
		$comando->bindParam(':po_status', $PoReqObj->po_status);
		$comando->bindParam(':po_usraprob1', $PoReqObj->po_usraprob1);
		$comando->bindParam(':po_usraprob2', $PoReqObj->po_usraprob2);
		$comando->bindParam(':po_usraprob3', $PoReqObj->po_usraprob3);
		$comando->bindParam(':po_fecaprob1', $PoReqObj->po_fecaprob1);
		$comando->bindParam(':po_fecaprob2', $PoReqObj->po_fecaprob2);
		$comando->bindParam(':po_fecaprob3', $PoReqObj->po_fecaprob3);		
		$comando->bindParam(':usrreg', $PoReqObj->po_usrreg);
		$comando->bindParam(':fecreg', $fecreg);
		$comando->execute();
		$query	 = "SELECT DISTINCT max(po_id) as id FROM po_orden where po_fecreg = '".$fecreg."' AND po_usrreg = '".$PoReqObj->po_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}

}

/*

  `pol_id` int(11) NOT NULL,
  `pol_lineaId` int(11) NOT NULL,
  `pol_tipoLinea` char(1) COLLATE latin1_general_ci NOT NULL DEFAULT 'I',
  `pol_prId` int(11) NOT NULL,
  `pol_descripcion` varchar(150) COLLATE latin1_general_ci NOT NULL,
  `pol_partNum` varchar(150) COLLATE latin1_general_ci NOT NULL,
  `pol_proyectoId` int(11) NOT NULL,
  `pol_fechaReq` date NOT NULL,
  `pol_uom` char(10) COLLATE latin1_general_ci NOT NULL,
  `pol_cantidad` float(5,2) NOT NULL,
  `pol_cantidadBckOrd` double(10,4) NOT NULL,
  `pol_precioBase` double(10,4) NOT NULL,
  `pol_precioInput` double(10,4) NOT NULL,
  `pol_dcto` double(10,4) NOT NULL,
  `pol_precio` double(10,4) NOT NULL,
  `pol_impuesto` double(10,4) NOT NULL DEFAULT '0.0000',
  `pol_subtotal` double(10,4) NOT NULL DEFAULT '0.0000',
  `pol_precioMDoc` double(10,4) NOT NULL,
  `pol_precioMN` double(10,4) NOT NULL,
  `pol_impuestoMN` double(10,4) NOT NULL DEFAULT '0.0000',
  `pol_subtotalMN` double(10,4) NOT NULL DEFAULT '0.0000',
  `pol_costoProm` double(10,4) NOT NULL,
  `pol_costoUlt` double(10,4) NOT NULL,
  `pol_obs` varchar(220) COLLATE latin1_general_ci NOT NULL,
  `pol_status` char(2) COLLATE latin1_general_ci NOT NULL,
  `pol_usrreg` varchar(20) COLLATE latin1_general_ci NOT NULL,
  `pol_usract` varchar(20) COLLATE latin1_general_ci NOT NULL,
  `pol_fecreg` datetime NOT NULL,
  `pol_fecact` datetime NOT NULL

*/

class PoPoLineaModel{

	public function insert($PoReqLineaObj){
		global $usuario,$PDO;
		if (!$PoReqLineaObj->pol_id){
			$PoReqLineaObj->pol_id = '';
		}
		if (!$PoReqLineaObj->pol_tipoLinea){
			$PoReqLineaObj->pol_tipoLinea = '';
		}
		if (!$PoReqLineaObj->pol_prId){
			$PoReqLineaObj->pol_prId = '';
		}
		if (!$PoReqLineaObj->pol_descripcion){
			$PoReqLineaObj->pol_descripcion = '';
		}
		if (!$PoReqLineaObj->pol_partNum){
			$PoReqLineaObj->pol_partNum = '';
		}
		if (!$PoReqLineaObj->pol_proyectoId){
			$PoReqLineaObj->pol_proyectoId = '';
		}
		if (!$PoReqLineaObj->pol_fechaReq){
			$PoReqLineaObj->pol_fechaReq = '';
		}
		if (!$PoReqLineaObj->pol_uom){
			$PoReqLineaObj->pol_uom = '';
		}
		if (!$PoReqLineaObj->pol_cantidad){
			$PoReqLineaObj->pol_cantidad = '';
		}
		if (!$PoReqLineaObj->pol_precioBase){
			$PoReqLineaObj->pol_precioBase = '';
		}
		if (!$PoReqLineaObj->pol_precioInput){
			$PoReqLineaObj->pol_precioInput = '';
		}
		if (!$PoReqLineaObj->pol_dcto){
			$PoReqLineaObj->pol_dcto = '';
		}
		if (!$PoReqLineaObj->pol_precio){
			$PoReqLineaObj->pol_precio = '';
		}
		if (!$PoReqLineaObj->pol_precioMDoc){
			$PoReqLineaObj->pol_precioMDoc = '';
		}
		if (!$PoReqLineaObj->pol_impuesto){
			$PoReqLineaObj->pol_impuesto = '';
		}
		if (!$PoReqLineaObj->pol_subtotal){
			$PoReqLineaObj->pol_subtotal = '';
		}
		if (!$PoReqLineaObj->pol_precioMN){
			$PoReqLineaObj->pol_precioMN = '';
		}
		if (!$PoReqLineaObj->pol_impuestoMN){
			$PoReqLineaObj->pol_impuestoMN = '';
		}
		if (!$PoReqLineaObj->pol_subtotalMN){
			$PoReqLineaObj->pol_subtotalMN = '';
		}
		if (!$PoReqLineaObj->pol_costoProm){
			$PoReqLineaObj->pol_costoProm = '';
		}
		if (!$PoReqLineaObj->pol_costoUlt){
			$PoReqLineaObj->pol_costoUlt = '';
		}
		if (!$PoReqLineaObj->pol_obs){
			$PoReqLineaObj->pol_obs = '';
		}
		if (!$PoReqLineaObj->pol_status){
			$PoReqLineaObj->pol_status = '';
		}

		$sql = "
			INSERT INTO 
			po_ordenlinea 
			(
			pol_id, 
			pol_tipoLinea,
			pol_prId,
			pol_descripcion, 
			pol_partNum, 
			pol_proyectoId,
			pol_fechaReq,
			pol_uom,
			pol_cantidad, 
			pol_cantidadBckOrd,
			pol_precioBase, 
			pol_precioInput, 
			pol_dcto,
			pol_precio,
			pol_impuesto,
			pol_subtotal,
			pol_precioMDoc,
			pol_precioMN,
			pol_impuestoMN,
			pol_subtotalMN,
			pol_costoProm,
			pol_costoUlt,
			pol_obs,
			pol_status,
			pol_usrreg, 
			pol_fecreg 
			) 
			VALUES 
			(
			:pol_id, 
			:pol_tipoLinea,
			:pol_prId,
			:pol_descripcion, 
			:pol_partNum, 
			:pol_proyectoId,
			:pol_fechaReq,
			:pol_uom,
			:pol_cantidad, 
			:pol_cantidadBckOrd,
			:pol_precioBase, 
			:pol_precioInput, 
			:pol_dcto,
			:pol_precio,
			:pol_impuesto,
			:pol_subtotal,
			:pol_precioMDoc,
			:pol_precioMN,
			:pol_impuestoMN,
			:pol_subtotalMN,
			:pol_costoProm,
			:pol_costoUlt,
			:pol_obs,
			:pol_status,
			:usuario, 
			:fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':pol_id', $PoReqLineaObj->pol_id);
		$comando->bindParam(':pol_tipoLinea', $PoReqLineaObj->pol_tipoLinea);
		$comando->bindParam(':pol_prId', $PoReqLineaObj->pol_prId);
		$comando->bindParam(':pol_descripcion', $PoReqLineaObj->pol_descripcion);
		$comando->bindParam(':pol_partNum', $PoReqLineaObj->pol_partNum);
		$comando->bindParam(':pol_proyectoId', $PoReqLineaObj->pol_proyectoId);
		$comando->bindParam(':pol_fechaReq', $PoReqLineaObj->pol_fechaReq);
		$comando->bindParam(':pol_uom', $PoReqLineaObj->pol_uom);
		$comando->bindParam(':pol_cantidad', $PoReqLineaObj->pol_cantidad);
		$comando->bindParam(':pol_cantidadBckOrd', $PoReqLineaObj->pol_cantidad);
		$comando->bindParam(':pol_precioBase', $PoReqLineaObj->pol_precioBase);
		$comando->bindParam(':pol_precioInput', $PoReqLineaObj->pol_precioInput);
		$comando->bindParam(':pol_dcto', $PoReqLineaObj->pol_dcto);
		$comando->bindParam(':pol_precio', $PoReqLineaObj->pol_precio);
		$comando->bindParam(':pol_precioMDoc', $PoReqLineaObj->pol_precio);
		$comando->bindParam(':pol_impuesto', $PoReqLineaObj->pol_impuesto);
		$comando->bindParam(':pol_subtotal', $PoReqLineaObj->pol_subtotal);
		$comando->bindParam(':pol_precioMN', $PoReqLineaObj->pol_precio);
		$comando->bindParam(':pol_impuestoMN', $PoReqLineaObj->pol_impuesto);
		$comando->bindParam(':pol_subtotalMN', $PoReqLineaObj->pol_subtotal);
		$comando->bindParam(':pol_costoProm', $PoReqLineaObj->pol_costoProm);
		$comando->bindParam(':pol_costoUlt', $PoReqLineaObj->pol_costoUlt);
		$comando->bindParam(':pol_obs', $PoReqLineaObj->pol_obs);
		$comando->bindParam(':pol_status', $PoReqLineaObj->pol_status);
		$comando->bindParam(':usuario', $PoReqLineaObj->pol_usrreg);
		$comando->bindParam(':fecreg', $fecreg);
		$comando->execute();

		$query	 = "
			SELECT DISTINCT max(pol_lineaId) as id 
			FROM po_ordenlinea 
			WHERE pol_fecreg = '".$fecreg."' 
				AND pol_usrreg = '".$PoReqLineaObj->pol_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function update($PoReqLineaObj){
		global $usuario, $PDO;
		if ($PoReqLineaObj->pol_tipoLinea){
			$set .= ",pol_tipoLinea = :pol_tipoLinea";
		}
		if ($PoReqLineaObj->pol_prId){
			$set .= ",pol_prId = :pol_prId";
		}
		if ($PoReqLineaObj->pol_descripcion){
			$set .= ",pol_descripcion = :pol_descripcion";
		}
		if ($PoReqLineaObj->pol_partNum){
			$set .= ",pol_partNum = :pol_partNum";
		}
		if ($PoReqLineaObj->pol_proyectoId){
			$set .= ",pol_proyectoId = :pol_proyectoId";
		}
		if ($PoReqLineaObj->pol_fechaReq){
			$set .= ",pol_fechaReq = :pol_fechaReq";
		}
		if ($PoReqLineaObj->pol_uom){
			$set .= ",pol_uom = :pol_uom";
		}
		if ($PoReqLineaObj->pol_cantidad){
			$set .= ",pol_cantidad = :pol_cantidad";
		}
		if ($PoReqLineaObj->pol_precioBase){
			$set .= ",pol_precioBase = :pol_precioBase";
		}
		if ($PoReqLineaObj->pol_precioInput){
			$set .= ",pol_precioInput = :pol_precioInput";
		}
		if ($PoReqLineaObj->pol_dcto){
			$set .= ",pol_dcto = :pol_dcto";
		}
		if ($PoReqLineaObj->pol_precio){
			$set .= ",pol_precio = :pol_precio";
		}
		if ($PoReqLineaObj->pol_impuesto){
			$set .= ",pol_impuesto = :pol_impuesto";
		}
		if ($PoReqLineaObj->pol_subtotal){
			$set .= ",pol_subtotal = :pol_subtotal";
		}
		if ($PoReqLineaObj->pol_precioMDoc){
			$set .= ",pol_precioMDoc = :pol_precioMDoc";
		}
		if ($PoReqLineaObj->pol_precioMN){
			$set .= ",pol_precio = :pol_precio";
		}
		if ($PoReqLineaObj->pol_impuestoMN){
			$set .= ",pol_impuesto = :pol_impuesto";
		}
		if ($PoReqLineaObj->pol_subtotalMN){
			$set .= ",pol_subtotal = :pol_subtotal";
		}
		if ($PoReqLineaObj->pol_costoProm){
			$set .= ",pol_costoProm = :pol_costoProm";
		}
		if ($PoReqLineaObj->pol_costoUlt){
			$set .= ",pol_costoUlt = :pol_costoUlt";
		}
		if ($PoReqLineaObj->pol_obs){
			$set .= ",pol_obs = :pol_obs";
		}
		if ($PoReqLineaObj->pol_status){
			$set .= ",pol_status = :pol_status";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_ordenlinea
				SET 
					$set
					,pol_usract = :usuario
				WHERE 
					pol_id = :pol_id
					AND pol_lineaId = :pol_lineaId
				LIMIT 1";			
			$comando->bindParam(':pol_id', $PoReqLineaObj->pol_id);
			$comando->bindParam(':pol_lineaId', $PoReqLineaObj->pol_lineaId);
			$comando->bindParam(':usuario', $PoReqLineaObj->pol_usract);
			if ($PoReqLineaObj->pol_tipoLinea){
				$comando->bindParam(':pol_tipoLinea', $PoReqLineaObj->pol_tipoLinea);
			}
			if ($PoReqLineaObj->pol_prId){
				$comando->bindParam(':pol_prId', $PoReqLineaObj->pol_prId);
			}
			if ($PoReqLineaObj->pol_descripcion){
				$comando->bindParam(':pol_descripcion', $PoReqLineaObj->pol_descripcion);
			}
			if ($PoReqLineaObj->pol_partNum){
				$comando->bindParam(':pol_partNum', $PoReqLineaObj->pol_partNum);
			}
			if ($PoReqLineaObj->pol_proyectoId){
				$comando->bindParam(':pol_proyectoId', $PoReqLineaObj->pol_proyectoId);
			}
			if ($PoReqLineaObj->pol_fechaReq){
				$comando->bindParam(':pol_fechaReq', $PoReqLineaObj->pol_fechaReq);
			}
			if ($PoReqLineaObj->pol_uom){
				$comando->bindParam(':pol_uom', $PoReqLineaObj->pol_uom);
			}			
			if ($PoReqLineaObj->pol_cantidad){
				$comando->bindParam(':pol_cantidad', $PoReqLineaObj->pol_cantidad);
			}
			if ($PoReqLineaObj->pol_precioBase){
				$comando->bindParam(':pol_precioBase', $PoReqLineaObj->pol_precioBase);
			}
			if ($PoReqLineaObj->pol_precioInput){
				$comando->bindParam(':pol_precioInput', $PoReqLineaObj->pol_precioInput);
			}
			if ($PoReqLineaObj->pol_dcto){
				$comando->bindParam(':pol_dcto', $PoReqLineaObj->pol_dcto);
			}
			if ($PoReqLineaObj->pol_precio){
				$comando->bindParam(':pol_precio', $PoReqLineaObj->pol_precio);
			}
			if ($PoReqLineaObj->pol_impuesto){
				$comando->bindParam(':pol_impuesto', $PoReqLineaObj->pol_impuesto);
			}
			if ($PoReqLineaObj->pol_subtotal){
				$comando->bindParam(':pol_subtotal', $PoReqLineaObj->pol_subtotal);
			}
			if ($PoReqLineaObj->pol_precioMDoc){
				$comando->bindParam(':pol_precioMDoc', $PoReqLineaObj->pol_precioMDoc);
			}
			if ($PoReqLineaObj->pol_precioMN){
				$comando->bindParam(':pol_precioMN', $PoReqLineaObj->pol_precioMN);
			}
			if ($PoReqLineaObj->pol_impuestoMN){
				$comando->bindParam(':pol_impuestoMN', $PoReqLineaObj->pol_impuestoMN);
			}
			if ($PoReqLineaObj->pol_subtotalMN){
				$comando->bindParam(':pol_subtotalMN', $PoReqLineaObj->pol_subtotalMN);
			}
			if ($PoReqLineaObj->pol_costoProm){
				$comando->bindParam(':pol_costoProm', $PoReqLineaObj->pol_costoProm);
			}
			if ($PoReqLineaObj->pol_costoUlt){
				$comando->bindParam(':pol_costoUlt', $PoReqLineaObj->pol_costoUlt);
			}
			if ($PoReqLineaObj->pol_obs){
				$comando->bindParam(':pol_obs', $PoReqLineaObj->pol_obs);
			}
			if ($PoReqLineaObj->pol_status){
				$comando->bindParam(':pol_status', $PoReqLineaObj->pol_status);
			}
			$comando->execute();
			return $PoReqLineaObj->pol_lineaId;
		}
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM po_ordenlinea
			WHERE pol_lineaId = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_ordenlinea
				LEFT JOIN im_producto P ON pol_prId = pr_id
				LEFT JOIN im_marca ON pr_marcaId = mr_marcaId
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				LEFT JOIN xx_pais ON pr_origen = pai_ISO2
			WHERE pol_id = :pol_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':pol_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["pol_id"]				= $row["pol_id"];
			$a_linea["pol_lineaId"]			= $row["pol_lineaId"];
			$a_linea["pol_tipoLinea"]		= $row["pol_tipoLinea"];
			$a_linea["pol_prId"]			= $row["pol_prId"];
			$a_linea["pol_descripcion"]		= $row["pol_descripcion"];
			$a_linea["pol_partNum"]			= $row["pol_partNum"];
			$a_linea["pol_proyectoId"]		= $row["pol_proyectoId"];
			$a_linea["pol_fechaReq"]		= $row["pol_fechaReq"];
			$a_linea["pol_uom"]				= $row["pol_uom"];
			$a_linea["pol_cantidad"]		= $row["pol_cantidad"];
			$a_linea["pol_cantidadBckOrd"]	= $row["pol_cantidadBckOrd"];
			$a_linea["pol_precioBase"]		= $row["pol_precioBase"];
			$a_linea["pol_precioInput"]		= $row["pol_precioInput"];
			$a_linea["pol_dcto"]			= $row["pol_dcto"];
			$a_linea["pol_precio"]			= $row["pol_precio"];
			$a_linea["pol_impuesto"]		= $row["pol_impuesto"];
			$a_linea["pol_subtotal"]		= $row["pol_precio"] * $row["pol_cantidad"];			
			$a_linea["pol_precioMDoc"]		= $row["pol_precioMDoc"];			
			$a_linea["pol_precioMN"]		= $row["pol_precioMN"];
			$a_linea["pol_impuestoMN"]		= $row["pol_impuestoMN"];
			$a_linea["pol_subtotalMN"]		= $row["pol_subtotalMN"];			
			$a_linea["pol_costoProm"]		= $row["pol_costoProm"];
			$a_linea["pol_costoUlt"]		= $row["pol_costoUlt"];
			$a_linea["pol_obs"]				= $row["pol_obs"];
			$a_linea["pol_status"]			= $row["pol_status"];
			$a_linea["pol_usrreg"]			= $row["pol_usrreg"];
			$a_linea["pol_usract"]			= $row["pol_usract"];
			$a_linea["pol_fecreg"]			= $row["pol_fecreg"];
			$a_linea["pol_fecact"]			= $row["pol_fecact"];
			$a_linea["pr_productoId"]		= $row["pr_productoId"];
			$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
			$a_linea["pr_uom"]				= $row["pr_uom"];
			$a_linea["pr_modelo"]			= $row["pr_modelo"];
			$a_linea["pr_partNum"]			= $row["pr_partNum"];
			$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
			$a_linea["mr_nombre"]			= $row["mr_nombre"];
			$a_linea["pai_nombre"]			= $row["pai_nombre"];
			$a_ingresolinea[]				= $a_linea;
		}
		return $a_ingresolinea;
			

	}



	public function select($PoReqFilter){
		global $PDO;
		if ($PoReqFilter->pol_id){
			$where .=  " AND pol_id = :pol_id";
		}
		if ($PoReqFilter->pol_lineaId){
			$where .=  " AND pol_lineaId = :pol_lineaId";
		}
		if ($PoReqFilter->pol_prId){
			$where .=  " AND pol_prId = :pol_prId";
		}
		if ($PoReqFilter->pol_partNum){
			$where .=  " AND pol_partNum = :pol_partNum";
		}
		if ($PoReqFilter->pol_descripcion){
			$where .=  " AND pol_descripcion LIKE :pol_descripcion";
		}
		if ($where){
			$sql = "
				SELECT *
				FROM po_ordenlinea
				LEFT JOIN im_producto ON pol_prId = pr_id
				LEFT JOIN im_marca ON pr_marcaId = mr_marcaId
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				LEFT JOIN xx_pais ON pr_origen = pai_ISO2
				WHERE 1 $where
			";	
			$comando = $PDO->prepare($sql);
			if ($PoReqFilter->pol_id){
				$comando->bindParam(':pol_id', $PoReqFilter->pol_id);
			}
			if ($PoReqFilter->pol_lineaId){
				$comando->bindParam(':pol_lineaId', $PoReqFilter->pol_lineaId);
			}
			if ($PoReqFilter->pol_prId){
				$comando->bindParam(':pol_prId', $PoReqFilter->pol_prId);
			}
			if ($PoReqFilter->pol_partNum){
				$comando->bindParam(':pol_partNum', $PoReqFilter->pol_partNum);
			}
			if ($PoReqFilter->pol_descripcion){
				$comando->bindParam(':pol_descripcion', $PoReqFilter->pol_descripcion);
			}
			$comando->execute();
			while($row = $comando->fetch()){
				$a_linea["pol_id"]				= $row["pol_id"];
				$a_linea["pol_lineaId"]			= $row["pol_lineaId"];
				$a_linea["pol_tipoLinea"]		= $row["pol_tipoLinea"];
				$a_linea["pol_prId"]			= $row["pol_prId"];
				$a_linea["pol_descripcion"]		= $row["pol_descripcion"];
				$a_linea["pol_partNum"]			= $row["pol_partNum"];
				$a_linea["pol_proyectoId"]		= $row["pol_proyectoId"];
				$a_linea["pol_fechaReq"]		= $row["pol_fechaReq"];
				$a_linea["pol_uom"]				= $row["pol_uom"];
				$a_linea["pol_cantidad"]		= $row["pol_cantidad"];
				$a_linea["pol_cantidadBckOrd"]	= $row["pol_cantidadBckOrd"];
				$a_linea["pol_precioBase"]		= $row["pol_precioBase"];
				$a_linea["pol_precioInput"]		= $row["pol_precioInput"];
				$a_linea["pol_dcto"]			= $row["pol_dcto"];
				$a_linea["pol_precio"]			= $row["pol_precio"];
				$a_linea["pol_impuesto"]		= $row["pol_impuesto"];
				$a_linea["pol_subtotal"]		= $row["pol_precio"] * $row["pol_cantidad"];			
				$a_linea["pol_precioMDoc"]		= $row["pol_precioMDoc"];			
				$a_linea["pol_precioMN"]		= $row["pol_precioMN"];
				$a_linea["pol_impuestoMN"]		= $row["pol_impuestoMN"];
				$a_linea["pol_subtotalMN"]		= $row["pol_subtotalMN"];			
				$a_linea["pol_costoProm"]		= $row["pol_costoProm"];
				$a_linea["pol_costoUlt"]		= $row["pol_costoUlt"];
				$a_linea["pol_obs"]				= $row["pol_obs"];
				$a_linea["pol_status"]			= $row["pol_status"];
				$a_linea["pol_usrreg"]			= $row["pol_usrreg"];
				$a_linea["pol_usract"]			= $row["pol_usract"];
				$a_linea["pol_fecreg"]			= $row["pol_fecreg"];
				$a_linea["pol_fecact"]			= $row["pol_fecact"];
				$a_linea["pr_productoId"]		= $row["pr_productoId"];
				$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
				$a_linea["pr_uom"]				= $row["pr_uom"];
				$a_linea["pr_modelo"]			= $row["pr_modelo"];
				$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
				$a_linea["mr_nombre"]			= $row["mr_nombre"];
				$a_linea["pai_nombre"]			= $row["pai_nombre"];
				$a_ingresolinea[]				= $a_linea;
			}
			return $a_ingresolinea;
			
		}
	}

	public function selectLineaArticulo($rqId,$productoId){
		global $PDO;
		if (!$rqId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_ordenlinea
			WHERE pol_id = '".$rqId."'				
				AND pol_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["pol_prId"] = $row["pol_prId"];
		}
		return $a_linea;
	}

}





?>