<?php


class PoReqModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_req
				LEFT JOIN xx_maestrolista ON rq_status = mlst_valorId AND mlst_listaId = 'poReqStatus'
			WHERE rq_id = :id
		";					
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_req["rq_id"]			= $row["rq_id"];
		$a_req["rq_tipo"]		= $row["rq_tipo"];
		$a_req["rq_prioridad"]	= $row["rq_prioridad"];
		$a_req["rq_proyectoId"]	= $row["rq_proyectoId"];
		$a_req["rq_fecha"]		= $row["rq_fecha"];
		$a_req["rq_moneda"]		= $row["rq_moneda"];
		$a_req["rq_tipoCambio"]	= $row["rq_tipoCambio"];
		$a_req["rq_obs"]		= $row["rq_obs"];
		$a_req["rq_status"]		= $row["rq_status"];
		$a_req["rq_usrreg"]		= $row["rq_usrreg"];
		$a_req["rq_usract"]		= $row["rq_usract"];
		$a_req["rq_fecreg"]		= $row["rq_fecreg"];
		$a_req["rq_fecact"]		= $row["rq_fecact"];	
		$a_req["rq_status_nombre"] = $row["mlst_valorDsc"];
		$a_req["rq_tipo_nombre"] = $row["tipo_nombre"];
		return $a_req;
	}

	public function select($PoReqObj,$limit=''){
		global $usuario, $PDO;
		if ($PoReqObj->rq_id){
			$where .= " AND rq_id = :rq_id";
		}
		if ($PoReqObj->rq_tipo){
			$where .= " AND rq_tipo = :rq_tipo";
		}
		if ($PoReqObj->fechaIni){
			$where .= " AND rq_fecha >= :fechaIni";
		}
		if ($PoReqObj->fechaFin){
			$where .= " AND rq_fecha <= :fechaFin";
		}
		if ($PoReqObj->rq_status=='*'){
			$where .= " AND rq_status = ''";
		}elseif ($PoReqObj->rq_status){
			$where .= " AND rq_status = '".$PoReqObj->rq_status."'";
		}
		if ($PoReqObj->orderBy){
			$orderBy = " ORDER BY ".$PoReqObj->orderBy;
		}else{
			$orderBy = " ORDER BY rq_fecha, rq_id";
		}
		$sql = "
			SELECT *
			FROM po_req
				LEFT JOIN po_reqlinea ON rq_id = rql_id
				LEFT JOIN im_producto ON rql_prId = pr_id
			WHERE 1 $where
			GROUP BY rq_id
			$orderBy
			$limit
		";		
		$comando = $PDO->prepare($sql);
		if ($PoReqObj->rq_id){
			$comando->bindParam(':rq_id', $PoReqObj->rq_id);
		}
		if ($PoReqObj->rq_tipo){
			$comando->bindParam(':rq_tipo', $PoReqObj->rq_tipo);
		}
		if ($PoReqObj->fechaIni){
			$comando->bindParam(':fechaIni', $PoReqObj->fechaIni);
		}
		if ($PoReqObj->fechaFin){
			$comando->bindParam(':fechaFin', $PoReqObj->fechaFin);
		}
		if ($PoReqObj->pr_id){
			$comando->bindParam(':pr_id', $PoReqObj->pr_id);
		}
		if ($PoReqObj->pr_familiaId){
			$comando->bindParam(':pr_familiaId', $PoReqObj->pr_familiaId);
		}
		
		$comando->execute();
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_req["rq_id"]			= $row["rq_id"];
			$a_req["rq_tipo"]		= $row["rq_tipo"];
			$a_req["rq_fecha"]		= $row["rq_fecha"];
			$a_req["rq_prioridad"]	= $row["rq_prioridad"];
			$a_req["rq_proyectoId"]	= $row["rq_proyectoId"];
			$a_req["rq_contacto"]	= $row["rq_contacto"];
			$a_req["rq_moneda"]		= $row["rq_moneda"];
			$a_req["rq_tipoCambio"]	= $row["rq_tipoCambio"];
			$a_req["rq_obs"]		= $row["rq_obs"];
			$a_req["rq_status"]		= $row["rq_status"];
			$a_req["rq_usrreg"]		= $row["rq_usrreg"];
			$a_req["rq_usract"]		= $row["rq_usract"];
			$a_req["rq_fecreg"]		= $row["rq_fecreg"];
			$a_req["rq_fecact"]		= $row["rq_fecact"];
			$a_reqList[]				= $a_req;
		}
		return $a_reqList;

	}


	public function update($PoReqObj){
		global $usuario, $PDO;
		if ($PoReqObj->rq_tipo){
			$set .= ",rq_tipo = :rq_tipo";
		}
		if ($PoReqObj->rq_fecha){
			$set .= ",rq_fecha = :rq_fecha";
		}
		if ($PoReqObj->rq_tipoCambio){
			$set .= ",rq_tipoCambio = :rq_tipoCambio";
		}
		if ($PoReqObj->rq_moneda){
			$set .= ",rq_moneda = :rq_moneda";
		}
		if ($PoReqObj->rq_prioridad){
			$set .= ",rq_prioridad = :rq_prioridad";
		}
		if ($PoReqObj->rq_proyectoId){
			$set .= ",rq_proyectoId = :rq_proyectoId";
		}
		if ($PoReqObj->rq_contacto){
			$set .= ",rq_contacto = :rq_contacto";
		}
		if ($PoReqObj->rq_obs){
			$set .= ",rq_obs = :rq_obs";
		}		
		if ($PoReqObj->rq_status){
			$set .= ",rq_status = :rq_status";
		}
		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_req
				SET 
					$set
					,rq_usract = :usract
				WHERE rq_id = :rq_id
				LIMIT 1";			
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':rq_id', $PoReqObj->rq_id);
			$comando->bindParam(':usract', $usuario);
			if ($PoReqObj->rq_tipo){
				$comando->bindParam(':rq_tipo', $PoReqObj->rq_tipo);
			}
			if ($PoReqObj->rq_fecha){
				$comando->bindParam(':rq_fecha', $PoReqObj->rq_fecha);
			}
			if ($PoReqObj->rq_tipoCambio){
				$comando->bindParam(':rq_tipoCambio', $PoReqObj->rq_tipoCambio);
			}
			if ($PoReqObj->rq_moneda){
				$comando->bindParam(':rq_moneda', $PoReqObj->rq_moneda);
			}
			if ($PoReqObj->rq_prioridad){
				$comando->bindParam(':rq_prioridad', $PoReqObj->rq_prioridad);
			}
			if ($PoReqObj->rq_proyectoId){
				$comando->bindParam(':rq_proyectoId', $PoReqObj->rq_proyectoId);
			}
			if ($PoReqObj->rq_contacto){
				$comando->bindParam(':rq_contacto', $PoReqObj->rq_contacto);
			}
			if ($PoReqObj->rq_obs){
				$comando->bindParam(':rq_obs', $PoReqObj->rq_obs);
			}
			if ($PoReqObj->rq_status){
				$comando->bindParam(':rq_status', $PoReqObj->rq_status);
			}
			$comando->execute();
			return $PoReqObj->rq_id;
		}
	}


	public function insert($PoReqObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO `po_req` 
			(
			rq_tipo, 
			rq_fecha,
			rq_prioridad,
			rq_proyectoId,
			rq_contacto,
			rq_tipoCambio,
			rq_moneda, 			
			rq_obs,
			rq_status, 
			rq_usrreg,
			rq_fecreg
			) 
			VALUES 
			(
			:rq_tipo,
			:rq_fecha,
			:rq_prioridad,
			:rq_proyectoId,
			:rq_contacto,
			:rq_tipoCambio,
			:rq_moneda, 			
			:rq_obs, 
			:rq_status, 
			:usrreg,
			:fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':rq_tipo', $PoReqObj->rq_tipo);
		$comando->bindParam(':rq_fecha', $PoReqObj->rq_fecha);
		$comando->bindParam(':rq_prioridad', $PoReqObj->rq_prioridad);
		$comando->bindParam(':rq_proyectoId', $PoReqObj->rq_proyectoId);
		$comando->bindParam(':rq_contacto', $PoReqObj->rq_contacto);
		$comando->bindParam(':rq_tipoCambio', $PoReqObj->rq_tipoCambio);
		$comando->bindParam(':rq_moneda', $PoReqObj->rq_moneda);
		$comando->bindParam(':rq_obs', $PoReqObj->rq_obs);
		$comando->bindParam(':rq_status', $PoReqObj->rq_status);
		$comando->bindParam(':usrreg', $PoReqObj->rq_usrreg);
		$comando->bindParam(':fecreg', $fecreg);
		$comando->execute();
		$query	 = "SELECT DISTINCT max(rq_id) as id FROM po_req where rq_fecreg = '".$fecreg."' AND rq_usrreg = '".$PoReqObj->rq_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}

}



class PoReqLineaModel{

	public function insert($PoReqLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			po_reqlinea 
			(
			rql_id, 
			rql_tipoLinea,
			rql_prId,
			rql_descripcion, 
			rql_partNum, 
			rql_proyectoId,
			rql_fechaReq,
			rql_uom,
			rql_cantidad, 
			rql_cantidadBckOrd,
			rql_precioRef, 
			rql_precioUlt,
			rql_obs,
			rql_usrreg, 
			rql_fecreg 
			) 
			VALUES 
			(
			:rql_id,
			:rql_tipoLinea,
			:rql_prId,
			:rql_descripcion, 
			:rql_partNum, 
			:rql_proyectoId,
			:rql_fechaReq,
			:rql_uom,
			:rql_cantidad, 
			:rql_cantidadBckOrd,
			:rql_precioRef, 
			:rql_precioUlt,
			:rql_obs,
			:usuario, 
			:fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':rql_id', $PoReqLineaObj->rql_id);
		$comando->bindParam(':rql_tipoLinea', $PoReqLineaObj->rql_tipoLinea);
		$comando->bindParam(':rql_prId', $PoReqLineaObj->rql_prId);
		$comando->bindParam(':rql_descripcion', $PoReqLineaObj->rql_descripcion);
		$comando->bindParam(':rql_partNum', $PoReqLineaObj->rql_partNum);
		$comando->bindParam(':rql_proyectoId', $PoReqLineaObj->rql_proyectoId);
		$comando->bindParam(':rql_fechaReq', $PoReqLineaObj->rql_fechaReq);
		$comando->bindParam(':rql_uom', $PoReqLineaObj->rql_uom);
		$comando->bindParam(':rql_cantidad', $PoReqLineaObj->rql_cantidad);
		$comando->bindParam(':rql_cantidadBckOrd', $PoReqLineaObj->rql_cantidad);
		$comando->bindParam(':rql_precioRef', $PoReqLineaObj->rql_precioRef);
		$comando->bindParam(':rql_precioUlt', $PoReqLineaObj->rql_precioUlt);
		$comando->bindParam(':rql_obs', $PoReqLineaObj->rql_obs);
		$comando->bindParam(':usuario', $PoReqLineaObj->rql_usrreg);
		$comando->bindParam(':fecreg', $fecreg);
		$comando->execute();
		//print_r($comando->errorInfo());
		$query	 = "
			SELECT DISTINCT max(rql_lineaId) as id 
			FROM po_reqlinea 
			WHERE rql_fecreg = '".$fecreg."' 
				AND rql_usrreg = '".$PoReqLineaObj->rql_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function update($PoReqLineaObj){
		global $usuario, $PDO;
		if ($PoReqLineaObj->rql_tipoLinea){
			$set .= ",rql_tipoLinea = :rql_tipoLinea";
		}
		if ($PoReqLineaObj->rql_descripcion){
			$set .= ",rql_descripcion = :rql_descripcion";
		}
		if ($PoReqLineaObj->rql_partNum){
			$set .= ",rql_partNum = :rql_partNum";
		}
		if ($PoReqLineaObj->rql_proyectoId){
			$set .= ",rql_proyectoId = :rql_proyectoId";
		}
		if ($PoReqLineaObj->rql_fechaReq){
			$set .= ",rql_fechaReq = :rql_fechaReq";
		}
		if ($PoReqLineaObj->rql_uom){
			$set .= ",rql_uom = :rql_uom";
		}
		if ($PoReqLineaObj->rql_cantidad){
			$set .= ",rql_cantidad = :rql_cantidad";
		}
		if ($PoReqLineaObj->rql_precioRef){
			$set .= ",rql_precioRef = :rql_precioRef";
		}
		if ($PoReqLineaObj->rql_precioUlt){
			$set .= ",rql_precioUlt = :rql_precioUlt";
		}
		if ($PoReqLineaObj->rql_obs){
			$set .= ",rql_obs = :rql_obs";
		}

		if ($set){
			$set = substr($set,1);
			$sql2 = "
				UPDATE po_reqlinea
				SET 
					$set
					,rql_usract = :usuario
				WHERE 
					rql_id = :rql_id
					AND rql_lineaId = :rql_lineaId
				LIMIT 1";			
			$comando->bindParam(':rql_id', $PoReqLineaObj->rql_id);
			$comando->bindParam(':rql_lineaId', $PoReqLineaObj->rql_lineaId);
			$comando->bindParam(':usuario', $PoReqLineaObj->rql_usract);
			if ($PoReqLineaObj->rql_tipoLinea){
				$comando->bindParam(':rql_tipoLinea', $PoReqLineaObj->rql_tipoLinea);
			}
			if ($PoReqLineaObj->rql_prId){
				$comando->bindParam(':rql_prId', $PoReqLineaObj->rql_prId);
			}
			if ($PoReqLineaObj->rql_descripcion){
				$comando->bindParam(':rql_descripcion', $PoReqLineaObj->rql_descripcion);
			}
			if ($PoReqLineaObj->rql_partNum){
				$comando->bindParam(':rql_partNum', $PoReqLineaObj->rql_partNum);
			}
			if ($PoReqLineaObj->rql_proyectoId){
				$comando->bindParam(':rql_proyectoId', $PoReqLineaObj->rql_proyectoId);
			}
			if ($PoReqLineaObj->rql_fechaReq){
				$comando->bindParam(':rql_fechaReq', $PoReqLineaObj->rql_fechaReq);
			}
			if ($PoReqLineaObj->rql_uom){
				$comando->bindParam(':rql_uom', $PoReqLineaObj->rql_uom);
			}			
			if ($PoReqLineaObj->rql_cantidad){
				$comando->bindParam(':rql_cantidad', $PoReqLineaObj->rql_cantidad);
			}
			if ($PoReqLineaObj->rql_precioRef){
				$comando->bindParam(':rql_precioRef', $PoReqLineaObj->rql_precioRef);
			}
			if ($PoReqLineaObj->rql_precioUlt){
				$comando->bindParam(':rql_precioUlt', $PoReqLineaObj->rql_precioUlt);
			}
			if ($PoReqLineaObj->rql_obs){
				$comando->bindParam(':rql_obs', $PoReqLineaObj->rql_obs);
			}
			$comando->execute();
			return $PoReqLineaObj->rql_lineaId;
		}
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM po_reqlinea
			WHERE rql_lineaId = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_reqlinea
				LEFT JOIN im_producto P ON rql_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
			WHERE rql_id = :rql_id
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':rql_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["rql_id"]				= $row["rql_id"];
			$a_linea["rql_lineaId"]			= $row["rql_lineaId"];
			$a_linea["rql_tipoLinea"]		= $row["rql_tipoLinea"];
			$a_linea["rql_prId"]			= $row["rql_prId"];
			$a_linea["rql_descripcion"]		= $row["rql_descripcion"];
			$a_linea["rql_partNum"]			= $row["rql_partNum"];
			$a_linea["rql_proyectoId"]		= $row["rql_proyectoId"];
			$a_linea["rql_fechaReq"]		= $row["rql_fechaReq"];
			$a_linea["rql_uom"]				= $row["rql_uom"];
			$a_linea["rql_cantidad"]		= $row["rql_cantidad"];
			$a_linea["rql_cantidadBckOrd"]	= $row["rql_cantidadBckOrd"];
			$a_linea["rql_precioRef"]		= $row["rql_precioRef"];
			$a_linea["rql_precioUlt"]		= $row["rql_precioUlt"];
			$a_linea["rql_obs"]				= $row["rql_obs"];
			$a_linea["subtotal"]			= $row["rql_cantidad"]*$row["rql_precioRef"];			
			$a_linea["rql_usrreg"]			= $row["rql_usrreg"];
			$a_linea["rql_usract"]			= $row["rql_usract"];
			$a_linea["rql_fecreg"]			= $row["rql_fecreg"];
			$a_linea["rql_fecact"]			= $row["rql_fecact"];
			$a_linea["pr_productoId"]		= $row["pr_productoId"];
			$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
			$a_linea["pr_uom"]				= $row["pr_uom"];
			$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
			$a_ingresolinea[]				= $a_linea;
		}
		return $a_ingresolinea;
			

	}



	public function select($PoReqFilter){
		global $PDO;
		if ($PoReqFilter->rql_id){
			$where .=  " AND rql_id = :rql_id";
		}
		if ($PoReqFilter->rql_lineaId){
			$where .=  " AND rql_lineaId = :rql_lineaId";
		}
		if ($PoReqFilter->rql_prId){
			$where .=  " AND rql_prId = :rql_prId";
		}
		if ($PoReqFilter->rql_partNum){
			$where .=  " AND rql_partNum = :rql_partNum";
		}
		if ($PoReqFilter->rql_descripcion){
			$where .=  " AND rql_descripcion LIKE :rql_descripcion";
		}
		if ($PoReqFilter->rql_cantidadBckOrd){
			$where .=  " AND rql_cantidadBckOrd > 0 ";
		}
		if ($where){
			$sql = "
				SELECT *
				FROM po_reqlinea
					LEFT JOIN po_req ON rql_id = rq_id
				LEFT JOIN im_producto ON rql_prId = pr_id
				LEFT JOIN im_subFamilia ON pr_subfamiliaId = sfm_subFamiliaId
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($PoReqFilter->rql_id){
				$comando->bindParam(':rql_id', $PoReqFilter->rql_id);
			}
			if ($PoReqFilter->rql_lineaId){
				$comando->bindParam(':rql_lineaId', $PoReqFilter->rql_lineaId);
			}
			if ($PoReqFilter->rql_prId){
				$comando->bindParam(':rql_prId', $PoReqFilter->rql_prId);
			}
			if ($PoReqFilter->rql_partNum){
				$comando->bindParam(':rql_partNum', $PoReqFilter->rql_partNum);
			}
			if ($PoReqFilter->rql_descripcion){
				$comando->bindParam(':rql_descripcion', $PoReqFilter->rql_descripcion);
			}

			$comando->execute();
			//print_r($comando->errorInfo());
			while($row = $comando->fetch()){
				$a_linea["rql_id"]				= $row["rql_id"];
				$a_linea["rql_lineaId"]			= $row["rql_lineaId"];
				$a_linea["rql_prId"]			= $row["rql_prId"];
				$a_linea["rq_fecha"]			= $row["rq_fecha"];
				$a_linea["pr_productoId"]		= $row["pr_productoId"];
				$a_linea["pr_descripcion"]		= $row["pr_descripcion"];
				$a_linea["rql_partNum"]			= $row["rql_partNum"];				
				$a_linea["rql_descripcion"]		= $row["rql_descripcion"];
				$a_linea["rql_proyectoId"]		= $row["rql_proyectoId"];
				$a_linea["rql_fechaReq"]		= $row["rql_fechaReq"];
				$a_linea["rql_uom"]				= $row["rql_uom"];
				$a_linea["rql_cantidad"]		= $row["rql_cantidad"];
				$a_linea["rql_cantidadBckOrd"]	= $row["rql_cantidadBckOrd"];
				$a_linea["rql_precioRef"]		= $row["rql_precioRef"];
				$a_linea["rql_precioUlt"]		= $row["rql_precioUlt"];
				$a_linea["rql_usrreg"]			= $row["rql_usrreg"];
				$a_linea["rql_usract"]			= $row["rql_usract"];
				$a_linea["rql_fecreg"]			= $row["rql_fecreg"];
				$a_linea["rql_fecact"]			= $row["rql_fecact"];
				$a_linea["sfm_nombre"]			= $row["sfm_nombre"];
				$a_ingresolinea[]				= $a_linea;
			}
			return $a_ingresolinea;
			
		}
	}

	public function selectLineaArticulo($rqId,$productoId){
		global $PDO;
		if (!$rqId or !$productoId){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM po_reqlinea
			WHERE rql_id = '".$rqId."'				
				AND rql_prId = '".$productoId."'
		";					
		$sentencia = $PDO->query($sql);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia->fetch();
		if ($row){
			$a_linea["rql_prId"] = $row["rql_prId"];
		}
		return $a_linea;
	}

}





?>