<?

define("cpi10", 0);
define("cpi12", 1);
define("anchoProporcional", 2);
define("anchoCondensado", 4);
define("negrita_1", 8);
define("negrita_2", 16);
define("anchoDuplicado", 32);
define("cursiva", 64);
define("subrayado", 128);



class imprimirTxt {
	var $texto;
	//Formato de texto
	var $cpi10; 
	var $cpi12; 
	var $anchoProporcional; 
	var $anchoCondensado; 
	var $negrita_1; 
	var $negrita_2; 
	var $anchoDuplicado; 
	var $cursiva; 
	var $subrayado;


	function imprimir() {
		$this->texto = "";
		$this->cpi10 = 0;
		$this->cpi12 = 0;
		$this->anchoProporcional = 0;
		$this->anchoCondensado = 0;
		$this->negrita_1 = 0;
		$this->negrita_2 = 0; 
		$this->anchoDuplicado = 0;
		$this->cursiva = 0;
		$this->subrayado = 0;
	}



	//Printer Operation

	function inicializar() {
	//Limpia el buffer de datos de la impresora y la reinicia
		$this->texto = $this->texto.chr(27).chr(64); 
	}



	function seleccionarImpresora() {
	//Selecciona la impresora
		$this->texto = $this->texto.chr(17); 
	}



	function deseleccionarImpresora() {
	//Deselecciona la impresora
		$this->texto = $this->texto.chr(19); 
	}



	//Data Control



	function retornoCarro() {
	//Hace un retorno de carro pero no aumenta una nueva linea
		$this->texto = $this->texto.chr(13); 
	}



	function del() {
	//Elimina el ultimo caracter ingresado (no afecta los caracteres de control)
		$this->texto = $this->texto.chr(127); 
	}



	//Vertical Motion/Horizontal Motion

	function saltoPagina() {
	//Realiza un salto de pagina de acuerdo al alto definido en la funcion setAltoPagina
		$this->texto = $this->texto.chr(12); 
	}

	

	function setAltoPagina($alto, $unidad) {
	//Define el alto de pagina, la unidad a utilizar puede ser pulgadas (unidad = 0) o lineas (unidad = 1)
		if($unidad == 0) { //Pulgadas
			if($alto >= 1 && $alto <= 22)
				$this->texto = $this->texto.chr(27).chr(67).chr(0).chr($alto);
		} else { //Lineas
			if($alto >= 1 && $alto <= 127)
				$this->texto = $this->texto.chr(27).chr(67).chr($alto);
		}
	}



	function nuevaLinea() { 
	//Imprime una nueva linea lo cual no significa retorno de carro
		$this->texto = $this->texto.chr(10);
	}



	function setEspaceoEntreLinea($espaceo, $factor=-1) { 
	//Define el espaceo entre cada linea, si se establece un factor este se dividira entre el numero definido por 'espaceo'
		if($factor == -1) {
			switch($espaceo) { 
				case 1: $this->texto = $this->texto.chr(27).chr(48); break; // 1/8 pulgada
				case 2: $this->texto = $this->texto.chr(27).chr(49); break; // 7/72 pulgada
				case 3: $this->texto = $this->texto.chr(27).chr(50); break; // 1/6 pulgada
			}
		} else {
			switch($espaceo) { 
				case 1: // n/216 pulgada
					if($factor >= 0 && $factor <= 255) {
						$this->texto = $this->texto.chr(27).chr(51).chr($factor); break; 
					}
				case 2: // n/72 pulgada
					if($factor >= 0 && $factor <= 85) {					
						$this->texto = $this->texto.chr(27).chr(65).chr($factor); break; 
					}
			}
		}
	}



	function desplazar($factor) {
	//Produce un desplazamiento vertical n/216 pulgadas
		if($factor >= 0 && $factor <= 255) {
			$this->texto = $this->texto.chr(27).chr(74).chr($factor); 
		}
	}



	function setMargenIzquierdo($factor) { 
	//Define el margen izquierdo tomando como unidad el ancho de caracter
		$this->texto = $this->texto.chr(27).chr(108).chr($factor); 
	}



	function setMargenDerecho($factor) { 
	//Define el margen derecho tomando como unidad el ancho de caracter
		$this->texto = $this->texto.chr(27).chr(81).chr($factor); 
	}



	function backspace() { 
	//Retrocede una posicion a la izquierda
		$this->texto = $this->texto.chr(8); 
	}



	function setPosicion($x, $y) {
	//Mueve a la posicion absoluta (x,y), la unidad utilizada es 1/60 pulgadas
		$this->texto = $this->texto.chr(27).chr(36).chr($x).chr($y); 
	}



	function setPosicionRelativa($x, $y) {
	//Mueve a la posicion relativa (x,y), la unidad utilizada es 1/120 pulgadas
		$this->texto = $this->texto.chr(27).chr(92).chr($x).chr($y); 
	}



	function tab() {
	//hace una tabulacion hacia la derecha (8 caracteres a la derecha)
		$this->texto = $this->texto.chr(9); 
	}



	function tabs($numero) {
	//hace una tabulacion hacia la derecha (8 caracteres a la derecha)
		for($i = 1; $i <= $numero; $i++) { 
			$this->tab(); 
		}
	}



	//Overall Printing Style/Print Size



	function setModoDraftNLQ($modo=1) { 
	//En el modo Draft no se puede utilizar ningun tipo de letra especial.
	//En el modo (NLQ 'Near Letter Quality') se pueden definir los tipos de letra: 'Roman', 'Sans Serif' o algun tipo de letra definida por el usuario.
		if($modo == 0) {
			$this->texto = $this->texto.chr(27).chr(120).chr(0);
		} else {
			$this->texto = $this->texto.chr(27).chr(120).chr(1);
		}
	}

	

	function setTipoLetra($tipo) { 
	//Define el tipo de letra (solo para NLQ): 'Roman' = 0, 'Sans Serif' = 1
		if($tipo == 0) { 
			$this->texto = $this->texto.chr(27).chr(107).chr(0);
		} else {
			$this->texto = $this->texto.chr(27).chr(107).chr(1);
		}
	}

	

	function getFormatoTexto() { 
	//Define un numero que utilizado por la funcion setFormatoTexto define la forma en que se imprimen los caracteres
		$formato = 0;
		if($this->cpi10 == 1) {
			$formato = 0;
		} 

		if ($this->cpi12 == 1) {
			$formato += 1;
		} 

		if ($this->anchoProporcional == 1) {
			$formato += 2;
		} 

		if ($this->anchoCondensado == 1) {
			$formato += 4;
		} 

		if ($this->negrita_1 == 1) { //Dobla caracter por caracter
			$formato += 8;
		} 
	
		if ($this->negrita_2 == 1) { //Dobla linea por linea
			$formato += 16;
		} 

		if ($this->anchoDuplicado == 1) {
			$formato += 32;
		} 

		if ($this->cursiva == 1) {
			$formato += 64;
		} 

		if ($this->subrayado == 1) {
			$formato += 128;
		} 

		return $formato;
	}

	

	function setFormatoTexto($formato) {
	//Permite establecer multiples caracteristicas para el formato de texto, 'formato' es un numero que se obtiene con la funcion getFormatoTexto
		$this->texto = $this->texto.chr(27).chr(33).chr($formato); 
	}



	function resetFormatoTexto() {
	//Resetea todos los valores establecidos en setFormatoTexto
		$this->cpi10 = 0;
		$this->cpi12 = 0;
		$this->anchoProporcional = 0;
		$this->anchoCondensado = 0;
		$this->negrita_1 = 0;
		$this->negrita_2 = 0; 
		$this->anchoDuplicado = 0;
		$this->cursiva = 0;
		$this->subrayado = 0;
	}


	function set10cpi() {
	//Esta funcion define que se imprima 10 caracteres por pulgada
		$this->cpi10 = 1;
		$this->cpi12 = 0;
		$this->texto = $this->texto.chr(27).chr(80); 
	}



	function set12cpi() {
	//Esta funcion define que se imprima 12 caracteres por pulgada
		$this->cpi12 = 1;
		$this->cpi10 = 0;
		$this->texto = $this->texto.chr(27).chr(77); 
	}

	

	function setAnchoProporcional($habilitar) {
	//Esta funcion establece un ancho proporcional al tamaño de cada letra ('W' sera mas ancho que 'I').
		if($habilitar) {
			$this->anchoProporcional = 1;
			$this->texto = $this->texto.chr(27).chr(112).chr(1); 
		} else {
			$this->anchoProporcional = 0;
			$this->texto = $this->texto.chr(27).chr(112).chr(0); 
		}
	}

	

	function setAnchoCondensado($habilitar) {
	//Esta funcion disminuye el ancho de todas las letras en un 60% 
	//(el tamaño resultante depende de si se ha establecido 10 cpi o 12 cpi)
		if($habilitar) {
			$this->anchoCondensado = 1;
			$this->texto = $this->texto.chr(27).chr(15); 
		} else {
			$this->anchoCondensado = 0;
			$this->texto = $this->texto.chr(18); 	
		}
	}



	function setAnchoDuplicado($habilitar) {
	//Esta funcion duplica el ancho de todas las letras
	//(el tamaño resultante depende de si se ha establecido 10 cpi o 12 cpi)
		if($habilitar) {
			$this->anchoDuplicado = 1;
			$this->texto = $this->texto.chr(27).chr(14); 
		} else {
			$this->anchoDuplicado = 0;
			$this->texto = $this->texto.chr(20); 	
		}
	}



	function setAltoDuplicado($habilitar) {
	//Esta funcion duplica el ancho de todas las letras
	//(el tamaño resultante depende de si se ha establecido 10 cpi o 12 cpi)
		if($habilitar) {
			$this->texto = $this->texto.chr(27).chr(119).chr(1); 
		} else {
			$this->texto = $this->texto.chr(27).chr(119).chr(0);
		}
	}



	//Print Enhancement/Word Processing



	function setNegrita($habilitar,$modo=1) {
	//Esta funcion imprime dos veces cada punto de cada caracter
	//(en el modo 1 duplica al terminar la linea, en el modo 0 lo hace caracter por caracter)
		if($habilitar) {
			if($mode==1) { //Por linea (negrita_2)
				$this->negrita_2 = 1;
				$this->negrita_1 = 0;
				$this->texto = $this->texto.chr(27).chr(71);
			} else { //Por caracter (negrita_1)
				$this->negrita_1 = 1;
				$this->negrita_2 = 0;
				$this->texto = $this->texto.chr(27).chr(69);
			}
		} else {
			if($mode==1) { 
				$this->negrita_2 = 0;
				$this->texto = $this->texto.chr(27).chr(72);
			} else { 
				$this->negrita_1 = 0;
				$this->texto = $this->texto.chr(27).chr(70);
			}
		}
	}

	

	function setSubIndice($habilitar) {
	//Esta funcion imprime los caracteres en sub indice
		if($habilitar) {
			$this->texto = $this->texto.chr(27).chr(83).chr(1);
		} else {
			$this->texto = $this->texto.chr(27).chr(84);
		}
	}

	

	function setSuperIndice($habilitar) {
	//Esta funcion imprime los caracteres en super indice
		if($habilitar) {
			$this->texto = $this->texto.chr(27).chr(83).chr(0);
		} else {
			$this->texto = $this->texto.chr(27).chr(84);
		}
	}



	function setSubrayado($habilitar) {
	//Esta funcion imprime los caracteres en super indice
		if($habilitar) {
			$this->subrayado = 1;
			$this->texto = $this->texto.chr(27).chr(45).chr(1);
		} else {
			$this->subrayado = 0;
			$this->texto = $this->texto.chr(27).chr(45).chr(0);
		}
	}



	function setAliniacion($aliniacion=0) {
	//Esta funcion establece la aliniacion del texto
		switch($aliniacion) {
			case 0: $this->texto = $this->texto.chr(27).chr(97).chr(0); break; //Izquierda
			case 1: $this->texto = $this->texto.chr(27).chr(97).chr(1); break; //Centrado
			case 2: $this->texto = $this->texto.chr(27).chr(97).chr(2); break; //Derecho
			case 3: $this->texto = $this->texto.chr(27).chr(97).chr(3); break; //Justificado
		}
	}



	function setEspaceoEntreCaracter($factor) { 
	//Esta funcion define el espaceo entre caracteres el cual es (factor/120) pulgadas
		if($factor >= 0 && $factor <= 127) {
			$this->texto = $this->texto.chr(27).chr(32).chr($factor);
		}
	}



	//Character Sets



	function setJuegoCaracteresEspeciales($tabla=1) { 
	//Esta funcion define que tabla de caracteres especiales se utilizara para los caracteres ASCII del 128 - 255
	// 0 : caracteres en cursiva
	// 1 : Caracteres Extendidos de EPSON
		if($tabla == 0) { 
			$this->texto = $this->texto.chr(27).chr(116).chr(0);
		} else {
			$this->texto = $this->texto.chr(27).chr(116).chr(1);
		}
	}



	function setCursiva($habilitar) { 
	//Esta funcion imprime los caracteres en cursiva
		if($habilitar) { 
			$this->cursiva = 1;
			$this->texto = $this->texto.chr(27).chr(52);
		} else {
			$this->cursiva = 0;
			$this->texto = $this->texto.chr(27).chr(53);
		}
	}



	function setJuegoCaracteresPais($pais) { 
	//Esta funcion define el juego de caracteres internacionales a utilizar
		$this->texto = $this->texto.chr(27).chr(82).chr($pais);
	}



	function anadirTexto($texto, $formato=0) {//before: anadirLinea
		set_time_limit(90);
		$this->setFormatoTexto($formato);
		$texto = str_replace ("\n", chr(10).chr(13), $texto);
		$texto = str_replace ("\t", chr(9), $texto);
		$texto = str_replace ("\\\\", "\\", $texto);
		$this->texto = $this->texto.$texto;
	}



	function crearArchivo() {
		global $DOCUMENT_ROOT;
		$this->saltoPagina();
		$this->inicializar();	
		//$nombre_temp = tempnam("/xampp/htdocs/nettools/imgs/articulos/a".date("Y-m-d H:i:s")."txt", "guia");
		//$nombre_temp = "/xampp/htdocs/nettools/imgs/articulos/a".date("Y-m-dH-i-s").".txt";
		$nombre_temp = "/home/sistema6/public_html/nettools/imgs/articulos/a".date("Y-m-dH-i-s").".txt";
		$archivo = fopen($nombre_temp, "w");
		if ($archivo){
			//echo "ok";
		}else{
			echo "error".$archivo;
		}
		if (fwrite($archivo, $this->texto)){
			//echo "writen"; 
		}
		fclose($archivo);
		return $nombre_temp;
	}

	function imprimirArchivo($archivo, $impresora) {
		//$comando = "start /min notepad /P ".$archivo;
		$archivoPath = str_replace(" ","",str_replace("/", "\ ", $archivo));
		$comando = "print /D:LPT1 C:".$archivoPath;
		//echo $comando;
		//exec ($comando, $respuesta, $error);
		return $respuesta;
	}
}

$impr = new imprimirTxt;