<?php

class PvAcuerdoServicioModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *,
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM pv_acuerdoServicio
				LEFT JOIN vt_cliente ON cl_id = as_cl_id
				LEFT JOIN xx_maestrolista MSTAT ON as_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'pvAcSrvStatus'
				LEFT JOIN xx_maestrolista MTIPO ON as_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'pvAcSrvTipo'
			WHERE as_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_cnt["as_id"]						= $row["as_id"];
		$a_cnt["as_tipo"]					= $row["as_tipo"];
		$a_cnt["as_numero"]					= $row["as_numero"];
		$a_cnt["as_cl_id"]					= $row["as_cl_id"];
		$a_cnt["as_contacto_nombre"]		= $row["as_contacto_nombre"];
		$a_cnt["as_contacto_cargo"]			= $row["as_contacto_cargo"];
		$a_cnt["as_contacto_email"]			= $row["as_contacto_email"];
		$a_cnt["as_contacto_telf"]			= $row["as_contacto_telf"];
		$a_cnt["as_cartaFianza_numero"]		= $row["as_cartaFianza_numero"];
		$a_cnt["as_cartaFianza_valor"]		= $row["as_cartaFianza_valor"];
		$a_cnt["as_cartaFianza_fechaIni"]	= $row["as_cartaFianza_fechaIni"];
		$a_cnt["as_cartaFianza_fechaFin"]	= $row["as_cartaFianza_fechaFin"];
		$a_cnt["as_cartaFianza_tipo"]		= $row["as_cartaFianza_tipo"];
		$a_cnt["as_contrato_fechaIni"]		= $row["as_contrato_fechaIni"];
		$a_cnt["as_contrato_fechaFin"]		= $row["as_contrato_fechaFin"];
		$a_cnt["as_servicio_fechaIni_defa"] = $row["as_servicio_fechaIni_defa"];
		$a_cnt["as_servicio_fechaFin_defa"] = $row["as_servicio_fechaFin_defa"];
		$a_cnt["as_garantiaServicioDias"]	= $row["as_garantiaServicioDias"];
		$a_cnt["as_eqpBkp"]					= $row["as_eqpBkp"];
		$a_cnt["as_eqpBkp_cantMax"]			= $row["as_eqpBkp_cantMax"];
		$a_cnt["as_eqpBkp_antigMax"]		= $row["as_eqpBkp_antigMax"];
		$a_cnt["as_eqpBkp_rptaHrs"]			= $row["as_eqpBkp_rptaHrs"];
		$a_cnt["as_sla1"]					= $row["as_sla1"];
		$a_cnt["as_sla2"]					= $row["as_sla2"];
		$a_cnt["as_sla3"]					= $row["as_sla3"];
		$a_cnt["as_tarifaServ_monto_defa"]	= $row["as_tarifaServ_monto_defa"];
		$a_cnt["as_tarifaServ_frecuencia"]	= $row["as_tarifaServ_frecuencia"];
		$a_cnt["as_tipoServ_defa"]			= $row["as_tipoServ_defa"];
		$a_cnt["as_inc_instal"]				= $row["as_inc_instal"];
		$a_cnt["as_inc_capa"]				= $row["as_inc_capa"];
		$a_cnt["as_frecuencia_defa"]		= $row["as_frecuencia_defa"];
		$a_cnt["as_cobro_rep"]				= $row["as_cobro_rep"];
		$a_cnt["as_cobro_rep_valor"]		= $row["as_cobro_rep_valor"];
		$a_cnt["as_cobro_consum"]			= $row["as_cobro_consum"];
		$a_cnt["as_cobro_consum_valor"]		= $row["as_cobro_consum_valor"];
		$a_cnt["as_cobro_srv"]				= $row["as_cobro_srv"];
		$a_cnt["as_cobro_srv_valor"]		= $row["as_cobro_srv_valor"];
		$a_cnt["as_obs"]					= $row["as_obs"];
		$a_cnt["as_status"]					= $row["as_status"];
		$a_cnt["as_fecreg"]					= $row["as_fecreg"];
		$a_cnt["as_fecact"]					= $row["as_fecact"];
		$a_cnt["as_usrreg"]					= $row["as_usrreg"];
		$a_cnt["as_usract"]					= $row["as_usract"];
		$a_cnt["cl_nombre"]					= $row["cl_nombre"];
		$a_cnt["status_nombre"]				= $row["status_nombre"];
		$a_cnt["tipo_nombre"]				= $row["tipo_nombre"];
		return $a_cnt;
	}


	public function select($OsObj,$limit=''){
		global $usuario, $PDO;
		if ($OsObj->as_id){
			$where .= " AND as_id = :as_id";
		}
		if ($OsObj->as_tipo){
			$where .= " AND as_tipo = :as_tipo";
		}
		if ($OsObj->cl_nombre){
			$where .= " AND cl_nombre LIKE :cl_nombre";
		}
		if ($OsObj->ass_ser_id){
			$where .= " AND ass_ser_id = :ass_ser_id";
		}
		if ($OsObj->asl_pr_id){
			$where .= " AND asl_pr_id = :asl_pr_id";
		}
		if ($OsObj->as_status){
			$where .= " AND as_status = :as_status";
		}
		if ($OsObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY as_id";
		}

		if ($OsObj->detalle_lineas){
			$join .= "	LEFT JOIN pv_acuerdoServiciolinea ON as_id = asl_as_id ";
			$join .= "	LEFT JOIN im_producto ON asl_pr_id = pr_id ";
		}
		if ($OsObj->detalle_series OR $OsObj->ass_ser_id){
			$join .= "	LEFT JOIN pv_acuerdoServicioserie ON asl_id = ass_asl_id ";
			$join .= "	LEFT JOIN pv_serie ON ass_ser_id = pser_serie ";
			$join .= "	LEFT JOIN vt_clienteSuc ON ass_cls_id = cls_id ";
		}

		$sql = "
			SELECT *,
				MSTAT.mlst_valorDsc as status_nombre,
				MTIPO.mlst_valorDsc as tipo_nombre
			FROM pv_acuerdoServicio
				LEFT JOIN vt_cliente ON as_cl_id = cl_id
				LEFT JOIN xx_maestrolista MSTAT ON as_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'pvAcSrvStatus'
				LEFT JOIN xx_maestrolista MTIPO ON as_tipo = MTIPO.mlst_valorId AND MTIPO.mlst_listaId = 'pvAcSrvTipo'				
				$join
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($OsObj->as_id){
			$comando->bindParam(':as_id', $OsObj->as_id);
		}
		if ($OsObj->as_tipo){
			$comando->bindParam(':as_tipo', $OsObj->as_tipo);
		}
		if ($OsObj->cl_nombre){
			$comando->bindParam(':cl_nombre', $OsObj->cl_nombre);
		}
		if ($OsObj->ass_ser_id){
			$comando->bindParam(':ass_ser_id', $OsObj->ass_ser_id);
		}
		if ($OsObj->asl_pr_id){
			$comando->bindParam(':asl_pr_id', $OsObj->asl_pr_id);
		}
		if ($OsObj->as_status){
			$comando->bindParam(':as_status', $OsObj->as_status);
		}
		
		if ($OsObj->orderBy){
			$comando->bindParam(':orderBy', $OsObj->orderBy);
		}			
		$comando->execute();
		while($row = $comando->fetch()){

			$a_cnt["as_id"]						= $row["as_id"];
			$a_cnt["as_tipo"]					= $row["as_tipo"];
			$a_cnt["as_numero"]					= $row["as_numero"];
			$a_cnt["as_cl_id"]					= $row["as_cl_id"];
			$a_cnt["as_contacto_nombre"]		= $row["as_contacto_nombre"];
			$a_cnt["as_contacto_cargo"]			= $row["as_contacto_cargo"];
			$a_cnt["as_contacto_email"]			= $row["as_contacto_email"];
			$a_cnt["as_contacto_telf"]			= $row["as_contacto_telf"];
			$a_cnt["as_cartaFianza_numero"]		= $row["as_cartaFianza_numero"];
			$a_cnt["as_cartaFianza_valor"]		= $row["as_cartaFianza_valor"];
			$a_cnt["as_cartaFianza_fechaIni"]	= $row["as_cartaFianza_fechaIni"];
			$a_cnt["as_cartaFianza_fechaFin"]	= $row["as_cartaFianza_fechaFin"];
			$a_cnt["as_cartaFianza_tipo"]		= $row["as_cartaFianza_tipo"];
			
			$a_cnt["as_contrato_fechaIni"]		= $row["as_contrato_fechaIni"];
			$a_cnt["as_contrato_fechaFin"]		= $row["as_contrato_fechaFin"];
			$a_cnt["as_servicio_fechaIni_defa"] = $row["as_servicio_fechaIni_defa"];
			$a_cnt["as_servicio_fechaFin_defa"] = $row["as_servicio_fechaFin_defa"];
			$a_cnt["as_garantiaServicioDias"]	= $row["as_garantiaServicioDias"];
			$a_cnt["as_eqpBkp"]					= $row["as_eqpBkp"];
			$a_cnt["as_eqpBkp_cantMax"]			= $row["as_eqpBkp_cantMax"];
			$a_cnt["as_eqpBkp_antigMax"]		= $row["as_eqpBkp_antigMax"];
			$a_cnt["as_eqpBkp_rptaHrs"]			= $row["as_eqpBkp_rptaHrs"];
			$a_cnt["as_sla1"]					= $row["as_sla1"];
			$a_cnt["as_sla2"]					= $row["as_sla2"];
			$a_cnt["as_sla3"]					= $row["as_sla3"];
			$a_cnt["as_tarifaServ_monto_defa"]	= $row["as_tarifaServ_monto_defa"];
			$a_cnt["as_tarifaServ_frecuencia"]	= $row["as_tarifaServ_frecuencia"];
			$a_cnt["as_tipoServ_defa"]			= $row["as_tipoServ_defa"];
			$a_cnt["as_inc_instal"]				= $row["as_inc_instal"];
			$a_cnt["as_inc_capa"]				= $row["as_inc_capa"];
			$a_cnt["as_frecuencia_defa"]		= $row["as_frecuencia_defa"];
			$a_cnt["as_cobro_rep"]				= $row["as_cobro_rep"];
			$a_cnt["as_cobro_rep_valor"]		= $row["as_cobro_rep_valor"];
			$a_cnt["as_cobro_consum"]			= $row["as_cobro_consum"];
			$a_cnt["as_cobro_consum_valor"]		= $row["as_cobro_consum_valor"];
			$a_cnt["as_cobro_srv"]				= $row["as_cobro_srv"];
			$a_cnt["as_cobro_srv_valor"]		= $row["as_cobro_srv_valor"];
			$a_cnt["as_obs"]					= $row["as_obs"];
			$a_cnt["as_status"]					= $row["as_status"];
			$a_cnt["as_fecreg"]					= $row["as_fecreg"];
			$a_cnt["as_fecact"]					= $row["as_fecact"];
			$a_cnt["as_usrreg"]					= $row["as_usrreg"];
			$a_cnt["as_usract"]					= $row["as_usract"];
			$a_cnt["cl_nombre"]					= $row["cl_nombre"];
			$a_cnt["status_nombre"]				= $row["status_nombre"];
			$a_cnt["tipo_nombre"]				= $row["tipo_nombre"];
			if ($OsObj->detalle_lineas){
				$a_cnt["asl_id"]					= $row["asl_id"];
				$a_cnt["asl_as_id"]					= $row["asl_as_id"];
				$a_cnt["asl_pr_id"]					= $row["asl_pr_id"];
				$a_cnt["asl_cantidad"]			= $row["asl_cantidad"];
				$a_cnt["asl_tarifaServ_monto"]		= $row["asl_tarifaServ_monto"];
				$a_cnt["asl_tarifaServ_frecuencia"]	= $row["asl_tarifaServ_frecuencia"];
				$a_cnt["asl_frecuencia_defa"]		= $row["asl_frecuencia_defa"];
				$a_cnt["asl_obs"]					= $row["asl_obs"];
				$a_cnt["asl_fecreg"]				= $row["asl_fecreg"];
				$a_cnt["asl_fecact"]				= $row["asl_fecact"];
				$a_cnt["asl_usrreg"]				= $row["asl_usrreg"];
				$a_cnt["asl_usract"]				= $row["asl_usract"];
				$a_cnt["pr_productoId"]				= $row["pr_productoId"];
				$a_cnt["pr_descripcion"]			= $row["pr_descripcion"];
			}
			if ($OsObj->detalle_series){
				$a_cnt["ass_id"]					= $row["ass_id"];
				$a_cnt["ass_asl_id"]				= $row["ass_asl_id"];
				$a_cnt["ass_as_id"]					= $row["ass_as_id"];
				$a_cnt["ass_ser_id"]					= $row["ass_ser_id"];
				$a_cnt["ass_servicio_fechaIni"]		= $row["ass_servicio_fechaIni"];
				$a_cnt["ass_servicio_fechaFin"]		= $row["ass_servicio_fechaFin"];
				$a_cnt["ass_servicio_fechaPrim"]	= $row["ass_servicio_fechaPrim"];
				$a_cnt["ass_servicio_fechaUlt"]		= $row["ass_servicio_fechaUlt"];
				$a_cnt["ass_servicio_fechaProx"]	= $row["ass_servicio_fechaProx"];
				$a_cnt["ass_frecuencia"]			= $row["ass_frecuencia"];
				$a_cnt["ass_obs"]					= $row["ass_obs"];
				$a_cnt["ass_status"]				= $row["ass_status"];
				$a_cnt["ass_fecreg"]				= $row["ass_fecreg"];
				$a_cnt["ass_fecact"]				= $row["ass_fecact"];
				$a_cnt["ass_usrreg"]				= $row["ass_usrreg"];
				$a_cnt["ass_usract"]				= $row["ass_usract"];
				$a_cnt["ser_serie"]					= $row["ser_serie"];
			}
			$a_osList[] = $a_cnt;
		}
		return $a_osList;
	}


	public function update($OsObj){
		global $usuario, $PDO;
		if ($OsObj->as_tipo){
			$set .= ", as_tipo = :as_tipo";
		}
		if ($OsObj->as_numero){
			$set .= ", as_numero = :as_numero";
		}
		if ($OsObj->as_cl_id){
			$set .= ", as_cl_id = :as_cl_id";
		}
		if ($OsObj->as_contacto_nombre){
			$set .= ", as_contacto_nombre = :as_contacto_nombre";
		}
		if ($OsObj->as_contacto_cargo){
			$set .= ", as_contacto_cargo = :as_contacto_cargo";
		}
		if ($OsObj->as_contacto_email){
			$set .= ", as_contacto_email = :as_contacto_email";
		}
		if ($OsObj->as_contacto_telf){
			$set .= ", as_contacto_telf = :as_contacto_telf";
		}
		if ($OsObj->as_cartaFianza_numero){
			$set .= ", as_cartaFianza_numero = :as_cartaFianza_numero";
		}
		if ($OsObj->as_cartaFianza_valor){
			$set .= ", as_cartaFianza_valor = :as_cartaFianza_valor";
		}
		if ($OsObj->as_cartaFianza_fechaIni){
			$set .= ", as_cartaFianza_fechaIni = :as_cartaFianza_fechaIni";
		}
		if ($OsObj->as_cartaFianza_fechaFin){
			$set .= ", as_cartaFianza_fechaFin = :as_cartaFianza_fechaFin";
		}
		if ($OsObj->as_cartaFianza_tipo){
			$set .= ", as_cartaFianza_tipo = :as_cartaFianza_tipo";
		}
		
		if ($OsObj->as_contrato_fechaIni){
			$set .= ", as_contrato_fechaIni = :as_contrato_fechaIni";
		}
		if ($OsObj->as_contrato_fechaFin){
			$set .= ", as_contrato_fechaFin = :as_contrato_fechaFin";
		}
		if ($OsObj->as_servicio_fechaIni_defa){
			$set .= ", as_servicio_fechaIni_defa = :as_servicio_fechaIni_defa";
		}
		if ($OsObj->as_servicio_fechaFin_defa){
			$set .= ", as_servicio_fechaFin_defa = :as_servicio_fechaFin_defa";
		}
		if ($OsObj->as_garantiaServicioDias){
			$set .= ", as_garantiaServicioDias = :as_garantiaServicioDias";
		}
		if ($OsObj->as_eqpBkp){
			$set .= ", as_eqpBkp = :as_eqpBkp";
		}
		if ($OsObj->as_eqpBkp_cantMax){
			$set .= ", as_eqpBkp_cantMax = :as_eqpBkp_cantMax";
		}
		if ($OsObj->as_eqpBkp_antigMax){
			$set .= ", as_eqpBkp_antigMax = :as_eqpBkp_antigMax";
		}
		if ($OsObj->as_eqpBkp_rptaHrs){
			$set .= ", as_eqpBkp_rptaHrs = :as_eqpBkp_rptaHrs";
		}
		if ($OsObj->as_sla1){
			$set .= ", as_sla1 = :as_sla1";
		}
		if ($OsObj->as_sla2){
			$set .= ", as_sla2 = :as_sla2";
		}
		if ($OsObj->as_sla3){
			$set .= ", as_sla3 = :as_sla3";
		}
		if ($OsObj->as_tarifaServ_monto_defa){
			$set .= ", as_tarifaServ_monto_defa = :as_tarifaServ_monto_defa";
		}
		if ($OsObj->as_tarifaServ_frecuencia){
			$set .= ", as_tarifaServ_frecuencia = :as_tarifaServ_frecuencia";
		}
		if ($OsObj->as_tipoServ_defa){
			$set .= ", as_tipoServ_defa = :as_tipoServ_defa";
		}
		if ($OsObj->as_inc_instal){
			$set .= ", as_inc_instal = :as_inc_instal";
		}		
		if ($OsObj->as_inc_capa){
			$set .= ", as_inc_capa = :as_inc_capa";
		}
		if ($OsObj->as_frecuencia_defa){
			$set .= ", as_frecuencia_defa = :as_frecuencia_defa";
		}
		if ($OsObj->as_cobro_rep){
			$set .= ", as_cobro_rep = :as_cobro_rep";
		}
		if ($OsObj->as_cobro_rep_valor){
			$set .= ", as_cobro_rep_valor = :as_cobro_rep_valor";
		}

		if ($OsObj->as_cobro_consum){
			$set .= ", as_cobro_consum = :as_cobro_consum";
		}
		if ($OsObj->as_cobro_consum_valor){
			$set .= ", as_cobro_consum_valor = :as_cobro_consum_valor";
		}

		if ($OsObj->as_cobro_srv){
			$set .= ", as_cobro_srv = :as_cobro_srv";
		}
		if ($OsObj->as_cobro_srv_valor){
			$set .= ", as_cobro_srv_valor = :as_cobro_srv_valor";
		}
		if ($OsObj->as_obs){
			$set .= ", as_obs = :as_obs";
		}
		if (isset($OsObj->as_status)){
			$set .= ", as_status = :as_status";
		}
		$set .= ", as_fecact = :as_fecact";
		$set .= ", as_usract = :as_usract";

		if ($set && $OsObj->as_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE pv_acuerdoServicio
				SET 
					$set
					,as_usract = :as_usract
					,as_fecact = :as_fecact
				WHERE as_id = :as_id
				AND as_status <> 'C'
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':as_id', $OsObj->as_id);
			if ($OsObj->as_tipo){
				$comando->bindParam(':as_tipo', $OsObj->as_tipo);
			}
			if ($OsObj->as_numero){
				$comando->bindParam(':as_numero', $OsObj->as_numero);
			}
			if ($OsObj->as_cl_id){
				$comando->bindParam(':as_cl_id', $OsObj->as_cl_id);
			}
			if ($OsObj->as_contacto_nombre){
				$comando->bindParam(':as_contacto_nombre', $OsObj->as_contacto_nombre);
			}
			if ($OsObj->as_contacto_cargo){
				$comando->bindParam(':as_contacto_cargo', $OsObj->as_contacto_cargo);
			}
			if ($OsObj->as_contacto_email){
				$comando->bindParam(':as_contacto_email', $OsObj->as_contacto_email);
			}
			if ($OsObj->as_contacto_telf){
				$comando->bindParam(':as_contacto_telf', $OsObj->as_contacto_telf);
			}
			if ($OsObj->as_cartaFianza_numero){
				$comando->bindParam(':as_cartaFianza_numero', $OsObj->as_cartaFianza_numero);
			}
			if ($OsObj->as_cartaFianza_valor){
				$comando->bindParam(':as_cartaFianza_valor', $OsObj->as_cartaFianza_valor);
			}
			if ($OsObj->as_cartaFianza_fechaIni){
				$comando->bindParam(':as_cartaFianza_fechaIni', $OsObj->as_cartaFianza_fechaIni);
			}
			if ($OsObj->as_cartaFianza_fechaFin){
				$comando->bindParam(':as_cartaFianza_fechaFin', $OsObj->as_cartaFianza_fechaFin);
			}
			if ($OsObj->as_cartaFianza_tipo){
				$comando->bindParam(':as_cartaFianza_tipo', $OsObj->as_cartaFianza_tipo);
			}
			
			if ($OsObj->as_contrato_fechaIni){
				$comando->bindParam(':as_contrato_fechaIni', $OsObj->as_contrato_fechaIni);
			}
			if ($OsObj->as_contrato_fechaFin){
				$comando->bindParam(':as_contrato_fechaFin', $OsObj->as_contrato_fechaFin);
			}
			if ($OsObj->as_servicio_fechaIni_defa){
				$comando->bindParam(':as_servicio_fechaIni_defa', $OsObj->as_servicio_fechaIni_defa);
			}
			if ($OsObj->as_servicio_fechaFin_defa){
				$comando->bindParam(':as_servicio_fechaFin_defa', $OsObj->as_servicio_fechaFin_defa);
			}
			if ($OsObj->as_garantiaServicioDias){
				$comando->bindParam(':as_garantiaServicioDias', $OsObj->as_garantiaServicioDias);
			}
			if ($OsObj->as_eqpBkp){
				$comando->bindParam(':as_eqpBkp', $OsObj->as_eqpBkp);
			}
			if ($OsObj->as_eqpBkp_cantMax){
				$comando->bindParam(':as_eqpBkp_cantMax', $OsObj->as_eqpBkp_cantMax);
			}
			if ($OsObj->as_eqpBkp_antigMax){
				$comando->bindParam(':as_eqpBkp_antigMax', $OsObj->as_eqpBkp_antigMax);
			}
			if ($OsObj->as_eqpBkp_rptaHrs){
				$comando->bindParam(':as_eqpBkp_rptaHrs', $OsObj->as_eqpBkp_rptaHrs);
			}
			if ($OsObj->as_sla1){
				$comando->bindParam(':as_sla1', $OsObj->as_sla1);
			}
			if ($OsObj->as_sla2){
				$comando->bindParam(':as_sla2', $OsObj->as_sla2);
			}
			if ($OsObj->as_sla3){
				$comando->bindParam(':as_sla3', $OsObj->as_sla3);
			}
			if ($OsObj->as_tarifaServ_monto_defa){
				$comando->bindParam(':as_tarifaServ_monto_defa', $OsObj->as_tarifaServ_monto_defa);
			}
			if ($OsObj->as_tarifaServ_frecuencia){
				$comando->bindParam(':as_tarifaServ_frecuencia', $OsObj->as_tarifaServ_frecuencia);
			}
			if (isset($OsObj->as_tipoServ_defa)){
				$comando->bindParam(':as_tipoServ_defa', $OsObj->as_tipoServ_defa);
			}
			if (isset($OsObj->as_inc_instal)){
				$comando->bindParam(':as_inc_instal', $OsObj->as_inc_instal);
			}
			if (isset($OsObj->as_inc_capa)){
				$comando->bindParam(':as_inc_capa', $OsObj->as_inc_capa);
			}
			if (isset($OsObj->as_frecuencia_defa)){
				$comando->bindParam(':as_frecuencia_defa', $OsObj->as_frecuencia_defa);
			}
			if (isset($OsObj->as_cobro_rep)){
				$comando->bindParam(':as_cobro_rep', $OsObj->as_cobro_rep);
			}
			if (isset($OsObj->as_cobro_rep_valor)){
				$comando->bindParam(':as_cobro_rep_valor', $OsObj->as_cobro_rep_valor);
			}
			if (isset($OsObj->as_cobro_consum)){
				$comando->bindParam(':as_cobro_consum', $OsObj->as_cobro_consum);
			}
			if (isset($OsObj->as_cobro_consum_valor)){
				$comando->bindParam(':as_cobro_consum_valor', $OsObj->as_cobro_consum_valor);
			}

			if (isset($OsObj->as_cobro_srv)){
				$comando->bindParam(':as_cobro_srv', $OsObj->as_cobro_srv);
			}
			if (isset($OsObj->as_cobro_srv_valor)){
				$comando->bindParam(':as_cobro_srv_valor', $OsObj->as_cobro_srv_valor);
			}

			if (isset($OsObj->as_obs)){
				$comando->bindParam(':as_obs', $OsObj->as_obs);
			}
			if (isset($OsObj->as_status)){
				$comando->bindParam(':as_status', $OsObj->as_status);
			}
			$OsObj->as_fecact = date("Y-m-d H:i:s");
			$comando->bindParam(':as_usract', $usuario);
			$comando->bindParam(':as_fecact', $OsObj->as_fecact);
			$comando->execute();
			print_r($OsObj);
			print_r($comando->errorInfo());
			echo "<pre>".$sql2."</pre>";
//			exit;
			return $OsObj->as_id;
		}
	}

	public function insert($OsObj){
		global $PDO, $usuario;
		$sql = "
			INSERT INTO pv_acuerdoServicio 
			(
			as_tipo,
			as_numero,
			as_cl_id,
			as_contacto_nombre,
			as_contacto_cargo,
			as_contacto_email,
			as_contacto_telf,
			as_cartaFianza_numero,
			as_cartaFianza_valor,
			as_cartaFianza_fechaIni,
			as_cartaFianza_fechaFin,
			as_cartaFianza_tipo,
			as_contrato_fechaIni,
			as_contrato_fechaFin,
			as_servicio_fechaIni_defa,
			as_servicio_fechaFin_defa,
			as_garantiaServicioDias,
			as_eqpBkp,
			as_eqpBkp_cantMax,
			as_eqpBkp_antigMax,
			as_eqpBkp_rptaHrs,
			as_sla1,
			as_sla2,
			as_sla3,
			as_tarifaServ_monto_defa,
			as_tarifaServ_frecuencia,
			as_tipoServ_defa,
			as_inc_instal,
			as_inc_capa,
			as_frecuencia_defa,
			as_cobro_rep,
			as_cobro_rep_valor,
			as_cobro_consum,
			as_cobro_consum_valor,
			as_cobro_srv,
			as_cobro_srv_valor,
			as_obs,
			as_status,
			as_fecreg,
			as_usrreg
			) 
			VALUES 
			(
			:as_tipo,
			:as_numero,
			:as_cl_id,
			:as_contacto_nombre,
			:as_contacto_cargo,
			:as_contacto_email,
			:as_contacto_telf,
			:as_cartaFianza_numero,
			:as_cartaFianza_valor,
			:as_cartaFianza_fechaIni,
			:as_cartaFianza_fechaFin,
			:as_cartaFianza_tipo,
			:as_contrato_fechaIni,
			:as_contrato_fechaFin,
			:as_servicio_fechaIni_defa,
			:as_servicio_fechaFin_defa,
			:as_garantiaServicioDias,
			:as_eqpBkp,
			:as_eqpBkp_cantMax,
			:as_eqpBkp_antigMax,
			:as_eqpBkp_rptaHrs,
			:as_sla1,
			:as_sla2,
			:as_sla3,
			:as_tarifaServ_monto_defa,
			:as_tarifaServ_frecuencia,
			:as_tipoServ_defa,
			:as_inc_instal,
			:as_inc_capa,
			:as_frecuencia_defa,
			:as_cobro_rep,
			:as_cobro_rep_valor,
			:as_cobro_consum,
			:as_cobro_consum_valor,
			:as_cobro_srv,
			:as_cobro_srv_valor,
			:as_obs,
			:as_status,
			:as_fecreg,
			:as_usrreg
			);			
		";
//		print_r($OsObj);
		//exit;
		$OsObj->as_fecreg = date("Y-m-d H:i:s");
		$OsObj->as_usrreg = $usuario;
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':as_tipo', $OsObj->as_tipo);
		$comando->bindParam(':as_numero', $OsObj->as_numero);
		$comando->bindParam(':as_cl_id', $OsObj->as_cl_id);
		$comando->bindParam(':as_contacto_nombre', $OsObj->as_contacto_nombre);
		$comando->bindParam(':as_contacto_cargo', $OsObj->as_contacto_cargo);
		$comando->bindParam(':as_contacto_email', $OsObj->as_contacto_email);
		$comando->bindParam(':as_contacto_telf', $OsObj->as_contacto_telf);
		$comando->bindParam(':as_cartaFianza_numero', $OsObj->as_cartaFianza_numero);
		$comando->bindParam(':as_cartaFianza_valor', $OsObj->as_cartaFianza_valor);
		$comando->bindParam(':as_cartaFianza_fechaIni', $OsObj->as_cartaFianza_fechaIni);
		$comando->bindParam(':as_cartaFianza_fechaFin', $OsObj->as_cartaFianza_fechaFin);
		$comando->bindParam(':as_cartaFianza_tipo', $OsObj->as_cartaFianza_tipo);
		$comando->bindParam(':as_contrato_fechaIni', $OsObj->as_contrato_fechaIni);
		$comando->bindParam(':as_contrato_fechaFin', $OsObj->as_contrato_fechaFin);
		$comando->bindParam(':as_servicio_fechaIni_defa', $OsObj->as_servicio_fechaIni_defa);
		$comando->bindParam(':as_servicio_fechaFin_defa', $OsObj->as_servicio_fechaFin_defa);
		$comando->bindParam(':as_garantiaServicioDias', $OsObj->as_garantiaServicioDias);
		$comando->bindParam(':as_eqpBkp', $OsObj->as_eqpBkp);
		$comando->bindParam(':as_eqpBkp_cantMax', $OsObj->as_eqpBkp_cantMax);
		$comando->bindParam(':as_eqpBkp_antigMax', $OsObj->as_eqpBkp_antigMax);
		$comando->bindParam(':as_eqpBkp_rptaHrs', $OsObj->as_eqpBkp_rptaHrs);
		$comando->bindParam(':as_sla1', $OsObj->as_sla1);
		$comando->bindParam(':as_sla2', $OsObj->as_sla2);
		$comando->bindParam(':as_sla3', $OsObj->as_sla3);
		$comando->bindParam(':as_tarifaServ_monto_defa', $OsObj->as_tarifaServ_monto_defa);
		$comando->bindParam(':as_tarifaServ_frecuencia', $OsObj->as_tarifaServ_frecuencia);
		$comando->bindParam(':as_tipoServ_defa', $OsObj->as_tipoServ_defa);
		$comando->bindParam(':as_inc_instal', $OsObj->as_inc_instal);
		$comando->bindParam(':as_inc_capa', $OsObj->as_inc_capa);
		$comando->bindParam(':as_frecuencia_defa', $OsObj->as_frecuencia_defa);
		$comando->bindParam(':as_cobro_rep', $OsObj->as_cobro_rep);
		$comando->bindParam(':as_cobro_rep_valor', $OsObj->as_cobro_rep_valor);
		$comando->bindParam(':as_cobro_consum', $OsObj->as_cobro_consum);
		$comando->bindParam(':as_cobro_consum_valor', $OsObj->as_cobro_consum_valor);
		$comando->bindParam(':as_cobro_srv', $OsObj->as_cobro_srv);
		$comando->bindParam(':as_cobro_srv_valor', $OsObj->as_cobro_srv_valor);
		$comando->bindParam(':as_obs', $OsObj->as_obs);
		$comando->bindParam(':as_status', $OsObj->as_status);
		$comando->bindParam(':as_fecreg', $OsObj->as_fecreg);
		$comando->bindParam(':as_usrreg', $OsObj->as_usrreg);
		$comando->execute();	
//			print_r($comando->errorInfo());
//  exit;
		$query	 = "
			SELECT DISTINCT max(as_id) as id 
			FROM pv_acuerdoServicio 
			WHERE as_usrreg = :as_usrreg 
				AND as_fecreg = :as_fecreg ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':as_usrreg', $OsObj->as_usrreg);
		$comando->bindParam(':as_fecreg', $OsObj->as_fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}



}


class PvAcuerdoServicioLineaModel{

	public function insert($AcuerdoServLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			pv_acuerdoServiciolinea 
			(
			asl_id,
			asl_as_id,
			asl_pr_id,
			asl_cantidad,
			asl_tarifaServ_monto,
			asl_tarifaServ_frecuencia,
			asl_frecuencia_defa,
			asl_obs,
			asl_fecreg,
			asl_usrreg
			) 
			VALUES 
			(
			:asl_id,
			:asl_as_id,
			:asl_pr_id,
			:asl_cantidad,
			:asl_tarifaServ_monto,
			:asl_tarifaServ_frecuencia,
			:asl_frecuencia_defa,
			:asl_obs,
			:asl_fecreg,
			:asl_usrreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$AcuerdoServLineaObj->asl_fecreg = date("Y-m-d H:i:s");
		$AcuerdoServLineaObj->asl_usrreg = $usuario;
		$comando->bindParam(':asl_id', $AcuerdoServLineaObj->asl_id);
		$comando->bindParam(':asl_as_id', $AcuerdoServLineaObj->asl_as_id);
		$comando->bindParam(':asl_pr_id', $AcuerdoServLineaObj->asl_pr_id);
		$comando->bindParam(':asl_cantidad', $AcuerdoServLineaObj->asl_cantidad);
		$comando->bindParam(':asl_tarifaServ_monto', $AcuerdoServLineaObj->asl_tarifaServ_monto);
		$comando->bindParam(':asl_tarifaServ_frecuencia', $AcuerdoServLineaObj->asl_tarifaServ_frecuencia);
		$comando->bindParam(':asl_frecuencia_defa', $AcuerdoServLineaObj->asl_frecuencia_defa);
		$comando->bindParam(':asl_obs', $AcuerdoServLineaObj->asl_obs);
		$comando->bindParam(':asl_fecreg', $AcuerdoServLineaObj->asl_fecreg);
		$comando->bindParam(':asl_usrreg', $AcuerdoServLineaObj->asl_usrreg);
		$comando->execute();

		$query	 = "
			SELECT DISTINCT max(asl_id) as id 
			FROM pv_acuerdoServiciolinea 
			WHERE asl_fecreg = '".$AcuerdoServLineaObj->asl_fecreg."' 
				AND asl_usrreg = '".$AcuerdoServLineaObj->asl_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_acuerdoServiciolinea
			WHERE asl_id = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id,$chkCant=''){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		if ($chkCant){
			$where = " AND asl_cantidad > 0 ";
		}
		$sql = "
			SELECT *
			FROM pv_acuerdoServiciolinea
				LEFT JOIN im_producto P ON asl_pr_id = pr_id
				LEFT JOIN pv_acuerdoServicio D ON asl_as_id = as_id
			WHERE asl_as_id = :asl_as_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':asl_as_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["asl_id"]						= $row["asl_id"];
			$a_linea["asl_as_id"]					= $row["asl_as_id"];
			$a_linea["asl_pr_id"]					= $row["asl_pr_id"];
			$a_linea["asl_cantidad"]				= $row["asl_cantidad"];
			$a_linea["asl_tarifaServ_monto"]		= $row["asl_tarifaServ_monto"];
			$a_linea["asl_tarifaServ_frecuencia"]	= $row["asl_tarifaServ_frecuencia"];
			$a_linea["asl_frecuencia_defa"]			= $row["asl_frecuencia_defa"];
			$a_linea["asl_obs"]						= $row["asl_obs"];
			$a_linea["asl_fecreg"]					= $row["asl_fecreg"];
			$a_linea["asl_usrreg"]					= $row["asl_usrreg"];
			$a_linea["pr_productoId"]				= $row["pr_productoId"];
			$a_linea["pr_descripcion"]				= $row["pr_descripcion"];			
			$a_totallinea[]							= $a_linea;
		}
		return $a_totallinea;
	}


	public function selectUniqueIdLinea($id,$chkCant=''){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		if ($chkCant){
			$where = " AND asl_cantidad > 0 ";
		}
		$sql = "
			SELECT *
			FROM pv_acuerdoServiciolinea
				LEFT JOIN im_producto P ON asl_pr_id = pr_id
				LEFT JOIN pv_acuerdoServicio D ON asl_as_id = as_id
			WHERE asl_id = :asl_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':asl_id', $id);
		}
		$comando->execute();
		$row = $comando->fetch();
		$a_linea["asl_id"]						= $row["asl_id"];
		$a_linea["asl_as_id"]					= $row["asl_as_id"];
		$a_linea["asl_pr_id"]					= $row["asl_pr_id"];
		$a_linea["asl_cantidad"]				= $row["asl_cantidad"];
		$a_linea["asl_tarifaServ_monto"]		= $row["asl_tarifaServ_monto"];
		$a_linea["asl_tarifaServ_frecuencia"]	= $row["asl_tarifaServ_frecuencia"];
		$a_linea["asl_frecuencia_defa"]			= $row["asl_frecuencia_defa"];
		$a_linea["asl_obs"]						= $row["asl_obs"];
		$a_linea["asl_fecreg"]					= $row["asl_fecreg"];
		$a_linea["asl_usrreg"]					= $row["asl_usrreg"];
		$a_linea["pr_productoId"]				= $row["pr_productoId"];
		$a_linea["pr_descripcion"]				= $row["pr_descripcion"];			
		return $a_linea;
	}

}



class PvAcuerdoServicioSerieModel{

	public function insert($AcuerdoServSerieObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			pv_acuerdoServicioserie
			(
			ass_id,
			ass_asl_id,
			ass_as_id,
			ass_ser_id,
			ass_cls_id,
			ass_servicio_fechaIni,
			ass_servicio_fechaFin,
			ass_servicio_fechaPrim,
			ass_servicio_fechaUlt,
			ass_servicio_fechaProx,
			ass_frecuencia,
			ass_tarifaServ_monto,
			ass_obs,
			ass_status,
			ass_fecreg,
			ass_usrreg
			) 
			VALUES 
			(
			:ass_id,
			:ass_asl_id,
			:ass_as_id,
			:ass_ser_id,
			:ass_cls_id,
			:ass_servicio_fechaIni,
			:ass_servicio_fechaFin,
			:ass_servicio_fechaPrim,
			:ass_servicio_fechaUlt,
			:ass_servicio_fechaProx,
			:ass_frecuencia,
			:ass_tarifaServ_monto,
			:ass_obs,
			:ass_status,
			:ass_fecreg,
			:ass_usrreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$AcuerdoServSerieObj->ass_fecreg = date("Y-m-d H:i:s");
		$AcuerdoServSerieObj->ass_usrreg = $usuario;
		$comando->bindParam(':ass_id', $AcuerdoServSerieObj->ass_id);
		$comando->bindParam(':ass_asl_id', $AcuerdoServSerieObj->ass_asl_id);
		$comando->bindParam(':ass_as_id', $AcuerdoServSerieObj->ass_as_id);
		$comando->bindParam(':ass_ser_id', $AcuerdoServSerieObj->ass_ser_id);
		$comando->bindParam(':ass_cls_id', $AcuerdoServSerieObj->ass_cls_id);
		$comando->bindParam(':ass_servicio_fechaIni', $AcuerdoServSerieObj->ass_servicio_fechaIni);
		$comando->bindParam(':ass_servicio_fechaFin', $AcuerdoServSerieObj->ass_servicio_fechaFin);
		$comando->bindParam(':ass_servicio_fechaPrim', $AcuerdoServSerieObj->ass_servicio_fechaPrim);
		$comando->bindParam(':ass_servicio_fechaUlt', $AcuerdoServSerieObj->ass_servicio_fechaUlt);
		$comando->bindParam(':ass_servicio_fechaProx', $AcuerdoServSerieObj->ass_servicio_fechaProx);
		$comando->bindParam(':ass_frecuencia', $AcuerdoServSerieObj->ass_frecuencia);
		$comando->bindParam(':ass_tarifaServ_monto', $AcuerdoServSerieObj->ass_tarifaServ_monto);
		$comando->bindParam(':ass_obs', $AcuerdoServSerieObj->ass_obs);
		$comando->bindParam(':ass_status', $AcuerdoServSerieObj->ass_status);
		$comando->bindParam(':ass_fecreg', $AcuerdoServSerieObj->ass_fecreg);
		$comando->bindParam(':ass_usrreg', $AcuerdoServSerieObj->ass_usrreg);
		$comando->execute();
			//print_r($comando->errorInfo());
		$query	 = "
			SELECT DISTINCT max(ass_id) as id 
			FROM pv_acuerdoServicioserie 
			WHERE ass_fecreg = '".$AcuerdoServSerieObj->ass_fecreg."' 
				AND ass_usrreg = '".$AcuerdoServSerieObj->ass_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_acuerdoServicioserie
			WHERE ass_id = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function deleteLinea($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_acuerdoServicioserie
			WHERE ass_asl_id = :lineaId
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_acuerdoServicioserie
				LEFT JOIN pv_acuerdoServiciolinea D ON ass_asl_id = asl_id
				LEFT JOIN im_producto P ON asl_pr_id = pr_id
			WHERE ass_as_id = :ass_as_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':ass_as_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["ass_id"]					= $row["ass_id"];
			$a_linea["ass_asl_id"]				= $row["ass_asl_id"];
			$a_linea["ass_as_id"]				= $row["ass_as_id"];
			$a_linea["ass_ser_id"]				= $row["ass_ser_id"];
			$a_linea["ass_cls_id"]				= $row["ass_cls_id"];
			$a_linea["ass_servicio_fechaIni"]	= $row["ass_servicio_fechaIni"];
			$a_linea["ass_servicio_fechaFin"]	= $row["ass_servicio_fechaFin"];
			$a_linea["ass_servicio_fechaPrim"]	= $row["ass_servicio_fechaPrim"];
			$a_linea["ass_servicio_fechaUlt"]	= $row["ass_servicio_fechaUlt"];
			$a_linea["ass_servicio_fechaProx"]	= $row["ass_servicio_fechaProx"];
			$a_linea["ass_frecuencia"]			= $row["ass_frecuencia"];
			$a_linea["ass_tarifaServ_monto"]	= $row["ass_tarifaServ_monto"];
			$a_linea["ass_obs"]					= $row["ass_obs"];	
			$a_linea["ass_status"]				= $row["ass_status"];	
			$a_linea["ass_fecreg"]				= $row["ass_fecreg"];	
			$a_linea["ass_fecact"]				= $row["ass_fecact"];	
			$a_linea["ass_usrreg"]				= $row["ass_usrreg"];	
			$a_linea["ass_usract"]				= $row["ass_usract"];	
			$a_linea["pr_productoId"]			= $row["pr_productoId"];	
			$a_linea["pr_descripcion"]			= $row["pr_descripcion"];
			$a_totallinea[]						= $a_linea;
		}
		return $a_totallinea;
	}


	public function select($GuiaFilter){
		global $PDO;
		if ($GuiaFilter->ass_as_id){
			$where .=  " AND ass_as_id = :ass_as_id";
		}
		if ($GuiaFilter->ass_asl_id){
			$where .=  " AND ass_asl_id = :ass_asl_id";
		}
		if ($GuiaFilter->asl_pr_id){
			$where .=  " AND asl_pr_id = :asl_pr_id";
		}
		if ($GuiaFilter->ser_serie){
			$where .=  " AND ser_serie = :ser_serie";
		}

		if ($where){
			$sql = "
				SELECT *
				FROM pv_acuerdoServicioserie
					LEFT JOIN pv_acuerdoServiciolinea ON ass_asl_id = asl_id
					LEFT JOIN vt_clienteSuc ON ass_cls_id = cls_id
					LEFT JOIN im_serie ON ass_ser_id = ser_id
					LEFT JOIN im_producto ON ser_prId = pr_id
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($GuiaFilter->ass_as_id){
				$comando->bindParam(':ass_as_id', $GuiaFilter->ass_as_id);
			}
			if ($GuiaFilter->ass_asl_id){
				$comando->bindParam(':ass_asl_id', $GuiaFilter->ass_asl_id);
			}
			if ($GuiaFilter->asl_pr_id){
				$comando->bindParam(':asl_pr_id', $GuiaFilter->asl_pr_id);
			}
			if ($GuiaFilter->ser_serie){
				$comando->bindParam(':ser_serie', $GuiaFilter->ser_serie);
			}

			$comando->execute();
			/*
			print_r($comando->errorInfo());
			print_r($GuiaFilter);
			exit($sql);
			*/
			while($row = $comando->fetch()){
				$a_linea["ass_id"]			= $row["ass_id"];
				$a_linea["ass_as_id"]		= $row["ass_as_id"];
				$a_linea["ass_asl_id"]		= $row["ass_asl_id"];
				$a_linea["ass_obs"]			= $row["ass_obs"];
				$a_linea["ass_ser_id"]		= $row["ass_ser_id"];
				$a_linea["ass_cls_id"]				= $row["ass_cls_id"];
				$a_linea["ass_servicio_fechaIni"]	= $row["ass_servicio_fechaIni"];
				$a_linea["ass_servicio_fechaFin"]	= $row["ass_servicio_fechaFin"];
				if ($row["ass_frecuencia"] < 1){
					$a_linea["ass_frecuencia"]	= $row["ass_frecuencia"];
				}else{
					$a_linea["ass_frecuencia"]	= (int) $row["ass_frecuencia"];
				}
				$a_linea["ass_tarifaServ_monto"]	= $row["ass_tarifaServ_monto"];
				$a_linea["ass_usrreg"]		= $row["ass_usrreg"];
				$a_linea["ass_fecreg"]		= $row["ass_fecreg"];
				$a_linea["pr_productoId"]	= $row["pr_productoId"];
				$a_linea["ser_prId"]		= $row["ser_prId"];
				$a_linea["ser_serie"]		= $row["ser_serie"];
				$a_linea["ser_id"]			= $row["ser_id"];
				$a_linea["cls_nombre"]		= $row["cls_nombre"];

				$a_lineaserie[]	= $a_linea;
			}
			return $a_lineaserie;
			
		}
	}

}


class PvAcuerdoServicioProgModel{

	public function insert($AcuerdoServProgObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			pv_acuerdoServicioprog
			(
			asp_id,
			asp_as_id,
			asp_ass_id,
			asp_tipo,
			asp_fechaProg,
			asp_tarifaServ_monto,
			asp_docNumRef,
			asp_obs,
			asp_status,
			asp_usrreg,
			asp_fecreg
			) 
			VALUES 
			(
			:asp_id,
			:asp_as_id,
			:asp_ass_id,
			:asp_tipo,
			:asp_fechaProg,
			:asp_tarifaServ_monto,
			:asp_docNumRef,
			:asp_obs,
			:asp_status,
			:asp_usrreg,
			:asp_fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$AcuerdoServProgObj->asp_fecreg = date("Y-m-d H:i:s");
		$AcuerdoServProgObj->asp_usrreg = $usuario;
		$comando->bindParam(':asp_id', $AcuerdoServProgObj->asp_id);
		$comando->bindParam(':asp_as_id', $AcuerdoServProgObj->asp_as_id);
		$comando->bindParam(':asp_ass_id', $AcuerdoServProgObj->asp_ass_id);
		$comando->bindParam(':asp_tipo', $AcuerdoServProgObj->asp_tipo);
		$comando->bindParam(':asp_fechaProg', $AcuerdoServProgObj->asp_fechaProg);
		$comando->bindParam(':asp_tarifaServ_monto', $AcuerdoServProgObj->asp_tarifaServ_monto);		
		$comando->bindParam(':asp_docNumRef', $AcuerdoServProgObj->asp_docNumRef);
		$comando->bindParam(':asp_obs', $AcuerdoServProgObj->asp_obs);
		$comando->bindParam(':asp_status', $AcuerdoServProgObj->asp_status);
		$comando->bindParam(':asp_usrreg', $AcuerdoServProgObj->asp_usrreg);
		$comando->bindParam(':asp_fecreg', $AcuerdoServProgObj->asp_fecreg);
		$comando->execute();
	//		print_r($comando->errorInfo());
		$query	 = "
			SELECT DISTINCT max(asp_id) as id 
			FROM pv_acuerdoServicioprog 
			WHERE asp_fecreg = '".$AcuerdoServProgObj->asp_fecreg."' 
				AND asp_usrreg = '".$AcuerdoServProgObj->asp_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}


	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_acuerdoServicioprog
			WHERE asp_id = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id,$chkCant=''){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_acuerdoServicioprog
				LEFT JOIN pv_acuerdoServicioserie D ON asp_ass_id = ass_id
				LEFT JOIN im_serie S ON ass_serie_id = ser_id
			WHERE asp_ass_id = :asp_ass_id
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':asp_as_id', $id);
		}
		$comando->execute();
		while($row = $comando->fetch()){
			$a_linea["asp_id"]			= $row["asp_id"];
			$a_linea["asp_as_id"]		= $row["asp_as_id"];
			$a_linea["asp_ass_id"]		= $row["asp_ass_id"];
			$a_linea["asp_tipo"]		= $row["asp_tipo"];
			$a_linea["asp_fechaProg"]	= $row["asp_fechaProg"];
			$a_linea["asp_tarifaServ_monto"]	= $row["asp_tarifaServ_monto"];
			$a_linea["asp_docNumRef"]	= $row["asp_docNumRef"];
			$a_linea["asp_docNumRef2"]	= $row["asp_docNumRef2"];
			$a_linea["asp_obs"]			= $row["asp_obs"];
			$a_linea["asp_status"]		= $row["asp_status"];
			$a_linea["asp_usrreg"]		= $row["asp_usrreg"];
			$a_linea["asp_usract"]		= $row["asp_usract"];
			$a_linea["asp_fecreg"]		= $row["asp_fecreg"];
			$a_linea["asp_fecact"]		= $row["asp_fecact"];
			$a_linea["ser_serie"]		= $row["ser_serie"];	
			$a_linea["ass_frecuencia"]	= $row["ass_frecuencia"];	
			$a_linea["ass_status"]		= $row["ass_status"];	
			$a_linea["pr_productoId"]	= $row["pr_productoId"];	
			$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
			$a_totallinea[]				= $a_linea;
		}
		return $a_totallinea;
	}


	public function select($AcuerdoServProgFilter){
		global $PDO;
		if ($AcuerdoServProgFilter->asp_id){
			$where .=  " AND asp_id = :asp_id";
		}
		if ($AcuerdoServProgFilter->asp_ass_id){
			$where .=  " AND asp_ass_id = :asp_ass_id";
		}
		if ($AcuerdoServProgFilter->asp_as_id){
			$where .=  " AND asp_as_id = :asp_as_id";
		}
		if ($AcuerdoServProgFilter->ser_serie){
			$where .=  " AND ser_serie = :ser_serie";
		}

		if (!$AcuerdoServProgFilter->orderBy){
			$order = " ORDER BY cls_nombre, pr_productoId, ser_serie, asp_fechaProg ";
		}else{
			$order = " ORDER BY ".$AcuerdoServProgFilter->orderBy;
		}

		if ($where){
			$sql = "
				SELECT *
				FROM pv_acuerdoServicioprog
					LEFT JOIN pv_acuerdoServicioserie ON asp_ass_id = ass_id
					LEFT JOIN pv_acuerdoServiciolinea ON ass_asl_id = asl_id
					LEFT JOIN vt_clienteSuc ON ass_cls_id = cls_id
					LEFT JOIN im_serie ON ass_ser_id = ser_id
					LEFT JOIN im_producto ON ser_prId = pr_id
					LEFT JOIN pv_ordenServicio ON asp_docNumRef2 = os_id AND os_status <> 'A'
				WHERE 1 $where
			";			
			$comando = $PDO->prepare($sql);
			if ($AcuerdoServProgFilter->asp_id){
				$comando->bindParam(':asp_id', $AcuerdoServProgFilter->asp_id);
			}
			if ($AcuerdoServProgFilter->asp_ass_id){
				$comando->bindParam(':asp_ass_id', $AcuerdoServProgFilter->asp_ass_id);
			}
			if ($AcuerdoServProgFilter->asp_as_id){
				$comando->bindParam(':asp_as_id', $AcuerdoServProgFilter->asp_as_id);
			}
			if ($AcuerdoServProgFilter->ser_serie){
				$comando->bindParam(':ser_serie', $AcuerdoServProgFilter->ser_serie);
			}

			$comando->execute();
			while($row = $comando->fetch()){
				$a_linea["asp_id"]			= $row["asp_id"];
				$a_linea["asp_as_id"]		= $row["asp_as_id"];
				$a_linea["asp_ass_id"]		= $row["asp_ass_id"];
				$a_linea["asp_tipo"]		= $row["asp_tipo"];
				$a_linea["asp_fechaProg"]	= $row["asp_fechaProg"];
				$a_linea["asp_tarifaServ_monto"]	= $row["asp_tarifaServ_monto"];
				$a_linea["asp_docNumRef"]	= $row["asp_docNumRef"];
				$a_linea["asp_docNumRef2"]	= $row["asp_docNumRef2"];
				$a_linea["asp_obs"]			= $row["asp_obs"];
				$a_linea["asp_status"]		= $row["asp_status"];
				$a_linea["asp_usrreg"]		= $row["asp_usrreg"];
				$a_linea["asp_usract"]		= $row["asp_usract"];
				$a_linea["asp_fecreg"]		= $row["asp_fecreg"];
				$a_linea["asp_fecact"]		= $row["asp_fecact"];
				$a_linea["ser_serie"]		= $row["ser_serie"];	
				$a_linea["ass_frecuencia"]	= $row["ass_frecuencia"];	
				$a_linea["ass_status"]		= $row["ass_status"];	
				$a_linea["pr_productoId"]	= $row["pr_productoId"];	
				$a_linea["pr_descripcion"]	= $row["pr_descripcion"];
				$a_linea["cls_id"]			= $row["cls_id"];
				$a_linea["cls_nombre"]		= $row["cls_nombre"];
				$a_linea["os_fecha"]		= $row["os_fecha"];
				$a_linea["os_status"]		= $row["os_status"];
				$a_lineaserie[]	= $a_linea;
			}
			return $a_lineaserie;
			
		}
	}


	public function update($OsObj){
		global $usuario, $PDO;
		if ($OsObj->asp_docNumRef){
			$set .= ", asp_docNumRef = :asp_docNumRef";
		}
		if ($OsObj->asp_docNumRef2){
			$set .= ", asp_docNumRef2 = :asp_docNumRef2";
		}
		if ($OsObj->asp_status){
			$set .= ", asp_status = :asp_status";
		}

		if ($set && $OsObj->asp_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE pv_acuerdoServicioprog
				SET 
					$set
					,asp_usract = :asp_usract
					,asp_fecact = :asp_fecact
				WHERE asp_id = :asp_id
				AND asp_status IS NULL
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':asp_id', $OsObj->asp_id);
			if ($OsObj->asp_docNumRef){
				$comando->bindParam(':asp_docNumRef', $OsObj->asp_docNumRef);
			}
			if ($OsObj->asp_docNumRef2){
				$comando->bindParam(':asp_docNumRef2', $OsObj->asp_docNumRef2);
			}
			if ($OsObj->asp_status){
				$comando->bindParam(':asp_status', $OsObj->asp_status);
			}
			$OsObj->asp_fecact = date("Y-m-d H:i:s");
			$comando->bindParam(':asp_usract', $usuario);
			$comando->bindParam(':asp_fecact', $OsObj->asp_fecact);
			$comando->execute();
			return $OsObj->asp_id;
		}
	}

}

?>