<?php

class PvOrdenServicioGastoLiqModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *, 
				MSTAT.mlst_valorDsc as status_nombre
			FROM pv_ordenServicio_gasto_liq
				LEFT JOIN pv_tecnico ON lq_tch_id = tec_id
				LEFT JOIN xx_maestrolista MSTAT ON lq_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'pvLiqStatus'
			WHERE lq_id = :id
			ORDER BY lq_fecha
		";					
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		/*
		print_r($comando->errorInfo());
		exit;
		*/
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0]; 
		$a_liq["lq_id"]					= $row["lq_id"];
		$a_liq["lq_fecha"]				= $row["lq_fecha"];
		$a_liq["lq_tch_id"]				= $row["lq_tch_id"];
		$a_liq["lq_obs"]				= $row["lq_obs"];
		$a_liq["lq_aprob_usr"]			= $row["lq_aprob_usr"];
		$a_liq["lq_aprob_fecreg"]		= $row["lq_aprob_fecreg"];
		$a_liq["lq_status"]				= $row["lq_status"];
		$a_liq["lq_usrreg"]				= $row["lq_usrreg"];
		$a_liq["lq_usract"]				= $row["lq_usract"];
		$a_liq["lq_fecreg"]				= $row["lq_fecreg"];
		$a_liq["lq_fecact"]				= $row["lq_fecact"];
		$a_liq["status_nombre"]			= $row["status_nombre"];
		$a_liq["tec_nombre"]			= $row["tec_nombre"];
		$a_liq["tec_documId"]			= $row["tec_documId"];
		$a_liq["tec_nombre_ext"]		= $row["tec_nombre_ext"];		
		return $a_liq;
	}

	public function select($LiqObj,$limit=''){
		global $usuario, $PDO;
		if ($LiqObj->lq_id){
			$where .= " AND lq_id = :lq_id";
		}
		if ($LiqObj->lq_fecha){
			$where .= " AND lq_fecha = :lq_fecha";
		}
		if ($LiqObj->tec_nombre){
			$where .= " AND tec_nombre LIKE :tec_nombre%";
		}
		if ($LiqObj->lq_status){
			$where .= " AND lq_status = :lq_status";
		}
		if ($LiqObj->orderBy){
			$orderBy = " ORDER BY ".$LiqObj->orderBy;
		}else{
			$orderBy = " ORDER BY lq_id";
		}
		$sql = "
			SELECT *, 
				MSTAT.mlst_valorDsc as status_nombre
			FROM pv_ordenServicio_gasto_liq
				LEFT JOIN pv_tecnico ON lq_tch_id = tec_id
				LEFT JOIN xx_maestrolista MSTAT ON lq_status = MSTAT.mlst_valorId AND MSTAT.mlst_listaId = 'pvLiqStatus'
			WHERE 1
				$where
				$orderBy
		";	
		$comando = $PDO->prepare($sql);
		if ($LiqObj->lq_id){
			$comando->bindParam(':lq_id', $LiqObj->lq_id);
		}
		if ($LiqObj->lq_fecha){
			$comando->bindParam(':lq_fecha', $LiqObj->lq_fecha);
		}
		if ($LiqObj->tec_nombre){
			$comando->bindParam(':tec_nombre', $LiqObj->tec_nombre);
		}
		if ($LiqObj->lq_status){
			$comando->bindParam(':lq_status', $LiqObj->lq_status);
		}
		$comando->execute();
//echo $sql;
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_liq["lq_id"]				= $row["lq_id"];
			$a_liq["lq_fecha"]			= $row["lq_fecha"];
			$a_liq["lq_tch_id"]			= $row["lq_tch_id"];
			$a_liq["lq_obs"]			= $row["lq_obs"];
			$a_liq["lq_aprob_usr"]		= $row["lq_aprob_usr"];
			$a_liq["lq_aprob_fecreg"]	= $row["lq_aprob_fecreg"];
			$a_liq["lq_status"]			= $row["lq_status"];
			$a_liq["lq_usrreg"]			= $row["lq_usrreg"];
			$a_liq["lq_usract"]			= $row["lq_usract"];
			$a_liq["lq_fecreg"]			= $row["lq_fecreg"];
			$a_liq["lq_fecact"]			= $row["lq_fecact"];
			$a_liq["lq_status_nombre"]	= $row["status_nombre"];
			$a_liq["lq_tec_nombre"]		= $row["tec_nombre"];
			$a_liqList[]				= $a_liq;
		}
		return $a_liqList;

	}


	public function update($LiqObj){
		global $usuario, $PDO;
		if ($LiqObj->lq_fecha){
			$set .= ",lq_fecha = :lq_fecha";
		}
		if ($LiqObj->lq_tch_id){
			$set .= ",lq_tch_id = :lq_tch_id";
		}
		if ($LiqObj->lq_obs){
			$set .= ",lq_obs = :lq_obs";
		}
		if ($LiqObj->lq_aprob_usr){
			$set .= ",lq_aprob_usr = :lq_aprob_usr";
		}
		if ($LiqObj->lq_aprob_fecreg){
			$set .= ",lq_aprob_fecreg = :lq_aprob_fecreg";
		}
		if ($LiqObj->lq_status){
			$set .= ",lq_status = :lq_status";
		}
		if ($set){
			$set = substr($set,1);
			$LiqObj->lq_fecact = date("Y-m-d H:i:s");
			$sql2 = "
				UPDATE pv_ordenServicio_gasto_liq
				SET 
					$set
					,lq_usract = :usract
					,lq_fecact = :fecact
				WHERE lq_id = :lq_id
				LIMIT 1";			

			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':lq_id', $LiqObj->lq_id);
			$comando->bindParam(':usract', $usuario);
			$comando->bindParam(':fecact', $LiqObj->lq_fecact);
			if ($LiqObj->lq_fecha){
				$comando->bindParam(':lq_fecha', $LiqObj->lq_fecha);
			}
			if ($LiqObj->lq_tch_id){
				$comando->bindParam(':lq_tch_id', $LiqObj->lq_tch_id);
			}
			if ($LiqObj->lq_obs){
				$comando->bindParam(':lq_obs', $LiqObj->lq_obs);
			}
			if ($LiqObj->lq_aprob_usr){
				$comando->bindParam(':lq_aprob_usr', $LiqObj->lq_aprob_usr);
			}
			if ($LiqObj->lq_aprob_fecreg){
				$comando->bindParam(':lq_aprob_fecreg', $LiqObj->lq_aprob_fecreg);
			}
			if ($LiqObj->lq_status){
				$comando->bindParam(':lq_status', $LiqObj->lq_status);
			}
			$comando->execute();
//			print_r($comando->errorInfo());
			return $LiqObj->lq_id;
		}
	}


	public function insert($LiqObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO pv_ordenServicio_gasto_liq 
			(
			lq_fecha,
			lq_tch_id,
			lq_obs,
			lq_usrreg,
			lq_fecreg
			) 
			VALUES 
			(
			:lq_fecha,
			:lq_tch_id,
			:lq_obs,
			:lq_usrreg,
			:lq_fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$LiqObj->lq_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':lq_fecha', $LiqObj->lq_fecha);
		$comando->bindParam(':lq_tch_id', $LiqObj->lq_tch_id);
		$comando->bindParam(':lq_obs', $LiqObj->lq_obs);
		$comando->bindParam(':lq_usrreg', $usuario);
		$comando->bindParam(':lq_fecreg', $LiqObj->lq_fecreg);
		$comando->execute();
		$query	 = "
			SELECT 
			DISTINCT max(lq_id) as id 
			FROM pv_ordenServicio_gasto_liq 
			WHERE lq_fecreg = '".$LiqObj->lq_fecreg."' AND lq_usrreg = '".$usuario."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];		
	}
}



class PvOrdenServicioGastoLiqLineaModel{

	public function insert($LiqLineaObj){
		global $usuario,$PDO;
		$sql = "
			INSERT INTO 
			pv_ordenServicio_gasto_liqlinea 
			(
			lql_lq_id, 
			lql_os_id,
			lql_gasto,
			lql_fecha,
			lql_detalle,
			lql_usrreg,
			lql_fecreg
			) 
			VALUES 
			(
			:lql_lq_id, 
			:lql_os_id,
			:lql_gasto,
			:lql_fecha,
			:lql_detalle,
			:lql_usrreg,
			:lql_fecreg
			);			
		";
		$comando = $PDO->prepare($sql);
		$LiqLineaObj->lql_fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':lql_lq_id', $LiqLineaObj->lql_lq_id);
		$comando->bindParam(':lql_os_id', $LiqLineaObj->lql_os_id);
		$comando->bindParam(':lql_gasto', $LiqLineaObj->lql_gasto);
		$comando->bindParam(':lql_fecha', $LiqLineaObj->lql_fecha);
		$comando->bindParam(':lql_detalle', $LiqLineaObj->lql_detalle);
		$comando->bindParam(':lql_fecreg', $LiqLineaObj->lql_fecreg);
		$comando->bindParam(':lql_usrreg', $usuario);
		$comando->execute();
//print_r($comando->errorInfo());
//exit;
		$query	 = "
			SELECT DISTINCT max(lql_id) as id 
			FROM pv_ordenServicio_gasto_liqlinea 
			WHERE lql_fecreg = '".$LiqLineaObj->lql_fecreg."' 
				AND lql_usrreg = '".$LiqLineaObj->lql_usrreg."'; " ;
		$sentencia2 = $PDO->query($query);
		$sentencia2->setFetchMode(PDO::FETCH_ASSOC);
		$row = $sentencia2->fetch();
		return $row["id"];
	}



	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_ordenServicio_gasto_liqlinea
			WHERE lql_id = :lineaId
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':lineaId', $lineaId);
		$comando->execute();
		return $lineaId;
	}


	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_ordenServicio_gasto_liqlinea
			LEFT JOIN pv_ordenServicio ON lql_os_id = os_id
			LEFT JOIN vt_clienteSuc ON os_cli_suc_id = cls_id
			WHERE lql_lq_id = :lql_lq_id
			ORDER BY lql_fecha
		";	
		$comando = $PDO->prepare($sql);
		if ($id){
			$comando->bindParam(':lql_lq_id', $id);
		}
		$comando->execute();
//		print_r($comando->errorInfo());
//		exit;
		while($row = $comando->fetch()){
			$a_linea["lql_lq_id"]	= $row["lql_lq_id"];
			$a_linea["lql_id"]		= $row["lql_id"];
			$a_linea["lql_os_id"]	= $row["lql_os_id"];
			$a_linea["lql_gasto"]	= $row["lql_gasto"];
			$a_linea["lql_fecha"]	= $row["lql_fecha"];
			$a_linea["lql_detalle"]	= $row["lql_detalle"];
			$a_linea["lql_usrreg"]	= $row["lql_usrreg"];
			$a_linea["lql_usract"]	= $row["lql_usract"];			
			$a_linea["lql_fecreg"]	= $row["lql_fecreg"];
			$a_linea["lql_fecact"]	= $row["lql_fecact"];	
			$a_linea["os_fecha"]	= $row["os_fecha"];	
			$a_linea["cls_estado"]	= $row["cls_estado"];	
			$a_linea["cls_ciudad"]	= $row["cls_ciudad"];	
			$a_linea["cls_direccion2"]	= $row["cls_direccion2"];
			$a_linea["os_cli_nombre"]	= $row["os_cli_nombre"];	
			$a_linea["cls_nombre"]	= $row["cls_nombre"];			
			$a_liqlinea[]			= $a_linea;
		}
		return $a_liqlinea;
	}


	public function select($LiqObj){
		global $usuario, $PDO;
		if ($LiqObj->lql_id){
			$where .= " AND lql_id = :lql_id";
		}
		$sql = "
			SELECT *
			FROM pv_ordenServicio_gasto_liqlinea
			LEFT JOIN pv_ordenServicio ON lql_os_id = os_id
			LEFT JOIN vt_clienteSuc ON os_cli_suc_id = cls_id
			WHERE 1
			$where
		";	
		$comando = $PDO->prepare($sql);
		if ($LiqObj->lql_id){
			$comando->bindParam(':lql_id', $LiqObj->lql_id);
		}
		$comando->execute();
//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_linea["lql_lq_id"]	= $row["lql_lq_id"];
			$a_linea["lql_id"]		= $row["lql_id"];
			$a_linea["lql_os_id"]	= $row["lql_os_id"];
			$a_linea["lql_gasto"]	= $row["lql_gasto"];
			$a_linea["lql_fecha"]	= $row["lql_fecha"];
			$a_linea["lql_detalle"]	= $row["lql_detalle"];
			$a_linea["lql_usrreg"]	= $row["lql_usrreg"];
			$a_linea["lql_usract"]	= $row["lql_usract"];			
			$a_linea["lql_fecreg"]	= $row["lql_fecreg"];
			$a_linea["lql_fecact"]	= $row["lql_fecact"];	
			$a_linea["os_fecha"]	= $row["os_fecha"];	
			$a_linea["cls_estado"]	= $row["cls_estado"];	
			$a_linea["cls_ciudad"]	= $row["cls_ciudad"];	
			$a_linea["cls_direccion2"]	= $row["cls_direccion2"];
			$a_linea["os_cli_nombre"]	= $row["os_cli_nombre"];	
			$a_linea["cls_nombre"]	= $row["cls_nombre"];	
			$a_liqList[]				= $a_linea;
		}
		return $a_liqList;

	}


}


?>