<?php


class PvTecnicoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_tecnico
			WHERE tec_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_tecnico["tec_id"]			= $row["tec_id"];
		$a_tecnico["tec_nombre"]		= $row["tec_nombre"];
		$a_tecnico["tec_nombre_ext"]	= $row["tec_nombre_ext"];
		$a_tecnico["tec_documId"]		= $row["tec_documId"];
		$a_tecnico["tec_email"]			= $row["tec_email"];
		$a_tecnico["tec_tipo"]			= $row["tec_tipo"];
		$a_tecnico["tec_nivel"]			= $row["tec_nivel"];
		$a_tecnico["tec_status"]		= $row["tec_status"];
		$a_tecnico["tec_usract"]		= $row["tec_usract"];
		$a_tecnico["tec_fecact"]		= $row["tec_fecact"];
		return $a_tecnico;
	}


	public function select($TecnicoObj,$limit=''){
		global $usuario, $PDO;
		if ($TecnicoObj->tec_id){
			$where .= " AND tec_id = :tec_id";
		}
		if ($TecnicoObj->tec_nombre){
			$where .= " AND tec_nombre LIKE '".$TecnicoObj->tec_nombre."'";
		}
		if ($TecnicoObj->tec_status){
			$where .= " AND tec_status = :tec_status";
		}else{
			$where .= " AND tec_status <> 'I' ";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($TecnicoObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY tec_nombre";
		}
		$sql = "
			SELECT *, 
				STATUS.mlst_valorDsc AS tec_status_nombre, 
				NIVEL.mlst_valorDsc AS tec_nivel_nombre 
			FROM pv_tecnico 
				LEFT JOIN xx_maestrolista STATUS ON tec_status = STATUS.mlst_valorId AND STATUS.mlst_listaId = 'pvTecStatus'
				LEFT JOIN xx_maestrolista NIVEL ON tec_nivel = NIVEL.mlst_valorId AND NIVEL.mlst_listaId = 'pvTecNivel'
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($TecnicoObj->tec_id){
			$comando->bindParam(':tec_id', $TecnicoObj->tec_id);
		}
		if ($TecnicoObj->tec_nombre){
			$comando->bindParam(':tec_nombre', $TecnicoObj->tec_nombre);
		}
		if ($TecnicoObj->tec_status){
			$comando->bindParam(':tec_status', $TecnicoObj->tec_status);
		}
		if ($TecnicoObj->orderBy){
			$comando->bindParam(':orderBy', $TecnicoObj->orderBy);
		}			
		$comando->execute();
		//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_tecnico["tec_id"]			= $row["tec_id"];
			$a_tecnico["tec_nombre"]		= $row["tec_nombre"];

			$a_tecnico["tec_nombre_ext"]	= $row["tec_nombre_ext"];
			$a_tecnico["tec_documId"]		= $row["tec_documId"];
			$a_tecnico["tec_email"]			= $row["tec_email"];
			$a_tecnico["tec_tipo"]			= $row["tec_tipo"];
			$a_tecnico["tec_nivel"]			= $row["tec_nivel"];

			$a_tecnico["tec_status"]		= $row["tec_status"];
			$a_tecnico["tec_status_nombre"]	= $row["tec_status_nombre"];
			$a_tecnico["tec_nivel_nombre"]	= $row["tec_nivel_nombre"];
			$a_tecnico["tec_usract"]		= $row["tec_usract"];
			$a_tecnico["tec_fecact"]		= $row["tec_fecact"];
			$a_tecnicoList[] = $a_tecnico;
		}
		if (!$a_tecnico){
			echo $sql."<br>";
		}
		return $a_tecnicoList;

	}


	public function update($TecnicoObj){
		global $usuario, $PDO;
		if (isset($TecnicoObj->tec_nombre)){
			$set .= ", tec_nombre = :tec_nombre";
		}
		if (isset($TecnicoObj->tec_status)){
			$set .= ", tec_status = :tec_status";
		}

		if (isset($TecnicoObj->tec_nombre_ext)){
			$set .= ", tec_nombre_ext = :tec_nombre_ext";
		}
		if (isset($TecnicoObj->tec_documId)){
			$set .= ", tec_documId = :tec_documId";
		}
		if (isset($TecnicoObj->tec_email)){
			$set .= ", tec_email = :tec_email";
		}
		if (isset($TecnicoObj->tec_tipo)){
			$set .= ", tec_tipo = :tec_tipo";
		}
		if (isset($TecnicoObj->tec_nivel)){
			$set .= ", tec_nivel = :tec_nivel";
		}

		if ($set && $TecnicoObj->tec_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE pv_tecnico
				SET 
					$set
					,tec_usract = :tec_usract
				WHERE tec_id = :tec_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':tec_id', $TecnicoObj->tec_id);
			if (isset($TecnicoObj->tec_nombre)){
				$comando->bindParam(':tec_nombre', $TecnicoObj->tec_nombre);
			}
			if (isset($TecnicoObj->tec_status)){
				$comando->bindParam(':tec_status', $TecnicoObj->tec_status);
			}

			if (isset($TecnicoObj->tec_nombre_ext)){
				$comando->bindParam(':tec_nombre_ext', $TecnicoObj->tec_nombre_ext);
			}
			if (isset($TecnicoObj->tec_documId)){
				$comando->bindParam(':tec_documId', $TecnicoObj->tec_documId);
			}
			if (isset($TecnicoObj->tec_email)){
				$comando->bindParam(':tec_email', $TecnicoObj->tec_email);
			}
			if (isset($TecnicoObj->tec_tipo)){
				$comando->bindParam(':tec_tipo', $TecnicoObj->tec_tipo);
			}
			if (isset($TecnicoObj->tec_nivel)){
				$comando->bindParam(':tec_nivel', $TecnicoObj->tec_nivel);
			}
			
			$comando->bindParam(':tec_usract', $usuario);
			$comando->execute();
		//	print_r($comando->errorInfo());
			
			return $TecnicoObj->tec_id;
		}
	}

	public function insert($TecnicoObj){
		global $PDO, $usuario;
		$sql = "
			INSERT INTO pv_tecnico 
			(
			tec_nombre, 
			tec_nombre_ext,
			tec_documId,
			tec_email,
			tec_tipo,
			tec_nivel,
			tec_status,
			tec_usract, 
			tec_fecact
			) 
			VALUES 
			(
			:tec_nombre, 
			:tec_nombre_ext,
			:tec_documId,
			:tec_email,
			:tec_tipo,
			:tec_nivel,
			:tec_status,
			:tec_usract, 
			:tec_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':tec_nombre', $TecnicoObj->tec_nombre);
		$comando->bindParam(':tec_nombre_ext', $TecnicoObj->tec_nombre_ext);
		$comando->bindParam(':tec_documId', $TecnicoObj->tec_documId);
		$comando->bindParam(':tec_email', $TecnicoObj->tec_email);
		$comando->bindParam(':tec_tipo', $TecnicoObj->tec_tipo);
		$comando->bindParam(':tec_nivel', $TecnicoObj->tec_nivel);
		$comando->bindParam(':tec_status', $TecnicoObj->tec_status);
		$comando->bindParam(':tec_usract', $usuario);
		$comando->bindParam(':tec_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(tec_id) as id 
			FROM pv_tecnico 
			WHERE tec_usract = :tec_usract 
				AND tec_fecact = :tec_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':tec_usract', $usuario);
		$comando->bindParam(':tec_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


class PvTecnicoZonaModel{
	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_tecnico_zona
			WHERE tcub_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_tecnico["tcub_id"]			= $row["tcub_id"];
		$a_tecnico["tcub_tec_id"]		= $row["tcub_tec_id"];
		$a_tecnico["tcub_direccion2"]	= $row["tcub_direccion2"];
		$a_tecnico["tcub_ciudad"]		= $row["tcub_ciudad"];
		$a_tecnico["tcub_estado"]		= $row["tcub_estado"];
		$a_tecnico["tcub_ubigeo"]		= $row["tcub_ubigeo"];
		$a_tecnico["tcub_usract"]		= $row["tcub_usract"];
		$a_tecnico["tcub_fecact"]		= $row["tcub_fecact"];
		return $a_tecnico;
	}	

	public function select($TecnicoObj,$limit=''){
		global $usuario, $PDO;
		if ($TecnicoObj->tcub_id){
			$where .= " AND tcub_id = :tcub_id";
		}
		if ($TecnicoObj->tcub_tec_id){
			$where .= " AND tcub_tec_id = :tcub_tec_id";
		}
		if ($TecnicoObj->tcub_estado){
			$where .= " AND tcub_estado = :tcub_estado";
		}
		if ($TecnicoObj->tcub_ubigeo){
			$where .= " AND tcub_ubigeo = :tcub_ubigeo";
		}
		if ($TecnicoObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY tcub_id";
		}
		$sql = "
			SELECT *
			FROM pv_tecnico_zona 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($TecnicoObj->tcub_id){
			$comando->bindParam(':tcub_id', $TecnicoObj->tcub_id);
		}
		if ($TecnicoObj->tcub_tec_id){
			$comando->bindParam(':tcub_tec_id', $TecnicoObj->tcub_tec_id);
		}
		if ($TecnicoObj->tcub_estado){
			$comando->bindParam(':tcub_estado', $TecnicoObj->tcub_estado);
		}
		if ($TecnicoObj->tcub_ubigeo){
			$comando->bindParam(':tcub_ubigeo', $TecnicoObj->tcub_ubigeo);
		}
		if ($TecnicoObj->orderBy){
			$comando->bindParam(':orderBy', $TecnicoObj->orderBy);
		}			
		$comando->execute();
		//print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_tecnico["tcub_id"]			= $row["tcub_id"];
			$a_tecnico["tcub_tec_id"]		= $row["tcub_tec_id"];
			$a_tecnico["tcub_direccion2"]	= $row["tcub_direccion2"];
			$a_tecnico["tcub_ciudad"]		= $row["tcub_ciudad"];
			$a_tecnico["tcub_estado"]		= $row["tcub_estado"];
			$a_tecnico["tcub_ubigeo"]		= $row["tcub_ubigeo"];
			$a_tecnico["tcub_usract"]		= $row["tcub_usract"];
			$a_tecnico["tcub_fecact"]		= $row["tcub_fecact"];
			$a_tecnicoList[] = $a_tecnico;
		}
		if (!$a_tecnico){
			echo $sql."<br>";
		}
		return $a_tecnicoList;
	}

	public function insert($TecnicoObj){
		global $PDO, $usuario;
		$sql = "
			INSERT INTO pv_tecnico_zona
			(
			tcub_tec_id, 
			tcub_direccion2,
			tcub_ciudad,
			tcub_estado,
			tcub_ubigeo,
			tcub_usract,
			tcub_fecact
			) 
			VALUES 
			(
			:tcub_tec_id, 
			:tcub_direccion2,
			:tcub_ciudad,
			:tcub_estado,
			:tcub_ubigeo,
			:tcub_usract,
			:tcub_fecact
			);			
		";
		if (!$TecnicoObj->tcub_ciudad){
			$TecnicoObj->tcub_ciudad = '*';
		}
		if (!$TecnicoObj->tcub_direccion2){
			$TecnicoObj->tcub_direccion2 = '*';
		}
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':tcub_tec_id', $TecnicoObj->tcub_tec_id);
		$comando->bindParam(':tcub_direccion2', $TecnicoObj->tcub_direccion2);
		$comando->bindParam(':tcub_ciudad', $TecnicoObj->tcub_ciudad);
		$comando->bindParam(':tcub_estado', $TecnicoObj->tcub_estado);
		$comando->bindParam(':tcub_ubigeo', $TecnicoObj->tcub_ubigeo);
		$comando->bindParam(':tcub_usract', $usuario);
		$comando->bindParam(':tcub_fecact', $fecreg);
		$comando->execute();	 
//		print_r($comando->errorInfo());
//		exit("****");
		$query	 = "
			SELECT DISTINCT max(tcub_id) as id 
			FROM pv_tecnico_zona 
			WHERE tcub_usract = :tcub_usract 
				AND tcub_fecact = :tcub_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':tcub_usract', $usuario);
		$comando->bindParam(':tcub_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_tecnico_zona
			WHERE tcub_id = :tcub_id
			LIMIT 1
		";		
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':tcub_id', $lineaId);
		$comando->execute();
		return $lineaId;
	}

}


class PvTecnicoEquipoModel{
	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM pv_tecnico_producto
				LEFT JOIN im_producto ON tcpr_pr_id = pr_id AND tcpr_prTipo = 'EQP'
				LEFT JOIN im_subFamilia ON tcpr_pr_id = sfm_subFamiliaId AND tcpr_prTipo = 'CATEG'
			WHERE tcpr_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_tecnico["tcpr_id"]		= $row["tcpr_id"];
		$a_tecnico["tcpr_tec_id"]	= $row["tcpr_tec_id"];
		$a_tecnico["tcpr_prTipo"]	= $row["tcpr_prTipo"];
		$a_tecnico["tcpr_pr_id"]	= $row["tcpr_pr_id"];
		$a_tecnico["tcpr_nivel"]	= $row["tcpr_nivel"];
		$a_tecnico["tcpr_usract"]	= $row["tcpr_usract"];
		$a_tecnico["tcpr_fecact"]	= $row["tcpr_fecact"];
		return $a_tecnico;
	}	

	public function select($TecnicoObj,$limit=''){
		global $usuario, $PDO;
		if ($TecnicoObj->tcpr_id){
			$where .= " AND tcpr_id = :tcpr_id";
		}
		if ($TecnicoObj->tcpr_tec_id){
			$where .= " AND tcpr_tec_id = :tcpr_tec_id";
		}
		if ($TecnicoObj->tcpr_prTipo){
			$where .= " AND tcpr_prTipo = :tcpr_prTipo";
		}
		if ($TecnicoObj->tcpr_pr_id){
			$where .= " AND tcpr_pr_id = :tcpr_pr_id";
		}
		if ($TecnicoObj->tcpr_nivel){
			$where .= " AND tcpr_nivel = :tcpr_nivel";
		}
		if ($TecnicoObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY tcpr_prTipo";
		}
		$sql = "
			SELECT *
			FROM pv_tecnico_producto 
				LEFT JOIN im_producto ON tcpr_pr_id = pr_id
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($TecnicoObj->tcpr_id){
			$comando->bindParam(':tcpr_id', $TecnicoObj->tcpr_id);
		}
		if ($TecnicoObj->tcpr_tec_id){
			$comando->bindParam(':tcpr_tec_id', $TecnicoObj->tcpr_tec_id);
		}
		if ($TecnicoObj->tcpr_prTipo){
			$comando->bindParam(':tcpr_prTipo', $TecnicoObj->tcpr_prTipo);
		}
		if ($TecnicoObj->tcpr_pr_id){
			$comando->bindParam(':tcpr_pr_id', $TecnicoObj->tcpr_pr_id);
		}
		if ($TecnicoObj->tcpr_nivel){
			$comando->bindParam(':tcpr_nivel', $TecnicoObj->tcpr_nivel);
		}
		if ($TecnicoObj->orderBy){
			$comando->bindParam(':orderBy', $TecnicoObj->orderBy);
		}			
		$comando->execute();
//		print_r($comando->errorInfo());
		while($row = $comando->fetch()){
			$a_tecnico["tcpr_id"]		= $row["tcpr_id"];
			$a_tecnico["tcpr_tec_id"]	= $row["tcpr_tec_id"];
			$a_tecnico["tcpr_prTipo"]	= $row["tcpr_prTipo"];
			$a_tecnico["tcpr_pr_id"]		= $row["tcpr_pr_id"];
			$a_tecnico["tcpr_nivel"]	= $row["tcpr_nivel"];
			$a_tecnico["tcpr_usract"]	= $row["tcpr_usract"];
			$a_tecnico["tcpr_fecact"]	= $row["tcpr_fecact"];
			$a_tecnico["pr_productoId"]	= $row["pr_productoId"];
			$a_tecnico["pr_descripcion"]	= $row["pr_descripcion"];
			$a_tecnicoList[] = $a_tecnico;
		}
/*
		if (!$a_tecnico){
			echo $sql."<br>";
		}
*/
		return $a_tecnicoList;
	}

	public function insert($TecnicoObj){
		global $PDO, $usuario;
		$sql = "
			INSERT INTO pv_tecnico_producto
			(
			tcpr_tec_id, 
			tcpr_prTipo,
			tcpr_pr_id,
			tcpr_nivel,
			tcpr_usract,
			tcpr_fecact
			) 
			VALUES 
			(
			:tcpr_tec_id, 
			:tcpr_prTipo,
			:tcpr_pr_id,
			:tcpr_nivel,
			:tcpr_usract,
			:tcpr_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':tcpr_tec_id', $TecnicoObj->tcpr_tec_id);
		$comando->bindParam(':tcpr_prTipo', $TecnicoObj->tcpr_prTipo);
		$comando->bindParam(':tcpr_pr_id', $TecnicoObj->tcpr_pr_id);
		$comando->bindParam(':tcpr_nivel', $TecnicoObj->tcpr_nivel);
		$comando->bindParam(':tcpr_usract', $usuario);
		$comando->bindParam(':tcpr_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(tcpr_id) as id 
			FROM pv_tecnico_producto 
			WHERE tcpr_usract = :tcpr_usract 
				AND tcpr_fecact = :tcpr_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':tcpr_usract', $usuario);
		$comando->bindParam(':tcpr_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

	public function delete($lineaId){
		global $PDO;
		$sql = "
			DELETE
			FROM pv_tecnico_producto
			WHERE tcpr_id = :tcpr_id
			LIMIT 1
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':tcpr_id', $lineaId);
		$comando->execute();
		return $lineaId;
	}

}

?>