<?php


class SoListaPreciosModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM vts_listaprecio
			WHERE lpr_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_listaPrecios["lpr_id"] = $row["lpr_id"];
		$a_listaPrecios["lpr_pr_id"]		= $row["lpr_pr_id"];
		$a_listaPrecios["lpr_tipoPrecio"]	= $row["lpr_tipoPrecio"];
		$a_listaPrecios["lpr_valorTipo"]	= $row["lpr_valorTipo"];
		$a_listaPrecios["lpr_usract"]		= $row["lpr_usract"];
		$a_listaPrecios["lpr_fecact"]		= $row["lpr_fecact"];
		return $a_listaPrecios;
	}


	public function select($ListaPreciosObj,$limit=''){
		global $usuario, $PDO;
		if ($ListaPreciosObj->lpr_id){
			$where .= "AND lpr_id = :lpr_id";
		}
		if ($ListaPreciosObj->lpr_pr_id){
			$where .= "AND lpr_pr_id LIKE :lpr_pr_id";
		}
		if ($ListaPreciosObj->lpr_tipoPrecio){
			$where .= "AND lpr_tipoPrecio = :lpr_tipoPrecio";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($ListaPreciosObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY lpr_tipoPrecio";
		}
		$sql = "
			SELECT *
			FROM vts_listaprecio 
			WHERE 1 $where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($ListaPreciosObj->lpr_id){
			$comando->bindParam(':lpr_id', $ListaPreciosObj->lpr_id);
		}
		if ($ListaPreciosObj->lpr_pr_id){
			$comando->bindParam(':lpr_pr_id', $ListaPreciosObj->lpr_pr_id);
		}
		if ($ListaPreciosObj->lpr_tipoPrecio){
			$comando->bindParam(':lpr_tipoPrecio', $ListaPreciosObj->lpr_tipoPrecio);
		}
		if ($ListaPreciosObj->orderBy){
			$comando->bindParam(':orderBy', $ListaPreciosObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_listaPrecios["lpr_id"]			= $row["lpr_id"];
			$a_listaPrecios["lpr_pr_id"]		= $row["lpr_pr_id"];
			$a_listaPrecios["lpr_tipoPrecio"]	= $row["lpr_tipoPrecio"];
			$a_listaPrecios["lpr_valorTipo"]	= $row["lpr_valorTipo"];
			$a_listaPrecios["lpr_usract"]		= $row["lpr_usract"];
			$a_listaPrecios["lpr_fecact"]		= $row["lpr_fecact"];
			$a_listaPreciosList["listaPag"][]	= $a_listaPrecios;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_listaPreciosList["total"] = $rowTotal["total"];
		return $a_listaPreciosList;

	}


	public function update($ListaPreciosObj){
		global $usuario, $PDO;
		if ($ListaPreciosObj->fm_nombre){
			$set .= ", fm_nombre = :fm_nombre";
		}
		if ($ListaPreciosObj->fm_status){
			$set .= ", fm_status = :fm_status";
		}
		if ($set && $ListaPreciosObj->lpr_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE vts_listaprecio
				SET 
					$set
					,fm_usract = :fm_usract
				WHERE lpr_id = :lpr_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':lpr_id', $ListaPreciosObj->lpr_id);
			if ($ListaPreciosObj->fm_nombre){
				$comando->bindParam(':fm_nombre', $ListaPreciosObj->fm_nombre);
			}
			if ($ListaPreciosObj->fm_status){
				$comando->bindParam(':fm_status', $ListaPreciosObj->fm_status);
			}
			$comando->bindParam(':fm_usract', $usuario);
			$comando->execute();
			return $ListaPreciosObj->lpr_id;
		}
	}


	public function insert($ListaPreciosObj){
		global $PDO;
		$sql = "
			REPLACE INTO vts_listaprecio 
			(
			lpr_pr_id, 
			lpr_moneda, 
			lpr_tipoPrecio, 
			lpr_valorTipo,
			lpr_usract,
			lpr_fecact
			) 
			VALUES 
			(
			:lpr_pr_id, 
			:lpr_moneda, 
			:lpr_tipoPrecio,
			:lpr_valorTipo,
			:lpr_usract,
			:lpr_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':lpr_pr_id', $ListaPreciosObj->lpr_pr_id);
		$comando->bindParam(':lpr_moneda', $ListaPreciosObj->lpr_moneda);
		$comando->bindParam(':lpr_tipoPrecio', $ListaPreciosObj->lpr_tipoPrecio);
		$comando->bindParam(':lpr_valorTipo', $ListaPreciosObj->lpr_valorTipo);
		$comando->bindParam(':lpr_usract', $ListaPreciosObj->lpr_usract);
		$comando->bindParam(':lpr_fecact', $fecreg);
		$comando->execute();	 
		//print_r($comando->errorInfo());
		$query	 = "
			SELECT DISTINCT max(lpr_id) as id 
			FROM `vts_listaprecio` 
			WHERE lpr_usract = :lpr_usract 
				AND lpr_fecact = :lpr_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':lpr_usract', $ListaPreciosObj->lpr_usract);
		$comando->bindParam(':lpr_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>