<?php


class XxChoferModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM xx_guiaChofer
			WHERE gech_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_chofer["gech_id"]		= $row["gech_id"];
		$a_chofer["gech_docIdTipo"]	= $row["gech_docIdTipo"];
		$a_chofer["gech_docIdNro"]	= $row["gech_docIdNro"];
		$a_chofer["gech_nombre"]	= $row["gech_nombre"];
		$a_chofer["gech_apellido"]	= $row["gech_apellido"];
		$a_chofer["gech_licencia"]	= $row["gech_licencia"];
		$a_chofer["gech_status"]	= $row["gech_status"];
		$a_chofer["gech_usract"]	= $row["gech_usract"];
		$a_chofer["gech_fecact"]	= $row["gech_fecact"];
		return $a_chofer;
	}


	public function select($ChoferObj,$limit=''){
		global $usuario, $PDO;
		if (($ChoferObj->gech_id)){
			$where .= " AND gech_id = :gech_id";
		}
		if (($ChoferObj->gech_apellido)){
			$where .= " AND gech_apellido LIKE :gech_apellido";
		}
		if (($ChoferObj->gech_nombre)){
			$where .= " AND gech_nombre LIKE :gech_nombre";
		}
		if (($ChoferObj->gech_status)){
			$where .= " AND gech_status = :gech_status";
		}
		if ($ChoferObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY gech_apellido, gech_nombre";
		}
		$sql = "
			SELECT *
			FROM xx_guiaChofer 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if (($ChoferObj->gech_id)){
			$comando->bindParam(':gech_id', $ChoferObj->gech_id);
		}
		if (($ChoferObj->gech_apellido)){
			$comando->bindParam(':gech_apellido', $ChoferObj->gech_apellido);
		}
		if (($ChoferObj->gech_nombre)){
			$comando->bindParam(':gech_nombre', $ChoferObj->gech_nombre);
		}
		if (($ChoferObj->gech_status)){
			$comando->bindParam(':gech_status', $ChoferObj->gech_status);
		}
		if ($ChoferObj->orderBy){
			$comando->bindParam(':orderBy', $ChoferObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_chofer["gech_id"]		= $row["gech_id"];
			$a_chofer["gech_docIdTipo"]	= $row["gech_docIdTipo"];
			$a_chofer["gech_docIdNro"]	= $row["gech_docIdNro"];
			$a_chofer["gech_nombre"]	= $row["gech_nombre"];
			$a_chofer["gech_apellido"]	= $row["gech_apellido"];
			$a_chofer["gech_licencia"]	= $row["gech_licencia"];
			$a_chofer["gech_status"]	= $row["gech_status"];
			$a_chofer["gech_usract"]	= $row["gech_usract"];
			$a_chofer["gech_fecact"]	= $row["gech_fecact"];
			$a_choferList[] = $a_chofer;
		}
		return $a_choferList;
	}


	public function update($ChoferObj){
		global $usuario, $PDO;
		if ($ChoferObj->gech_docIdTipo){
			$set .= ", gech_docIdTipo = :gech_docIdTipo";
		}
		if ($ChoferObj->gech_docIdNro){
			$set .= ", gech_docIdNro = :gech_docIdNro";
		}
		if ($ChoferObj->gech_nombre){
			$set .= ", gech_nombre = :gech_nombre";
		}
		if ($ChoferObj->gech_apellido){
			$set .= ", gech_apellido = :gech_apellido";
		}
		if ($ChoferObj->gech_licencia){
			$set .= ", gech_licencia = :gech_licencia";
		}
		if ($ChoferObj->gech_status){
			$set .= ", gech_status = :gech_status";
		}
		if ($set && $ChoferObj->gech_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE xx_guiaChofer
				SET 
					$set
					,gech_usract = :gech_usract
				WHERE gech_id = :gech_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':gech_id', $ChoferObj->gech_id);
			if ($ChoferObj->gech_docIdTipo){
				$comando->bindParam(':gech_docIdTipo', $ChoferObj->gech_docIdTipo);
			}
			if ($ChoferObj->gech_docIdNro){
				$comando->bindParam(':gech_docIdNro', $ChoferObj->gech_docIdNro);
			}
			if ($ChoferObj->gech_nombre){
				$comando->bindParam(':gech_nombre', $ChoferObj->gech_nombre);
			}
			if ($ChoferObj->gech_apellido){
				$comando->bindParam(':gech_apellido', $ChoferObj->gech_apellido);
			}
			if ($ChoferObj->gech_licencia){
				$comando->bindParam(':gech_licencia', $ChoferObj->gech_licencia);
			}
			if ($ChoferObj->gech_status){
				$comando->bindParam(':gech_status', $ChoferObj->gech_status);
			}
			$comando->bindParam(':gech_usract', $usuario);
			$comando->execute();
			//print_r($comando->errorInfo());
			return $ChoferObj->gech_id;
		}
	}

	public function insert($ChoferObj){
		global $PDO;
		$sql = "
			INSERT INTO xx_guiaChofer 
			(
			gech_docIdTipo,
			gech_docIdNro,
			gech_apellido, 
			gech_nombre, 
			gech_licencia, 
			gech_usract, 
			gech_fecact
			) 
			VALUES 
			(
			:gech_docIdTipo,
			:gech_docIdNro,
			:gech_apellido, 
			:gech_nombre, 
			:gech_licencia,
			:gech_usract, 
			:gech_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':gech_docIdTipo', $ChoferObj->gech_docIdTipo);
		$comando->bindParam(':gech_docIdNro', $ChoferObj->gech_docIdNro);
		$comando->bindParam(':gech_apellido', $ChoferObj->gech_apellido);
		$comando->bindParam(':gech_nombre', $ChoferObj->gech_nombre);
		$comando->bindParam(':gech_licencia', $ChoferObj->gech_licencia);
		$comando->bindParam(':gech_usract', $ChoferObj->gech_usract);
		$comando->bindParam(':gech_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(gech_id) as id 
			FROM `xx_guiaChofer` 
			WHERE gech_usract = :gech_usract 
				AND gech_fecact = :gech_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':gech_usract', $ChoferObj->gech_usract);
		$comando->bindParam(':gech_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>