<?php


class XXMaestroListaModel{

	public function selectUniqueId($listaId,$id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
				xx_maestrolista
			WHERE mlst_listaId = :listaId
				AND mlst_valorId = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->bindParam(':listaId', $listaId);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_xxMaestroLista["mlst_listaId"]	= $row["mlst_listaId"];
		$a_xxMaestroLista["mlst_valorId"]	= $row["mlst_valorId"];
		$a_xxMaestroLista["mlst_valorDsc"]	= $row["mlst_valorDsc"];
		$a_xxMaestroLista["mlst_orden"]		= $row["mlst_orden"];
		$a_xxMaestroLista["mlst_estado"]	= $row["mlst_estado"];
		$a_xxMaestroLista["mlst_usract"]	= $row["mlst_usract"];
		$a_xxMaestroLista["mlst_fecact"]	= $row["mlst_fecact"];
		return $a_xxMaestroLista;
	}


	public function select($XXMaestroListaObj,$limit=''){
		global $usuario, $PDO;
		if ($XXMaestroListaObj->mlst_listaId){
			$where .= " AND mlst_listaId = :mlst_listaId";
		}else{
			return FALSE;
		}
		if ($XXMaestroListaObj->mlst_valorId){
			$where .= " AND mlst_valorId = :mlst_valorId";
		}
		if ($XXMaestroListaObj->mlst_valorDsc){
			$where .= " AND mlst_valorDsc = :mlst_valorDsc";
		}
		if ($XXMaestroListaObj->mlst_estado){
			$where .= " AND mlst_estado = :mlst_estado";
		}
		if ($limit){
			$field = " SQL_CALC_FOUND_ROWS * ";
		}else{
			$field = " * ";	
		}
		if ($XXMaestroListaObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY mlst_orden, mlst_valorDsc";
		}
		$sql = "
			SELECT *
			FROM xx_maestrolista 
			WHERE 1 $where
			 AND mlst_status <> 'I'
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($XXMaestroListaObj->mlst_listaId){
			$comando->bindParam(':mlst_listaId', $XXMaestroListaObj->mlst_listaId);
		}
		if ($XXMaestroListaObj->mlst_valorId){
			$comando->bindParam(':mlst_valorId', $XXMaestroListaObj->mlst_valorId);
		}
		if ($XXMaestroListaObj->mlst_valorDsc){
			$comando->bindParam(':mlst_valorDsc', $XXMaestroListaObj->mlst_valorDsc);
		}
		if ($XXMaestroListaObj->mlst_estado){
			$comando->bindParam(':mlst_estado', $XXMaestroListaObj->mlst_estado);
		}
		if ($XXMaestroListaObj->orderBy){
			$comando->bindParam(':orderBy', $XXMaestroListaObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_pais["mlst_listaId"]		= $row["mlst_listaId"];
			$a_pais["mlst_valorId"]		= $row["mlst_valorId"];
			$a_pais["mlst_valorDsc"]	= $row["mlst_valorDsc"];
			$a_pais["mlst_orden"]		= $row["mlst_orden"];
			$a_pais["mlst_estado"]		= $row["mlst_estado"];
			$a_pais["mlst_field1"]		= $row["mlst_field1"];
			$a_pais["mlst_usract"]		= $row["mlst_usract"];
			$a_pais["mlst_fecact"]		= $row["mlst_fecact"];
			$a_maestroListaList["listaPag"][] = $a_pais;
		}
		$sqlTotal = "
			SELECT FOUND_ROWS() as total
		";
		$sentencia = $PDO->query($sqlTotal);
		$sentencia->setFetchMode(PDO::FETCH_ASSOC);
		$rowTotal = $sentencia->fetch();
		$a_maestroListaList["total"] = $rowTotal["total"];
		return $a_maestroListaList;

	}


	public function update($XXMaestroListaObj){
		global $usuario, $PDO;
		if ($XXMaestroListaObj->mlst_valorDsc){
			$set .= ", mlst_valorDsc = :mlst_valorDsc";
		}
		if ($XXMaestroListaObj->mlst_orden){
			$set .= ", mlst_orden = :mlst_orden";
		}
		if ($XXMaestroListaObj->mlst_estado){
			$set .= ", mlst_estado = :mlst_estado";
		}
		if ($set && $XXMaestroListaObj->mlst_listaId && $XXMaestroListaObj->mlst_valorId){
			$set = substr($set,1);
			$sql2 = "
				UPDATE xx_maestrolista
				SET 
					$set
					,mlst_usract = :mlst_usract
				WHERE mlst_listaId = :mlst_listaId
					AND mlst_valorId = :mlst_valorId
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':mlst_listaId', $XXMaestroListaObj->mlst_listaId);
			$comando->bindParam(':mlst_valorId', $XXMaestroListaObj->mlst_valorId);
			$comando->bindParam(':mr_usract', $usuario);
			if ($XXMaestroListaObj->mlst_valorDsc){
				$comando->bindParam(':mlst_valorDsc', $XXMaestroListaObj->mlst_valorDsc);
			}
			if ($XXMaestroListaObj->mlst_orden){
				$comando->bindParam(':mlst_orden', $XXMaestroListaObj->mlst_orden);
			}
			if ($XXMaestroListaObj->mlst_estado){
				$comando->bindParam(':mlst_estado', $XXMaestroListaObj->mlst_estado);
			}
			$comando->execute();
			return $XXMaestroListaObj->mlst_valorId;
		}
	}


	public function insert($XXMaestroListaObj){
		global $PDO;
		$sql = "
			INSERT INTO xx_maestrolista 
			(
			mlst_listaId, 
			mlst_valorId,
			mlst_valorDsc,
			mlst_orden,
			mlst_estado,
			mlst_usract, 
			mlst_fecact
			) 
			VALUES 
			(
			:mlst_listaId,
			:mlst_valorId,
			:mlst_valorDsc,
			:mlst_orden,
			:mlst_estado,
			:mlst_usract,
			:mlst_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':mlst_listaId', $XXMaestroListaObj->mlst_listaId);
		$comando->bindParam(':mlst_valorId', $XXMaestroListaObj->mlst_valorId);
		$comando->bindParam(':mlst_valorDsc', $XXMaestroListaObj->mlst_valorDsc);
		$comando->bindParam(':mlst_orden', $XXMaestroListaObj->mlst_orden);
		$comando->bindParam(':mlst_estado', $XXMaestroListaObj->mlst_estado);
		$comando->bindParam(':mlst_usract', $XXMaestroListaObj->mlst_usract);
		$comando->bindParam(':mlst_fecact', $fecreg);
		$comando->execute();	 
		return $XXMaestroListaObj->mlst_valorId;
	}

}


?>