<?php


class XxTransportistaModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM xx_guiaTransportista
			WHERE getr_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_chofer["getr_id"]		= $row["getr_id"];
		$a_chofer["getr_docTipo"]	= $row["getr_docTipo"];
		$a_chofer["getr_ruc"]		= $row["getr_ruc"];
		$a_chofer["getr_nombre"]	= $row["getr_nombre"];
		$a_chofer["getr_status"]	= $row["getr_status"];
		$a_chofer["getr_usract"]	= $row["getr_usract"];
		$a_chofer["getr_fecact"]	= $row["getr_fecact"];
		return $a_chofer;
	}


	public function select($ChoferObj,$limit=''){
		global $usuario, $PDO;
		if ($ChoferObj->getr_id){
			$where .= " AND getr_id = :getr_id";
		}
		if ($ChoferObj->getr_nombre){
			$where .= " AND getr_nombre LIKE :getr_nombre";
		}
		if ($ChoferObj->getr_status){
			$where .= " AND getr_status = :getr_status";
		}
		if ($ChoferObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY getr_nombre";
		}
		$sql = "
			SELECT *
			FROM xx_guiaTransportista 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if ($ChoferObj->getr_id){
			$comando->bindParam(':getr_id', $ChoferObj->getr_id);
		}
		if ($ChoferObj->getr_nombre){
			$comando->bindParam(':getr_nombre', $ChoferObj->getr_nombre);
		}
		if ($ChoferObj->getr_status){
			$comando->bindParam(':getr_status', $ChoferObj->getr_status);
		}
		if ($ChoferObj->orderBy){
			$comando->bindParam(':orderBy', $ChoferObj->orderBy);
		}			
		$comando->execute();

		while($row = $comando->fetch()){
			$a_chofer["getr_id"]		= $row["getr_id"];
			$a_chofer["getr_docTipo"]	= $row["getr_docTipo"];
			$a_chofer["getr_ruc"]		= $row["getr_ruc"];
			$a_chofer["getr_nombre"]	= $row["getr_nombre"];
			$a_chofer["getr_status"]	= $row["getr_status"];
			$a_chofer["getr_usract"]	= $row["getr_usract"];
			$a_chofer["getr_fecact"]	= $row["getr_fecact"];
			$a_choferList[] = $a_chofer;
		}
		return $a_choferList;
	}


	public function update($ChoferObj){
		global $usuario, $PDO;
		if (isset($ChoferObj->getr_nombre)){
			$set .= ", getr_nombre = :getr_nombre";
		}
		if (isset($ChoferObj->getr_docTipo)){
			$set .= ", getr_docTipo = :getr_docTipo";
		}
		if (isset($ChoferObj->getr_ruc)){
			$set .= ", getr_ruc = :getr_ruc";
		}
		if (isset($ChoferObj->getr_status)){
			$set .= ", getr_status = :getr_status";
		}
		if ($set && $ChoferObj->getr_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE xx_guiaTransportista
				SET 
					$set
					,getr_usract = :getr_usract
				WHERE getr_id = :getr_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':getr_id', $ChoferObj->getr_id);
			if (isset($ChoferObj->getr_nombre)){
				$comando->bindParam(':getr_nombre', $ChoferObj->getr_nombre);
			}
			if (isset($ChoferObj->getr_docTipo)){
				$comando->bindParam(':getr_docTipo', $ChoferObj->getr_docTipo);
			}
			if (isset($ChoferObj->getr_ruc)){
				$comando->bindParam(':getr_ruc', $ChoferObj->getr_ruc);
			}
			if (isset($ChoferObj->getr_status)){
				$comando->bindParam(':getr_status', $ChoferObj->getr_status);
			}
			$comando->bindParam(':getr_usract', $usuario);
			$comando->execute();
			//print_r($comando->errorInfo());
			return $ChoferObj->getr_id;
		}
	}

	public function insert($ChoferObj){
		global $PDO;
		$sql = "
			INSERT INTO xx_guiaTransportista 
			(
			getr_nombre, 
			getr_docTipo,
			getr_ruc,
			getr_usract,
			getr_fecact
			) 
			VALUES 
			(
			:getr_nombre, 
			:getr_docTipo,
			:getr_ruc,
			:getr_usract,
			:getr_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$ChoferObj->getr_fecact = date("Y-m-d H:i:s");
		$comando->bindParam(':getr_nombre', $ChoferObj->getr_nombre);
		$comando->bindParam(':getr_docTipo', $ChoferObj->getr_docTipo);
		$comando->bindParam(':getr_ruc', $ChoferObj->getr_ruc);
		$comando->bindParam(':getr_usract', $ChoferObj->getr_usract);
		$comando->bindParam(':getr_fecact', $ChoferObj->getr_fecact);
		$comando->execute();	 
	//	print_r($comando->errorInfo());
	//exit;
		$query	 = "
			SELECT DISTINCT max(getr_id) as id 
			FROM `xx_guiaTransportista` 
			WHERE getr_usract = :getr_usract 
				AND getr_fecact = :getr_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':getr_usract', $ChoferObj->getr_usract);
		$comando->bindParam(':getr_fecact', $ChoferObj->getr_fecact);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>