<?php


class XxVehiculoModel{

	public function selectUniqueId($id){
		global $PDO;
		if (!$id){
			return FALSE;
		}
		$sql = "
			SELECT *
			FROM xx_guiaVehiculo
			WHERE gevh_id = :id
		";
		$comando = $PDO->prepare($sql);
		$comando->bindParam(':id', $id);
		$comando->execute();
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		$a_chofer["gevh_id"]			= $row["gevh_id"];
		$a_chofer["gevh_placa"]			= $row["gevh_placa"];
		$a_chofer["gevh_tarjeta"]		= $row["gevh_tarjeta"];
		$a_chofer["gevh_autorizacion"]	= $row["gevh_autorizacion"];
		$a_chofer["gevh_emisor"]		= $row["gevh_emisor"];
		$a_chofer["gevh_status"]		= $row["gevh_status"];
		$a_chofer["gevh_usract"]		= $row["gevh_usract"];
		$a_chofer["gevh_fecact"]		= $row["gevh_fecact"];
		return $a_chofer;
	}


	public function select($VehiculoObj,$limit=''){
		global $usuario, $PDO;
		if (($VehiculoObj->gevh_id)){
			$where .= " AND gevh_id = :gevh_id";
		}
		if (($VehiculoObj->gevh_placa)){
			$where .= " AND gevh_placa LIKE :gevh_placa";
		}
		if (($VehiculoObj->gevh_tarjeta)){
			$where .= " AND gevh_tarjeta LIKE :gevh_tarjeta";
		}
		if (($VehiculoObj->gevh_autorizacion)){
			$where .= " AND gevh_autorizacion = :gevh_autorizacion";
		}
		if (($VehiculoObj->gevh_emisor)){
			$where .= " AND gevh_emisor = :gevh_emisor";
		}
		if ($VehiculoObj->orderBy){
			$orderBy = " ORDER BY :orderBy";
		}else{
			$orderBy = " ORDER BY gevh_placa";
		}
		$sql = "
			SELECT *
			FROM xx_guiaVehiculo 
			WHERE 1 
			$where
			$orderBy
		";
		$comando = $PDO->prepare($sql);
		if (($VehiculoObj->gevh_id)){
			$comando->bindParam(':gevh_id', $VehiculoObj->gevh_id);
		}
		if (($VehiculoObj->gevh_placa)){
			$comando->bindParam(':gevh_placa', $VehiculoObj->gevh_placa);
		}
		if (($VehiculoObj->gevh_tarjeta)){
			$comando->bindParam(':gevh_tarjeta', $VehiculoObj->gevh_tarjeta);
		}
		if (($VehiculoObj->gevh_autorizacion)){
			$comando->bindParam(':gevh_autorizacion', $VehiculoObj->gevh_autorizacion);
		}
		if (($VehiculoObj->gevh_emisor)){
			$comando->bindParam(':gevh_emisor', $VehiculoObj->gevh_emisor);
		}
		if ($VehiculoObj->orderBy){
			$comando->bindParam(':orderBy', $VehiculoObj->orderBy);
		}			
		$comando->execute();
		while($row = $comando->fetch()){
			$a_chofer["gevh_id"]			= $row["gevh_id"];
			$a_chofer["gevh_placa"]			= $row["gevh_placa"];
			$a_chofer["gevh_tarjeta"]		= $row["gevh_tarjeta"];
			$a_chofer["gevh_autorizacion"]	= $row["gevh_autorizacion"];
			$a_chofer["gevh_emisor"]		= $row["gevh_emisor"];
			$a_chofer["gevh_status"]		= $row["gevh_status"];
			$a_chofer["gevh_usract"]		= $row["gevh_usract"];
			$a_chofer["gevh_fecact"]		= $row["gevh_fecact"];
			$a_choferList[] = $a_chofer;
		}
		/*
		print_r($VehiculoObj);
		print_r($a_choferList);
		exit($sql);
		*/
		return $a_choferList;
	}


	public function update($VehiculoObj){
		global $usuario, $PDO;
		if ($VehiculoObj->gevh_placa){
			$set .= ", gevh_placa = :gevh_placa";
		}
		if ($VehiculoObj->gevh_tarjeta){
			$set .= ", gevh_tarjeta = :gevh_tarjeta";
		}
		if ($VehiculoObj->gevh_autorizacion){
			$set .= ", gevh_autorizacion = :gevh_autorizacion";
		}
		if ($VehiculoObj->gevh_emisor){
			$set .= ", gevh_emisor = :gevh_emisor";
		}
		if ($VehiculoObj->gevh_status){
			$set .= ", gevh_status = :gevh_status";
		}
		if ($set && $VehiculoObj->gevh_id){
			$set = substr($set,1);
			$sql2 = "
				UPDATE xx_guiaVehiculo
				SET 
					$set
					,gevh_usract = :gevh_usract
				WHERE gevh_id = :gevh_id
				LIMIT 1";
			$comando = $PDO->prepare($sql2);
			$comando->bindParam(':gevh_id', $VehiculoObj->gevh_id);
			if ($VehiculoObj->gevh_placa){
				$comando->bindParam(':gevh_placa', $VehiculoObj->gevh_placa);
			}
			if ($VehiculoObj->gevh_tarjeta){
				$comando->bindParam(':gevh_tarjeta', $VehiculoObj->gevh_tarjeta);
			}
			if ($VehiculoObj->gevh_autorizacion){
				$comando->bindParam(':gevh_autorizacion', $VehiculoObj->gevh_autorizacion);
			}
			if ($VehiculoObj->gevh_emisor){
				$comando->bindParam(':gevh_emisor', $VehiculoObj->gevh_emisor);
			}
			if ($VehiculoObj->gevh_status){
				$comando->bindParam(':gevh_status', $VehiculoObj->gevh_status);
			}
			$comando->bindParam(':gevh_usract', $usuario);
			$comando->execute();
			return $VehiculoObj->gevh_id;
		}
	}

	public function insert($VehiculoObj){
		global $PDO;
		$sql = "
			INSERT INTO xx_guiaVehiculo 
			(
			gevh_placa,
			gevh_tarjeta,
			gevh_autorizacion, 
			gevh_emisor, 
			gevh_usract, 
			gevh_fecact
			) 
			VALUES 
			(
			:gevh_placa,
			:gevh_tarjeta,
			:gevh_autorizacion, 
			:gevh_emisor, 
			:gevh_usract, 
			:gevh_fecact
			);			
		";
		$comando = $PDO->prepare($sql);
		$fecreg = date("Y-m-d H:i:s");
		$comando->bindParam(':gevh_placa', $VehiculoObj->gevh_placa);
		$comando->bindParam(':gevh_tarjeta', $VehiculoObj->gevh_tarjeta);
		$comando->bindParam(':gevh_autorizacion', $VehiculoObj->gevh_autorizacion);
		$comando->bindParam(':gevh_emisor', $VehiculoObj->gevh_emisor);
		$comando->bindParam(':gevh_usract', $VehiculoObj->gevh_usract);
		$comando->bindParam(':gevh_fecact', $fecreg);
		$comando->execute();	 
		$query	 = "
			SELECT DISTINCT max(gevh_id) as id 
			FROM `xx_guiaVehiculo` 
			WHERE gevh_usract = :gevh_usract 
				AND gevh_fecact = :gevh_fecact ";
		$comando = $PDO->prepare($query);
		$comando->bindParam(':gevh_usract', $VehiculoObj->gevh_usract);
		$comando->bindParam(':gevh_fecact', $fecreg);
		$comando->execute();	 
		$resultado = $comando->fetchAll(PDO::FETCH_ASSOC);
		$row = $resultado[0];
		return $row["id"];
	}

}


?>